searchData={"items":[{"type":"module","title":"GoogleApi.Spanner.V1","doc":"API client metadata for GoogleApi.Spanner.V1.","ref":"GoogleApi.Spanner.V1.html"},{"type":"function","title":"GoogleApi.Spanner.V1.discovery_revision/0","doc":"","ref":"GoogleApi.Spanner.V1.html#discovery_revision/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Api.Projects","doc":"API calls for all endpoints tagged `Projects`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_config_operations_list/4","doc":"Lists the user-managed instance configuration long-running operations in the given project. An instance configuration operation has a name of the form `projects//instanceConfigs//operations/`. The long-running operation metadata field type `metadata.type_url` describes the type of the metadata. Operations returned include those that have completed/failed/canceled within the last 7 days, and pending operations. Operations returned are ordered by `operation.metadata.value.start_time` in descending order starting from the most recently started operation.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_config_operations_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_config_operations_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The project of the instance configuration operations. Values are of the form `projects/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - An expression that filters the list of returned operations. A filter expression consists of a field name, a comparison operator, and a value for filtering. The value must be a string, a number, or a boolean. The comparison operator must be one of: `<`, `>`, `<=`, `>=`, `!=`, `=`, or `:`. Colon `:` is the contains operator. Filter rules are not case sensitive. The following fields in the Operation are eligible for filtering: * `name` - The name of the long-running operation * `done` - False if the operation is in progress, else true. * `metadata.@type` - the type of metadata. For example, the type string for CreateInstanceConfigMetadata is `type.googleapis.com/google.spanner.admin.instance.v1.CreateInstanceConfigMetadata`. * `metadata.` - any field in metadata.value. `metadata.@type` must be specified first, if filtering on metadata fields. * `error` - Error associated with the long-running operation. * `response.@type` - the type of response. * `response.` - any field in response.value. You can combine multiple expressions by enclosing each expression in parentheses. By default, expressions are combined with AND logic. However, you can specify AND, OR, and NOT logic explicitly. Here are a few examples: * `done:true` - The operation is complete. * `(metadata.@type=` \\ `type.googleapis.com/google.spanner.admin.instance.v1.CreateInstanceConfigMetadata) AND` \\ `(metadata.instance_config.name:custom-config) AND` \\ `(metadata.progress.start_time < \\\"2021-03-28T14:50:00Z\\\") AND` \\ `(error:*)` - Return operations where: * The operation's metadata type is CreateInstanceConfigMetadata. * The instance configuration name contains \"custom-config\". * The operation started before 2021-03-28T14:50:00Z. * The operation resulted in an error.\n    *   `:pageSize` (*type:* `integer()`) - Number of operations to be returned in the response. If 0 or less, defaults to the server's maximum allowed page size.\n    *   `:pageToken` (*type:* `String.t`) - If non-empty, `page_token` should contain a next_page_token from a previous ListInstanceConfigOperationsResponse to the same `parent` and with the same `filter`.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_config_operations_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_config_operations_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListInstanceConfigOperationsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_config_operations_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_create/4","doc":"Creates an instance configuration and begins preparing it to be used. The returned long-running operation can be used to track the progress of preparing the new instance configuration. The instance configuration name is assigned by the caller. If the named instance configuration already exists, `CreateInstanceConfig` returns `ALREADY_EXISTS`. Immediately after the request returns: * The instance configuration is readable via the API, with all requested attributes. The instance configuration's reconciling field is set to true. Its state is `CREATING`. While the operation is pending: * Cancelling the operation renders the instance configuration immediately unreadable via the API. * Except for deleting the creating resource, all other attempts to modify the instance configuration are rejected. Upon completion of the returned operation: * Instances can be created using the instance configuration. * The instance configuration's reconciling field becomes false. Its state becomes `READY`. The returned long-running operation will have a name of the format `/operations/` and can be used to track creation of the instance configuration. The metadata field type is CreateInstanceConfigMetadata. The response field type is InstanceConfig, if successful. Authorization requires `spanner.instanceConfigs.create` permission on the resource parent.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_create/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_create/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The name of the project in which to create the instance configuration. Values are of the form `projects/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.CreateInstanceConfigRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_create/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_create/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_delete/4","doc":"Deletes the instance configuration. Deletion is only allowed when no instances are using the configuration. If any instances are using the configuration, returns `FAILED_PRECONDITION`. Only user-managed configurations can be deleted. Authorization requires `spanner.instanceConfigs.delete` permission on the resource name.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_delete/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_delete/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The name of the instance configuration to be deleted. Values are of the form `projects//instanceConfigs/`\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:etag` (*type:* `String.t`) - Used for optimistic concurrency control as a way to help prevent simultaneous deletes of an instance configuration from overwriting each other. If not empty, the API only deletes the instance configuration when the etag provided matches the current status of the requested instance configuration. Otherwise, deletes the instance configuration without checking the current status of the requested instance configuration.\n    *   `:validateOnly` (*type:* `boolean()`) - An option to validate, but not actually execute, a request, and provide the same response.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_delete/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_delete/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_get/4","doc":"Gets information about a particular instance configuration.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_get/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_get/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The name of the requested instance configuration. Values are of the form `projects//instanceConfigs/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_get/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.InstanceConfig{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_get/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_list/4","doc":"Lists the supported instance configurations for a given project. Returns both Google-managed configurations and user-managed configurations.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The name of the project for which a list of supported instance configurations is requested. Values are of the form `projects/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:pageSize` (*type:* `integer()`) - Number of instance configurations to be returned in the response. If 0 or less, defaults to the server's maximum allowed page size.\n    *   `:pageToken` (*type:* `String.t`) - If non-empty, `page_token` should contain a next_page_token from a previous ListInstanceConfigsResponse.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListInstanceConfigsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_operations_cancel/4","doc":"Starts asynchronous cancellation on a long-running operation. The server makes a best effort to cancel the operation, but success is not guaranteed. If the server doesn't support this method, it returns `google.rpc.Code.UNIMPLEMENTED`. Clients can use Operations.GetOperation or other methods to check whether the cancellation succeeded or whether the operation completed despite cancellation. On successful cancellation, the operation is not deleted; instead, it becomes an operation with an Operation.error value with a google.rpc.Status.code of 1, corresponding to `Code.CANCELLED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_operations_cancel/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_operations_cancel/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource to be cancelled.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_operations_cancel/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_operations_cancel/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_operations_cancel/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_operations_delete/4","doc":"Deletes a long-running operation. This method indicates that the client is no longer interested in the operation result. It does not cancel the operation. If the server doesn't support this method, it returns `google.rpc.Code.UNIMPLEMENTED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_operations_delete/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_operations_delete/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource to be deleted.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_operations_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_operations_delete/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_operations_delete/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_operations_get/4","doc":"Gets the latest state of a long-running operation. Clients can use this method to poll the operation result at intervals as recommended by the API service.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_operations_get/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_operations_get/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_operations_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_operations_get/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_operations_get/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_operations_list/4","doc":"Lists operations that match the specified filter in the request. If the server doesn't support this method, it returns `UNIMPLEMENTED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_operations_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_operations_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation's parent resource.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - The standard list filter.\n    *   `:pageSize` (*type:* `integer()`) - The standard list page size.\n    *   `:pageToken` (*type:* `String.t`) - The standard list page token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_operations_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_operations_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListOperationsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_operations_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_patch/4","doc":"Updates an instance configuration. The returned long-running operation can be used to track the progress of updating the instance. If the named instance configuration does not exist, returns `NOT_FOUND`. Only user-managed configurations can be updated. Immediately after the request returns: * The instance configuration's reconciling field is set to true. While the operation is pending: * Cancelling the operation sets its metadata's cancel_time. The operation is guaranteed to succeed at undoing all changes, after which point it terminates with a `CANCELLED` status. * All other attempts to modify the instance configuration are rejected. * Reading the instance configuration via the API continues to give the pre-request values. Upon completion of the returned operation: * Creating instances using the instance configuration uses the new values. * The new values of the instance configuration are readable via the API. * The instance configuration's reconciling field becomes false. The returned long-running operation will have a name of the format `/operations/` and can be used to track the instance configuration modification. The metadata field type is UpdateInstanceConfigMetadata. The response field type is InstanceConfig, if successful. Authorization requires `spanner.instanceConfigs.update` permission on the resource name.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_patch/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_patch/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - A unique identifier for the instance configuration. Values are of the form `projects//instanceConfigs/a-z*`. User instance configuration must start with `custom-`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.UpdateInstanceConfigRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_patch/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_patch/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_patch/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_ssd_caches_operations_cancel/4","doc":"Starts asynchronous cancellation on a long-running operation. The server makes a best effort to cancel the operation, but success is not guaranteed. If the server doesn't support this method, it returns `google.rpc.Code.UNIMPLEMENTED`. Clients can use Operations.GetOperation or other methods to check whether the cancellation succeeded or whether the operation completed despite cancellation. On successful cancellation, the operation is not deleted; instead, it becomes an operation with an Operation.error value with a google.rpc.Status.code of 1, corresponding to `Code.CANCELLED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_ssd_caches_operations_cancel/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_ssd_caches_operations_cancel/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource to be cancelled.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_ssd_caches_operations_cancel/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_ssd_caches_operations_cancel/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_ssd_caches_operations_cancel/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_ssd_caches_operations_delete/4","doc":"Deletes a long-running operation. This method indicates that the client is no longer interested in the operation result. It does not cancel the operation. If the server doesn't support this method, it returns `google.rpc.Code.UNIMPLEMENTED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_ssd_caches_operations_delete/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_ssd_caches_operations_delete/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource to be deleted.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_ssd_caches_operations_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_ssd_caches_operations_delete/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_ssd_caches_operations_delete/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_ssd_caches_operations_get/4","doc":"Gets the latest state of a long-running operation. Clients can use this method to poll the operation result at intervals as recommended by the API service.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_ssd_caches_operations_get/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_ssd_caches_operations_get/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_ssd_caches_operations_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_ssd_caches_operations_get/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_ssd_caches_operations_get/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_ssd_caches_operations_list/4","doc":"Lists operations that match the specified filter in the request. If the server doesn't support this method, it returns `UNIMPLEMENTED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_ssd_caches_operations_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_ssd_caches_operations_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation's parent resource.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - The standard list filter.\n    *   `:pageSize` (*type:* `integer()`) - The standard list page size.\n    *   `:pageToken` (*type:* `String.t`) - The standard list page token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_ssd_caches_operations_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instance_configs_ssd_caches_operations_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListOperationsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instance_configs_ssd_caches_operations_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backup_operations_list/4","doc":"Lists the backup long-running operations in the given instance. A backup operation has a name of the form `projects//instances//backups//operations/`. The long-running operation metadata field type `metadata.type_url` describes the type of the metadata. Operations returned include those that have completed/failed/canceled within the last 7 days, and pending operations. Operations returned are ordered by `operation.metadata.value.progress.start_time` in descending order starting from the most recently started operation.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backup_operations_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backup_operations_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The instance of the backup operations. Values are of the form `projects//instances/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - An expression that filters the list of returned backup operations. A filter expression consists of a field name, a comparison operator, and a value for filtering. The value must be a string, a number, or a boolean. The comparison operator must be one of: `<`, `>`, `<=`, `>=`, `!=`, `=`, or `:`. Colon `:` is the contains operator. Filter rules are not case sensitive. The following fields in the operation are eligible for filtering: * `name` - The name of the long-running operation * `done` - False if the operation is in progress, else true. * `metadata.@type` - the type of metadata. For example, the type string for CreateBackupMetadata is `type.googleapis.com/google.spanner.admin.database.v1.CreateBackupMetadata`. * `metadata.` - any field in metadata.value. `metadata.@type` must be specified first if filtering on metadata fields. * `error` - Error associated with the long-running operation. * `response.@type` - the type of response. * `response.` - any field in response.value. You can combine multiple expressions by enclosing each expression in parentheses. By default, expressions are combined with AND logic, but you can specify AND, OR, and NOT logic explicitly. Here are a few examples: * `done:true` - The operation is complete. * `(metadata.@type=type.googleapis.com/google.spanner.admin.database.v1.CreateBackupMetadata) AND` \\ `metadata.database:prod` - Returns operations where: * The operation's metadata type is CreateBackupMetadata. * The source database name of backup contains the string \"prod\". * `(metadata.@type=type.googleapis.com/google.spanner.admin.database.v1.CreateBackupMetadata) AND` \\ `(metadata.name:howl) AND` \\ `(metadata.progress.start_time < \\\"2018-03-28T14:50:00Z\\\") AND` \\ `(error:*)` - Returns operations where: * The operation's metadata type is CreateBackupMetadata. * The backup name contains the string \"howl\". * The operation started before 2018-03-28T14:50:00Z. * The operation resulted in an error. * `(metadata.@type=type.googleapis.com/google.spanner.admin.database.v1.CopyBackupMetadata) AND` \\ `(metadata.source_backup:test) AND` \\ `(metadata.progress.start_time < \\\"2022-01-18T14:50:00Z\\\") AND` \\ `(error:*)` - Returns operations where: * The operation's metadata type is CopyBackupMetadata. * The source backup name contains the string \"test\". * The operation started before 2022-01-18T14:50:00Z. * The operation resulted in an error. * `((metadata.@type=type.googleapis.com/google.spanner.admin.database.v1.CreateBackupMetadata) AND` \\ `(metadata.database:test_db)) OR` \\ `((metadata.@type=type.googleapis.com/google.spanner.admin.database.v1.CopyBackupMetadata) AND` \\ `(metadata.source_backup:test_bkp)) AND` \\ `(error:*)` - Returns operations where: * The operation's metadata matches either of criteria: * The operation's metadata type is CreateBackupMetadata AND the source database name of the backup contains the string \"test_db\" * The operation's metadata type is CopyBackupMetadata AND the source backup name contains the string \"test_bkp\" * The operation resulted in an error.\n    *   `:pageSize` (*type:* `integer()`) - Number of operations to be returned in the response. If 0 or less, defaults to the server's maximum allowed page size.\n    *   `:pageToken` (*type:* `String.t`) - If non-empty, `page_token` should contain a next_page_token from a previous ListBackupOperationsResponse to the same `parent` and with the same `filter`.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backup_operations_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backup_operations_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListBackupOperationsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backup_operations_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_copy/4","doc":"Starts copying a Cloud Spanner Backup. The returned backup long-running operation will have a name of the format `projects//instances//backups//operations/` and can be used to track copying of the backup. The operation is associated with the destination backup. The metadata field type is CopyBackupMetadata. The response field type is Backup, if successful. Cancelling the returned operation will stop the copying and delete the destination backup. Concurrent CopyBackup requests can run on the same source backup.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_copy/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_copy/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The name of the destination instance that will contain the backup copy. Values are of the form: `projects//instances/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.CopyBackupRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_copy/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_copy/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_copy/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_create/4","doc":"Starts creating a new Cloud Spanner Backup. The returned backup long-running operation will have a name of the format `projects//instances//backups//operations/` and can be used to track creation of the backup. The metadata field type is CreateBackupMetadata. The response field type is Backup, if successful. Cancelling the returned operation will stop the creation and delete the backup. There can be only one pending backup creation per database. Backup creation of different databases can run concurrently.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_create/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_create/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The name of the instance in which the backup will be created. This must be the same instance that contains the database the backup will be created from. The backup will be stored in the location(s) specified in the instance configuration of this instance. Values are of the form `projects//instances/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:backupId` (*type:* `String.t`) - Required. The id of the backup to be created. The `backup_id` appended to `parent` forms the full backup name of the form `projects//instances//backups/`.\n    *   `:\"encryptionConfig.encryptionType\"` (*type:* `String.t`) - Required. The encryption type of the backup.\n    *   `:\"encryptionConfig.kmsKeyName\"` (*type:* `String.t`) - Optional. The Cloud KMS key that will be used to protect the backup. This field should be set only when encryption_type is `CUSTOMER_MANAGED_ENCRYPTION`. Values are of the form `projects//locations//keyRings//cryptoKeys/`.\n    *   `:\"encryptionConfig.kmsKeyNames\"` (*type:* `list(String.t)`) - Optional. Specifies the KMS configuration for the one or more keys used to protect the backup. Values are of the form `projects//locations//keyRings//cryptoKeys/`. The keys referenced by kms_key_names must fully cover all regions of the backup's instance configuration. Some examples: * For single region instance configs, specify a single regional location KMS key. * For multi-regional instance configs of type GOOGLE_MANAGED, either specify a multi-regional location KMS key or multiple regional location KMS keys that cover all regions in the instance config. * For an instance config of type USER_MANAGED, please specify only regional location KMS keys to cover each region in the instance config. Multi-regional location KMS keys are not supported for USER_MANAGED instance configs.\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.Backup.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_create/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_create/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_delete/4","doc":"Deletes a pending or completed Backup.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_delete/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_delete/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. Name of the backup to delete. Values are of the form `projects//instances//backups/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_delete/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_delete/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_get/4","doc":"Gets metadata on a pending or completed Backup.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_get/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_get/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. Name of the backup. Values are of the form `projects//instances//backups/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_get/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Backup{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_get/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_get_iam_policy/4","doc":"Gets the access control policy for a database or backup resource. Returns an empty policy if a database or backup exists but does not have a policy set. Authorization requires `spanner.databases.getIamPolicy` permission on resource. For backups, authorization requires `spanner.backups.getIamPolicy` permission on resource.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_get_iam_policy/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_get_iam_policy/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `resource` (*type:* `String.t`) - REQUIRED: The Cloud Spanner resource for which the policy is being retrieved. The format is `projects//instances/` for instance resources and `projects//instances//databases/` for database resources.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.GetIamPolicyRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_get_iam_policy/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_get_iam_policy/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Policy{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_get_iam_policy/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_list/4","doc":"Lists completed and pending backups. Backups returned are ordered by `create_time` in descending order, starting from the most recent `create_time`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The instance to list backups from. Values are of the form `projects//instances/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - An expression that filters the list of returned backups. A filter expression consists of a field name, a comparison operator, and a value for filtering. The value must be a string, a number, or a boolean. The comparison operator must be one of: `<`, `>`, `<=`, `>=`, `!=`, `=`, or `:`. Colon `:` is the contains operator. Filter rules are not case sensitive. The following fields in the Backup are eligible for filtering: * `name` * `database` * `state` * `create_time` (and values are of the format YYYY-MM-DDTHH:MM:SSZ) * `expire_time` (and values are of the format YYYY-MM-DDTHH:MM:SSZ) * `version_time` (and values are of the format YYYY-MM-DDTHH:MM:SSZ) * `size_bytes` You can combine multiple expressions by enclosing each expression in parentheses. By default, expressions are combined with AND logic, but you can specify AND, OR, and NOT logic explicitly. Here are a few examples: * `name:Howl` - The backup's name contains the string \"howl\". * `database:prod` - The database's name contains the string \"prod\". * `state:CREATING` - The backup is pending creation. * `state:READY` - The backup is fully created and ready for use. * `(name:howl) AND (create_time < \\\"2018-03-28T14:50:00Z\\\")` - The backup name contains the string \"howl\" and `create_time` of the backup is before 2018-03-28T14:50:00Z. * `expire_time < \\\"2018-03-28T14:50:00Z\\\"` - The backup `expire_time` is before 2018-03-28T14:50:00Z. * `size_bytes > 10000000000` - The backup's size is greater than 10GB\n    *   `:pageSize` (*type:* `integer()`) - Number of backups to be returned in the response. If 0 or less, defaults to the server's maximum allowed page size.\n    *   `:pageToken` (*type:* `String.t`) - If non-empty, `page_token` should contain a next_page_token from a previous ListBackupsResponse to the same `parent` and with the same `filter`.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListBackupsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_operations_cancel/4","doc":"Starts asynchronous cancellation on a long-running operation. The server makes a best effort to cancel the operation, but success is not guaranteed. If the server doesn't support this method, it returns `google.rpc.Code.UNIMPLEMENTED`. Clients can use Operations.GetOperation or other methods to check whether the cancellation succeeded or whether the operation completed despite cancellation. On successful cancellation, the operation is not deleted; instead, it becomes an operation with an Operation.error value with a google.rpc.Status.code of 1, corresponding to `Code.CANCELLED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_operations_cancel/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_operations_cancel/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource to be cancelled.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_operations_cancel/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_operations_cancel/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_operations_cancel/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_operations_delete/4","doc":"Deletes a long-running operation. This method indicates that the client is no longer interested in the operation result. It does not cancel the operation. If the server doesn't support this method, it returns `google.rpc.Code.UNIMPLEMENTED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_operations_delete/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_operations_delete/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource to be deleted.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_operations_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_operations_delete/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_operations_delete/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_operations_get/4","doc":"Gets the latest state of a long-running operation. Clients can use this method to poll the operation result at intervals as recommended by the API service.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_operations_get/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_operations_get/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_operations_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_operations_get/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_operations_get/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_operations_list/4","doc":"Lists operations that match the specified filter in the request. If the server doesn't support this method, it returns `UNIMPLEMENTED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_operations_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_operations_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation's parent resource.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - The standard list filter.\n    *   `:pageSize` (*type:* `integer()`) - The standard list page size.\n    *   `:pageToken` (*type:* `String.t`) - The standard list page token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_operations_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_operations_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListOperationsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_operations_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_patch/4","doc":"Updates a pending or completed Backup.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_patch/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_patch/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Output only for the CreateBackup operation. Required for the UpdateBackup operation. A globally unique identifier for the backup which cannot be changed. Values are of the form `projects//instances//backups/a-z*[a-z0-9]` The final segment of the name must be between 2 and 60 characters in length. The backup is stored in the location(s) specified in the instance configuration of the instance containing the backup, identified by the prefix of the backup name of the form `projects//instances/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:updateMask` (*type:* `String.t`) - Required. A mask specifying which fields (e.g. `expire_time`) in the Backup resource should be updated. This mask is relative to the Backup resource, not to the request message. The field mask must always be specified; this prevents any future fields from being erased accidentally by clients that do not know about them.\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.Backup.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_patch/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_patch/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Backup{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_patch/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_set_iam_policy/4","doc":"Sets the access control policy on a database or backup resource. Replaces any existing policy. Authorization requires `spanner.databases.setIamPolicy` permission on resource. For backups, authorization requires `spanner.backups.setIamPolicy` permission on resource.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_set_iam_policy/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_set_iam_policy/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `resource` (*type:* `String.t`) - REQUIRED: The Cloud Spanner resource for which the policy is being set. The format is `projects//instances/` for instance resources and `projects//instances//databases/` for databases resources.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.SetIamPolicyRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_set_iam_policy/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_set_iam_policy/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Policy{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_set_iam_policy/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_test_iam_permissions/4","doc":"Returns permissions that the caller has on the specified database or backup resource. Attempting this RPC on a non-existent Cloud Spanner database will result in a NOT_FOUND error if the user has `spanner.databases.list` permission on the containing Cloud Spanner instance. Otherwise returns an empty set of permissions. Calling this method on a backup that does not exist will result in a NOT_FOUND error if the user has `spanner.backups.list` permission on the containing instance.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_test_iam_permissions/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_test_iam_permissions/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `resource` (*type:* `String.t`) - REQUIRED: The Cloud Spanner resource for which permissions are being tested. The format is `projects//instances/` for instance resources and `projects//instances//databases/` for database resources.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_test_iam_permissions/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_backups_test_iam_permissions/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_backups_test_iam_permissions/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_create/4","doc":"Creates an instance and begins preparing it to begin serving. The returned long-running operation can be used to track the progress of preparing the new instance. The instance name is assigned by the caller. If the named instance already exists, `CreateInstance` returns `ALREADY_EXISTS`. Immediately upon completion of this request: * The instance is readable via the API, with all requested attributes but no allocated resources. Its state is `CREATING`. Until completion of the returned operation: * Cancelling the operation renders the instance immediately unreadable via the API. * The instance can be deleted. * All other attempts to modify the instance are rejected. Upon completion of the returned operation: * Billing for all successfully-allocated resources begins (some types may have lower than the requested levels). * Databases can be created in the instance. * The instance's allocated resource levels are readable via the API. * The instance's state becomes `READY`. The returned long-running operation will have a name of the format `/operations/` and can be used to track creation of the instance. The metadata field type is CreateInstanceMetadata. The response field type is Instance, if successful.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_create/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_create/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The name of the project in which to create the instance. Values are of the form `projects/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.CreateInstanceRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_create/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_create/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_database_operations_list/4","doc":"Lists database longrunning-operations. A database operation has a name of the form `projects//instances//databases//operations/`. The long-running operation metadata field type `metadata.type_url` describes the type of the metadata. Operations returned include those that have completed/failed/canceled within the last 7 days, and pending operations.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_database_operations_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_database_operations_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The instance of the database operations. Values are of the form `projects//instances/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - An expression that filters the list of returned operations. A filter expression consists of a field name, a comparison operator, and a value for filtering. The value must be a string, a number, or a boolean. The comparison operator must be one of: `<`, `>`, `<=`, `>=`, `!=`, `=`, or `:`. Colon `:` is the contains operator. Filter rules are not case sensitive. The following fields in the Operation are eligible for filtering: * `name` - The name of the long-running operation * `done` - False if the operation is in progress, else true. * `metadata.@type` - the type of metadata. For example, the type string for RestoreDatabaseMetadata is `type.googleapis.com/google.spanner.admin.database.v1.RestoreDatabaseMetadata`. * `metadata.` - any field in metadata.value. `metadata.@type` must be specified first, if filtering on metadata fields. * `error` - Error associated with the long-running operation. * `response.@type` - the type of response. * `response.` - any field in response.value. You can combine multiple expressions by enclosing each expression in parentheses. By default, expressions are combined with AND logic. However, you can specify AND, OR, and NOT logic explicitly. Here are a few examples: * `done:true` - The operation is complete. * `(metadata.@type=type.googleapis.com/google.spanner.admin.database.v1.RestoreDatabaseMetadata) AND` \\ `(metadata.source_type:BACKUP) AND` \\ `(metadata.backup_info.backup:backup_howl) AND` \\ `(metadata.name:restored_howl) AND` \\ `(metadata.progress.start_time < \\\"2018-03-28T14:50:00Z\\\") AND` \\ `(error:*)` - Return operations where: * The operation's metadata type is RestoreDatabaseMetadata. * The database is restored from a backup. * The backup name contains \"backup_howl\". * The restored database's name contains \"restored_howl\". * The operation started before 2018-03-28T14:50:00Z. * The operation resulted in an error.\n    *   `:pageSize` (*type:* `integer()`) - Number of operations to be returned in the response. If 0 or less, defaults to the server's maximum allowed page size.\n    *   `:pageToken` (*type:* `String.t`) - If non-empty, `page_token` should contain a next_page_token from a previous ListDatabaseOperationsResponse to the same `parent` and with the same `filter`.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_database_operations_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_database_operations_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListDatabaseOperationsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_database_operations_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_create/4","doc":"Creates a new backup schedule.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_create/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_create/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The name of the database that this backup schedule applies to.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:backupScheduleId` (*type:* `String.t`) - Required. The Id to use for the backup schedule. The `backup_schedule_id` appended to `parent` forms the full backup schedule name of the form `projects//instances//databases//backupSchedules/`.\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.BackupSchedule.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_create/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.BackupSchedule{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_create/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_delete/4","doc":"Deletes a backup schedule.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_delete/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_delete/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The name of the schedule to delete. Values are of the form `projects//instances//databases//backupSchedules/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_delete/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_delete/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_get/4","doc":"Gets backup schedule for the input schedule name.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_get/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_get/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The name of the schedule to retrieve. Values are of the form `projects//instances//databases//backupSchedules/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_get/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.BackupSchedule{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_get/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_get_iam_policy/4","doc":"Gets the access control policy for a database or backup resource. Returns an empty policy if a database or backup exists but does not have a policy set. Authorization requires `spanner.databases.getIamPolicy` permission on resource. For backups, authorization requires `spanner.backups.getIamPolicy` permission on resource.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_get_iam_policy/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_get_iam_policy/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `resource` (*type:* `String.t`) - REQUIRED: The Cloud Spanner resource for which the policy is being retrieved. The format is `projects//instances/` for instance resources and `projects//instances//databases/` for database resources.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.GetIamPolicyRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_get_iam_policy/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_get_iam_policy/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Policy{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_get_iam_policy/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_list/4","doc":"Lists all the backup schedules for the database.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. Database is the parent resource whose backup schedules should be listed. Values are of the form projects//instances//databases/\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:pageSize` (*type:* `integer()`) - Optional. Number of backup schedules to be returned in the response. If 0 or less, defaults to the server's maximum allowed page size.\n    *   `:pageToken` (*type:* `String.t`) - Optional. If non-empty, `page_token` should contain a next_page_token from a previous ListBackupSchedulesResponse to the same `parent`.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListBackupSchedulesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_patch/4","doc":"Updates a backup schedule.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_patch/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_patch/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Identifier. Output only for the CreateBackupSchedule operation. Required for the UpdateBackupSchedule operation. A globally unique identifier for the backup schedule which cannot be changed. Values are of the form `projects//instances//databases//backupSchedules/a-z*[a-z0-9]` The final segment of the name must be between 2 and 60 characters in length.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:updateMask` (*type:* `String.t`) - Required. A mask specifying which fields in the BackupSchedule resource should be updated. This mask is relative to the BackupSchedule resource, not to the request message. The field mask must always be specified; this prevents any future fields from being erased accidentally.\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.BackupSchedule.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_patch/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_patch/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.BackupSchedule{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_patch/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_set_iam_policy/4","doc":"Sets the access control policy on a database or backup resource. Replaces any existing policy. Authorization requires `spanner.databases.setIamPolicy` permission on resource. For backups, authorization requires `spanner.backups.setIamPolicy` permission on resource.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_set_iam_policy/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_set_iam_policy/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `resource` (*type:* `String.t`) - REQUIRED: The Cloud Spanner resource for which the policy is being set. The format is `projects//instances/` for instance resources and `projects//instances//databases/` for databases resources.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.SetIamPolicyRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_set_iam_policy/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_set_iam_policy/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Policy{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_set_iam_policy/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_test_iam_permissions/4","doc":"Returns permissions that the caller has on the specified database or backup resource. Attempting this RPC on a non-existent Cloud Spanner database will result in a NOT_FOUND error if the user has `spanner.databases.list` permission on the containing Cloud Spanner instance. Otherwise returns an empty set of permissions. Calling this method on a backup that does not exist will result in a NOT_FOUND error if the user has `spanner.backups.list` permission on the containing instance.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_test_iam_permissions/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_test_iam_permissions/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `resource` (*type:* `String.t`) - REQUIRED: The Cloud Spanner resource for which permissions are being tested. The format is `projects//instances/` for instance resources and `projects//instances//databases/` for database resources.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_test_iam_permissions/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_backup_schedules_test_iam_permissions/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_backup_schedules_test_iam_permissions/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_changequorum/4","doc":"`ChangeQuorum` is strictly restricted to databases that use dual-region instance configurations. Initiates a background operation to change the quorum of a database from dual-region mode to single-region mode or vice versa. The returned long-running operation has a name of the format `projects//instances//databases//operations/` and can be used to track execution of the `ChangeQuorum`. The metadata field type is ChangeQuorumMetadata. Authorization requires `spanner.databases.changequorum` permission on the resource database.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_changequorum/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_changequorum/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. Name of the database in which to apply `ChangeQuorum`. Values are of the form `projects//instances//databases/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.ChangeQuorumRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_changequorum/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_changequorum/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_changequorum/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_create/4","doc":"Creates a new Spanner database and starts to prepare it for serving. The returned long-running operation will have a name of the format `/operations/` and can be used to track preparation of the database. The metadata field type is CreateDatabaseMetadata. The response field type is Database, if successful.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_create/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_create/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The name of the instance that will serve the new database. Values are of the form `projects//instances/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.CreateDatabaseRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_create/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_create/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_database_roles_list/4","doc":"Lists Cloud Spanner database roles.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_database_roles_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_database_roles_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The database whose roles should be listed. Values are of the form `projects//instances//databases/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:pageSize` (*type:* `integer()`) - Number of database roles to be returned in the response. If 0 or less, defaults to the server's maximum allowed page size.\n    *   `:pageToken` (*type:* `String.t`) - If non-empty, `page_token` should contain a next_page_token from a previous ListDatabaseRolesResponse.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_database_roles_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_database_roles_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListDatabaseRolesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_database_roles_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_database_roles_test_iam_permissions/4","doc":"Returns permissions that the caller has on the specified database or backup resource. Attempting this RPC on a non-existent Cloud Spanner database will result in a NOT_FOUND error if the user has `spanner.databases.list` permission on the containing Cloud Spanner instance. Otherwise returns an empty set of permissions. Calling this method on a backup that does not exist will result in a NOT_FOUND error if the user has `spanner.backups.list` permission on the containing instance.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_database_roles_test_iam_permissions/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_database_roles_test_iam_permissions/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `resource` (*type:* `String.t`) - REQUIRED: The Cloud Spanner resource for which permissions are being tested. The format is `projects//instances/` for instance resources and `projects//instances//databases/` for database resources.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_database_roles_test_iam_permissions/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_database_roles_test_iam_permissions/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_database_roles_test_iam_permissions/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_drop_database/4","doc":"Drops (aka deletes) a Cloud Spanner database. Completed backups for the database will be retained according to their `expire_time`. Note: Cloud Spanner might continue to accept requests for a few seconds after the database has been deleted.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_drop_database/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_drop_database/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `database` (*type:* `String.t`) - Required. The database to be dropped.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_drop_database/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_drop_database/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_drop_database/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_get/4","doc":"Gets the state of a Cloud Spanner database.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_get/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_get/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The name of the requested database. Values are of the form `projects//instances//databases/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_get/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Database{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_get/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_get_ddl/4","doc":"Returns the schema of a Cloud Spanner database as a list of formatted DDL statements. This method does not show pending schema updates, those may be queried using the Operations API.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_get_ddl/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_get_ddl/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `database` (*type:* `String.t`) - Required. The database whose schema we wish to get. Values are of the form `projects//instances//databases/`\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_get_ddl/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_get_ddl/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.GetDatabaseDdlResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_get_ddl/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_get_iam_policy/4","doc":"Gets the access control policy for a database or backup resource. Returns an empty policy if a database or backup exists but does not have a policy set. Authorization requires `spanner.databases.getIamPolicy` permission on resource. For backups, authorization requires `spanner.backups.getIamPolicy` permission on resource.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_get_iam_policy/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_get_iam_policy/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `resource` (*type:* `String.t`) - REQUIRED: The Cloud Spanner resource for which the policy is being retrieved. The format is `projects//instances/` for instance resources and `projects//instances//databases/` for database resources.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.GetIamPolicyRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_get_iam_policy/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_get_iam_policy/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Policy{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_get_iam_policy/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_get_scans/4","doc":"Request a specific scan with Database-specific data for Cloud Key Visualizer.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_get_scans/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_get_scans/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The unique name of the scan containing the requested information, specific to the Database service implementing this interface.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:endTime` (*type:* `DateTime.t`) - The upper bound for the time range to retrieve Scan data for.\n    *   `:startTime` (*type:* `DateTime.t`) - These fields restrict the Database-specific information returned in the `Scan.data` field. If a `View` is provided that does not include the `Scan.data` field, these are ignored. This range of time must be entirely contained within the defined time range of the targeted scan. The lower bound for the time range to retrieve Scan data for.\n    *   `:view` (*type:* `String.t`) - Specifies which parts of the Scan should be returned in the response. Note, if left unspecified, the FULL view is assumed.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_get_scans/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_get_scans/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Scan{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_get_scans/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_list/4","doc":"Lists Cloud Spanner databases.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The instance whose databases should be listed. Values are of the form `projects//instances/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:pageSize` (*type:* `integer()`) - Number of databases to be returned in the response. If 0 or less, defaults to the server's maximum allowed page size.\n    *   `:pageToken` (*type:* `String.t`) - If non-empty, `page_token` should contain a next_page_token from a previous ListDatabasesResponse.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListDatabasesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_operations_cancel/4","doc":"Starts asynchronous cancellation on a long-running operation. The server makes a best effort to cancel the operation, but success is not guaranteed. If the server doesn't support this method, it returns `google.rpc.Code.UNIMPLEMENTED`. Clients can use Operations.GetOperation or other methods to check whether the cancellation succeeded or whether the operation completed despite cancellation. On successful cancellation, the operation is not deleted; instead, it becomes an operation with an Operation.error value with a google.rpc.Status.code of 1, corresponding to `Code.CANCELLED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_operations_cancel/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_operations_cancel/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource to be cancelled.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_operations_cancel/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_operations_cancel/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_operations_cancel/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_operations_delete/4","doc":"Deletes a long-running operation. This method indicates that the client is no longer interested in the operation result. It does not cancel the operation. If the server doesn't support this method, it returns `google.rpc.Code.UNIMPLEMENTED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_operations_delete/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_operations_delete/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource to be deleted.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_operations_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_operations_delete/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_operations_delete/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_operations_get/4","doc":"Gets the latest state of a long-running operation. Clients can use this method to poll the operation result at intervals as recommended by the API service.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_operations_get/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_operations_get/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_operations_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_operations_get/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_operations_get/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_operations_list/4","doc":"Lists operations that match the specified filter in the request. If the server doesn't support this method, it returns `UNIMPLEMENTED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_operations_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_operations_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation's parent resource.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - The standard list filter.\n    *   `:pageSize` (*type:* `integer()`) - The standard list page size.\n    *   `:pageToken` (*type:* `String.t`) - The standard list page token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_operations_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_operations_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListOperationsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_operations_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_patch/4","doc":"Updates a Cloud Spanner database. The returned long-running operation can be used to track the progress of updating the database. If the named database does not exist, returns `NOT_FOUND`. While the operation is pending: * The database's reconciling field is set to true. * Cancelling the operation is best-effort. If the cancellation succeeds, the operation metadata's cancel_time is set, the updates are reverted, and the operation terminates with a `CANCELLED` status. * New UpdateDatabase requests will return a `FAILED_PRECONDITION` error until the pending operation is done (returns successfully or with error). * Reading the database via the API continues to give the pre-request values. Upon completion of the returned operation: * The new values are in effect and readable via the API. * The database's reconciling field becomes false. The returned long-running operation will have a name of the format `projects//instances//databases//operations/` and can be used to track the database modification. The metadata field type is UpdateDatabaseMetadata. The response field type is Database, if successful.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_patch/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_patch/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The name of the database. Values are of the form `projects//instances//databases/`, where `` is as specified in the `CREATE DATABASE` statement. This name can be passed to other API methods to identify the database.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:updateMask` (*type:* `String.t`) - Required. The list of fields to update. Currently, only `enable_drop_protection` field can be updated.\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.Database.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_patch/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_patch/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_patch/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_restore/4","doc":"Create a new database by restoring from a completed backup. The new database must be in the same project and in an instance with the same instance configuration as the instance containing the backup. The returned database long-running operation has a name of the format `projects//instances//databases//operations/`, and can be used to track the progress of the operation, and to cancel it. The metadata field type is RestoreDatabaseMetadata. The response type is Database, if successful. Cancelling the returned operation will stop the restore and delete the database. There can be only one database being restored into an instance at a time. Once the restore operation completes, a new restore operation can be initiated, without waiting for the optimize operation associated with the first restore to complete.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_restore/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_restore/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The name of the instance in which to create the restored database. This instance must be in the same project and have the same instance configuration as the instance containing the source backup. Values are of the form `projects//instances/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.RestoreDatabaseRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_restore/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_restore/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_restore/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_batch_create/4","doc":"Creates multiple new sessions. This API can be used to initialize a session cache on the clients. See https://goo.gl/TgSFN2 for best practices on session cache management.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_batch_create/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_batch_create/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `database` (*type:* `String.t`) - Required. The database in which the new sessions are created.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.BatchCreateSessionsRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_batch_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_batch_create/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.BatchCreateSessionsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_batch_create/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_batch_write/4","doc":"Batches the supplied mutation groups in a collection of efficient transactions. All mutations in a group are committed atomically. However, mutations across groups can be committed non-atomically in an unspecified order and thus, they must be independent of each other. Partial failure is possible, i.e., some groups may have been committed successfully, while some may have failed. The results of individual batches are streamed into the response as the batches are applied. BatchWrite requests are not replay protected, meaning that each mutation group may be applied more than once. Replays of non-idempotent mutations may have undesirable effects. For example, replays of an insert mutation may produce an already exists error or if you use generated or commit timestamp-based keys, it may result in additional rows being added to the mutation's table. We recommend structuring your mutation groups to be idempotent to avoid this issue.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_batch_write/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_batch_write/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `session` (*type:* `String.t`) - Required. The session in which the batch request is to be run.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.BatchWriteRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_batch_write/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_batch_write/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.BatchWriteResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_batch_write/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_begin_transaction/4","doc":"Begins a new transaction. This step can often be skipped: Read, ExecuteSql and Commit can begin a new transaction as a side-effect.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_begin_transaction/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_begin_transaction/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `session` (*type:* `String.t`) - Required. The session in which the transaction runs.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.BeginTransactionRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_begin_transaction/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_begin_transaction/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Transaction{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_begin_transaction/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_commit/4","doc":"Commits a transaction. The request includes the mutations to be applied to rows in the database. `Commit` might return an `ABORTED` error. This can occur at any time; commonly, the cause is conflicts with concurrent transactions. However, it can also happen for a variety of other reasons. If `Commit` returns `ABORTED`, the caller should re-attempt the transaction from the beginning, re-using the same session. On very rare occasions, `Commit` might return `UNKNOWN`. This can happen, for example, if the client job experiences a 1+ hour networking failure. At that point, Cloud Spanner has lost track of the transaction outcome and we recommend that you perform another read from the database to see the state of things as they are now.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_commit/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_commit/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `session` (*type:* `String.t`) - Required. The session in which the transaction to be committed is running.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.CommitRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_commit/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_commit/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.CommitResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_commit/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_create/4","doc":"Creates a new session. A session can be used to perform transactions that read and/or modify data in a Cloud Spanner database. Sessions are meant to be reused for many consecutive transactions. Sessions can only execute one transaction at a time. To execute multiple concurrent read-write/write-only transactions, create multiple sessions. Note that standalone reads and queries use a transaction internally, and count toward the one transaction limit. Active sessions use additional server resources, so it is a good idea to delete idle and unneeded sessions. Aside from explicit deletes, Cloud Spanner may delete sessions for which no operations are sent for more than an hour. If a session is deleted, requests to it return `NOT_FOUND`. Idle sessions can be kept alive by sending a trivial SQL query periodically, e.g., `\"SELECT 1\"`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_create/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_create/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `database` (*type:* `String.t`) - Required. The database in which the new session is created.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.CreateSessionRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_create/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Session{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_create/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_delete/4","doc":"Ends a session, releasing server resources associated with it. This will asynchronously trigger cancellation of any operations that are running with this session.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_delete/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_delete/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The name of the session to delete.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_delete/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_delete/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_execute_batch_dml/4","doc":"Executes a batch of SQL DML statements. This method allows many statements to be run with lower latency than submitting them sequentially with ExecuteSql. Statements are executed in sequential order. A request can succeed even if a statement fails. The ExecuteBatchDmlResponse.status field in the response provides information about the statement that failed. Clients must inspect this field to determine whether an error occurred. Execution stops after the first failed statement; the remaining statements are not executed.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_execute_batch_dml/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_execute_batch_dml/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `session` (*type:* `String.t`) - Required. The session in which the DML statements should be performed.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.ExecuteBatchDmlRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_execute_batch_dml/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_execute_batch_dml/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ExecuteBatchDmlResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_execute_batch_dml/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_execute_sql/4","doc":"Executes an SQL statement, returning all results in a single reply. This method cannot be used to return a result set larger than 10 MiB; if the query yields more data than that, the query fails with a `FAILED_PRECONDITION` error. Operations inside read-write transactions might return `ABORTED`. If this occurs, the application should restart the transaction from the beginning. See Transaction for more details. Larger result sets can be fetched in streaming fashion by calling ExecuteStreamingSql instead.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_execute_sql/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_execute_sql/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `session` (*type:* `String.t`) - Required. The session in which the SQL query should be performed.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.ExecuteSqlRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_execute_sql/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_execute_sql/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ResultSet{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_execute_sql/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_execute_streaming_sql/4","doc":"Like ExecuteSql, except returns the result set as a stream. Unlike ExecuteSql, there is no limit on the size of the returned result set. However, no individual row in the result set can exceed 100 MiB, and no column value can exceed 10 MiB.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_execute_streaming_sql/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_execute_streaming_sql/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `session` (*type:* `String.t`) - Required. The session in which the SQL query should be performed.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.ExecuteSqlRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_execute_streaming_sql/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_execute_streaming_sql/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.PartialResultSet{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_execute_streaming_sql/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_get/4","doc":"Gets a session. Returns `NOT_FOUND` if the session does not exist. This is mainly useful for determining whether a session is still alive.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_get/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_get/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The name of the session to retrieve.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_get/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Session{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_get/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_list/4","doc":"Lists all sessions in a given database.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `database` (*type:* `String.t`) - Required. The database in which to list sessions.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - An expression for filtering the results of the request. Filter rules are case insensitive. The fields eligible for filtering are: * `labels.key` where key is the name of a label Some examples of using filters are: * `labels.env:*` --> The session has the label \"env\". * `labels.env:dev` --> The session has the label \"env\" and the value of the label contains the string \"dev\".\n    *   `:pageSize` (*type:* `integer()`) - Number of sessions to be returned in the response. If 0 or less, defaults to the server's maximum allowed page size.\n    *   `:pageToken` (*type:* `String.t`) - If non-empty, `page_token` should contain a next_page_token from a previous ListSessionsResponse.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListSessionsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_partition_query/4","doc":"Creates a set of partition tokens that can be used to execute a query operation in parallel. Each of the returned partition tokens can be used by ExecuteStreamingSql to specify a subset of the query result to read. The same session and read-only transaction must be used by the PartitionQueryRequest used to create the partition tokens and the ExecuteSqlRequests that use the partition tokens. Partition tokens become invalid when the session used to create them is deleted, is idle for too long, begins a new transaction, or becomes too old. When any of these happen, it is not possible to resume the query, and the whole operation must be restarted from the beginning.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_partition_query/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_partition_query/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `session` (*type:* `String.t`) - Required. The session used to create the partitions.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.PartitionQueryRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_partition_query/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_partition_query/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.PartitionResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_partition_query/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_partition_read/4","doc":"Creates a set of partition tokens that can be used to execute a read operation in parallel. Each of the returned partition tokens can be used by StreamingRead to specify a subset of the read result to read. The same session and read-only transaction must be used by the PartitionReadRequest used to create the partition tokens and the ReadRequests that use the partition tokens. There are no ordering guarantees on rows returned among the returned partition tokens, or even within each individual StreamingRead call issued with a partition_token. Partition tokens become invalid when the session used to create them is deleted, is idle for too long, begins a new transaction, or becomes too old. When any of these happen, it is not possible to resume the read, and the whole operation must be restarted from the beginning.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_partition_read/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_partition_read/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `session` (*type:* `String.t`) - Required. The session used to create the partitions.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.PartitionReadRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_partition_read/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_partition_read/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.PartitionResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_partition_read/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_read/4","doc":"Reads rows from the database using key lookups and scans, as a simple key/value style alternative to ExecuteSql. This method cannot be used to return a result set larger than 10 MiB; if the read matches more data than that, the read fails with a `FAILED_PRECONDITION` error. Reads inside read-write transactions might return `ABORTED`. If this occurs, the application should restart the transaction from the beginning. See Transaction for more details. Larger result sets can be yielded in streaming fashion by calling StreamingRead instead.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_read/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_read/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `session` (*type:* `String.t`) - Required. The session in which the read should be performed.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.ReadRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_read/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_read/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ResultSet{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_read/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_rollback/4","doc":"Rolls back a transaction, releasing any locks it holds. It is a good idea to call this for any transaction that includes one or more Read or ExecuteSql requests and ultimately decides not to commit. `Rollback` returns `OK` if it successfully aborts the transaction, the transaction was already aborted, or the transaction is not found. `Rollback` never returns `ABORTED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_rollback/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_rollback/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `session` (*type:* `String.t`) - Required. The session in which the transaction to roll back is running.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.RollbackRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_rollback/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_rollback/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_rollback/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_streaming_read/4","doc":"Like Read, except returns the result set as a stream. Unlike Read, there is no limit on the size of the returned result set. However, no individual row in the result set can exceed 100 MiB, and no column value can exceed 10 MiB.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_streaming_read/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_streaming_read/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `session` (*type:* `String.t`) - Required. The session in which the read should be performed.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.ReadRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_streaming_read/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_sessions_streaming_read/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.PartialResultSet{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_sessions_streaming_read/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_set_iam_policy/4","doc":"Sets the access control policy on a database or backup resource. Replaces any existing policy. Authorization requires `spanner.databases.setIamPolicy` permission on resource. For backups, authorization requires `spanner.backups.setIamPolicy` permission on resource.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_set_iam_policy/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_set_iam_policy/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `resource` (*type:* `String.t`) - REQUIRED: The Cloud Spanner resource for which the policy is being set. The format is `projects//instances/` for instance resources and `projects//instances//databases/` for databases resources.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.SetIamPolicyRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_set_iam_policy/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_set_iam_policy/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Policy{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_set_iam_policy/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_test_iam_permissions/4","doc":"Returns permissions that the caller has on the specified database or backup resource. Attempting this RPC on a non-existent Cloud Spanner database will result in a NOT_FOUND error if the user has `spanner.databases.list` permission on the containing Cloud Spanner instance. Otherwise returns an empty set of permissions. Calling this method on a backup that does not exist will result in a NOT_FOUND error if the user has `spanner.backups.list` permission on the containing instance.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_test_iam_permissions/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_test_iam_permissions/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `resource` (*type:* `String.t`) - REQUIRED: The Cloud Spanner resource for which permissions are being tested. The format is `projects//instances/` for instance resources and `projects//instances//databases/` for database resources.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_test_iam_permissions/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_test_iam_permissions/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_test_iam_permissions/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_update_ddl/4","doc":"Updates the schema of a Cloud Spanner database by creating/altering/dropping tables, columns, indexes, etc. The returned long-running operation will have a name of the format `/operations/` and can be used to track execution of the schema change(s). The metadata field type is UpdateDatabaseDdlMetadata. The operation has no response.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_update_ddl/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_update_ddl/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `database` (*type:* `String.t`) - Required. The database to update.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_update_ddl/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_databases_update_ddl/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_databases_update_ddl/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_delete/4","doc":"Deletes an instance. Immediately upon completion of the request: * Billing ceases for all of the instance's reserved resources. Soon afterward: * The instance and *all of its databases* immediately and irrevocably disappear from the API. All data in the databases is permanently deleted.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_delete/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_delete/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The name of the instance to be deleted. Values are of the form `projects//instances/`\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_delete/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_delete/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_get/4","doc":"Gets information about a particular instance.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_get/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_get/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The name of the requested instance. Values are of the form `projects//instances/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:fieldMask` (*type:* `String.t`) - If field_mask is present, specifies the subset of Instance fields that should be returned. If absent, all Instance fields are returned.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_get/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Instance{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_get/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_get_iam_policy/4","doc":"Gets the access control policy for an instance resource. Returns an empty policy if an instance exists but does not have a policy set. Authorization requires `spanner.instances.getIamPolicy` on resource.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_get_iam_policy/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_get_iam_policy/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `resource` (*type:* `String.t`) - REQUIRED: The Cloud Spanner resource for which the policy is being retrieved. The format is `projects//instances/` for instance resources and `projects//instances//databases/` for database resources.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.GetIamPolicyRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_get_iam_policy/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_get_iam_policy/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Policy{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_get_iam_policy/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partition_operations_list/4","doc":"Lists instance partition long-running operations in the given instance. An instance partition operation has a name of the form `projects//instances//instancePartitions//operations/`. The long-running operation metadata field type `metadata.type_url` describes the type of the metadata. Operations returned include those that have completed/failed/canceled within the last 7 days, and pending operations. Operations returned are ordered by `operation.metadata.value.start_time` in descending order starting from the most recently started operation. Authorization requires `spanner.instancePartitionOperations.list` permission on the resource parent.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partition_operations_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partition_operations_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The parent instance of the instance partition operations. Values are of the form `projects//instances/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - Optional. An expression that filters the list of returned operations. A filter expression consists of a field name, a comparison operator, and a value for filtering. The value must be a string, a number, or a boolean. The comparison operator must be one of: `<`, `>`, `<=`, `>=`, `!=`, `=`, or `:`. Colon `:` is the contains operator. Filter rules are not case sensitive. The following fields in the Operation are eligible for filtering: * `name` - The name of the long-running operation * `done` - False if the operation is in progress, else true. * `metadata.@type` - the type of metadata. For example, the type string for CreateInstancePartitionMetadata is `type.googleapis.com/google.spanner.admin.instance.v1.CreateInstancePartitionMetadata`. * `metadata.` - any field in metadata.value. `metadata.@type` must be specified first, if filtering on metadata fields. * `error` - Error associated with the long-running operation. * `response.@type` - the type of response. * `response.` - any field in response.value. You can combine multiple expressions by enclosing each expression in parentheses. By default, expressions are combined with AND logic. However, you can specify AND, OR, and NOT logic explicitly. Here are a few examples: * `done:true` - The operation is complete. * `(metadata.@type=` \\ `type.googleapis.com/google.spanner.admin.instance.v1.CreateInstancePartitionMetadata) AND` \\ `(metadata.instance_partition.name:custom-instance-partition) AND` \\ `(metadata.start_time < \\\"2021-03-28T14:50:00Z\\\") AND` \\ `(error:*)` - Return operations where: * The operation's metadata type is CreateInstancePartitionMetadata. * The instance partition name contains \"custom-instance-partition\". * The operation started before 2021-03-28T14:50:00Z. * The operation resulted in an error.\n    *   `:instancePartitionDeadline` (*type:* `DateTime.t`) - Optional. Deadline used while retrieving metadata for instance partition operations. Instance partitions whose operation metadata cannot be retrieved within this deadline will be added to unreachable in ListInstancePartitionOperationsResponse.\n    *   `:pageSize` (*type:* `integer()`) - Optional. Number of operations to be returned in the response. If 0 or less, defaults to the server's maximum allowed page size.\n    *   `:pageToken` (*type:* `String.t`) - Optional. If non-empty, `page_token` should contain a next_page_token from a previous ListInstancePartitionOperationsResponse to the same `parent` and with the same `filter`.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partition_operations_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partition_operations_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListInstancePartitionOperationsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partition_operations_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_create/4","doc":"Creates an instance partition and begins preparing it to be used. The returned long-running operation can be used to track the progress of preparing the new instance partition. The instance partition name is assigned by the caller. If the named instance partition already exists, `CreateInstancePartition` returns `ALREADY_EXISTS`. Immediately upon completion of this request: * The instance partition is readable via the API, with all requested attributes but no allocated resources. Its state is `CREATING`. Until completion of the returned operation: * Cancelling the operation renders the instance partition immediately unreadable via the API. * The instance partition can be deleted. * All other attempts to modify the instance partition are rejected. Upon completion of the returned operation: * Billing for all successfully-allocated resources begins (some types may have lower than the requested levels). * Databases can start using this instance partition. * The instance partition's allocated resource levels are readable via the API. * The instance partition's state becomes `READY`. The returned long-running operation will have a name of the format `/operations/` and can be used to track creation of the instance partition. The metadata field type is CreateInstancePartitionMetadata. The response field type is InstancePartition, if successful.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_create/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_create/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The name of the instance in which to create the instance partition. Values are of the form `projects//instances/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.CreateInstancePartitionRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_create/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_create/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_delete/4","doc":"Deletes an existing instance partition. Requires that the instance partition is not used by any database or backup and is not the default instance partition of an instance. Authorization requires `spanner.instancePartitions.delete` permission on the resource name.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_delete/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_delete/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The name of the instance partition to be deleted. Values are of the form `projects/{project}/instances/{instance}/instancePartitions/{instance_partition}`\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:etag` (*type:* `String.t`) - Optional. If not empty, the API only deletes the instance partition when the etag provided matches the current status of the requested instance partition. Otherwise, deletes the instance partition without checking the current status of the requested instance partition.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_delete/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_delete/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_get/4","doc":"Gets information about a particular instance partition.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_get/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_get/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The name of the requested instance partition. Values are of the form `projects/{project}/instances/{instance}/instancePartitions/{instance_partition}`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_get/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.InstancePartition{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_get/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_list/4","doc":"Lists all instance partitions for the given instance.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The instance whose instance partitions should be listed. Values are of the form `projects//instances/`. Use `{instance} = '-'` to list instance partitions for all Instances in a project, e.g., `projects/myproject/instances/-`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:instancePartitionDeadline` (*type:* `DateTime.t`) - Optional. Deadline used while retrieving metadata for instance partitions. Instance partitions whose metadata cannot be retrieved within this deadline will be added to unreachable in ListInstancePartitionsResponse.\n    *   `:pageSize` (*type:* `integer()`) - Number of instance partitions to be returned in the response. If 0 or less, defaults to the server's maximum allowed page size.\n    *   `:pageToken` (*type:* `String.t`) - If non-empty, `page_token` should contain a next_page_token from a previous ListInstancePartitionsResponse.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListInstancePartitionsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_operations_cancel/4","doc":"Starts asynchronous cancellation on a long-running operation. The server makes a best effort to cancel the operation, but success is not guaranteed. If the server doesn't support this method, it returns `google.rpc.Code.UNIMPLEMENTED`. Clients can use Operations.GetOperation or other methods to check whether the cancellation succeeded or whether the operation completed despite cancellation. On successful cancellation, the operation is not deleted; instead, it becomes an operation with an Operation.error value with a google.rpc.Status.code of 1, corresponding to `Code.CANCELLED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_operations_cancel/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_operations_cancel/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource to be cancelled.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_operations_cancel/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_operations_cancel/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_operations_cancel/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_operations_delete/4","doc":"Deletes a long-running operation. This method indicates that the client is no longer interested in the operation result. It does not cancel the operation. If the server doesn't support this method, it returns `google.rpc.Code.UNIMPLEMENTED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_operations_delete/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_operations_delete/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource to be deleted.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_operations_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_operations_delete/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_operations_delete/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_operations_get/4","doc":"Gets the latest state of a long-running operation. Clients can use this method to poll the operation result at intervals as recommended by the API service.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_operations_get/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_operations_get/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_operations_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_operations_get/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_operations_get/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_operations_list/4","doc":"Lists operations that match the specified filter in the request. If the server doesn't support this method, it returns `UNIMPLEMENTED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_operations_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_operations_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation's parent resource.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - The standard list filter.\n    *   `:pageSize` (*type:* `integer()`) - The standard list page size.\n    *   `:pageToken` (*type:* `String.t`) - The standard list page token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_operations_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_operations_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListOperationsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_operations_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_patch/4","doc":"Updates an instance partition, and begins allocating or releasing resources as requested. The returned long-running operation can be used to track the progress of updating the instance partition. If the named instance partition does not exist, returns `NOT_FOUND`. Immediately upon completion of this request: * For resource types for which a decrease in the instance partition's allocation has been requested, billing is based on the newly-requested level. Until completion of the returned operation: * Cancelling the operation sets its metadata's cancel_time, and begins restoring resources to their pre-request values. The operation is guaranteed to succeed at undoing all resource changes, after which point it terminates with a `CANCELLED` status. * All other attempts to modify the instance partition are rejected. * Reading the instance partition via the API continues to give the pre-request resource levels. Upon completion of the returned operation: * Billing begins for all successfully-allocated resources (some types may have lower than the requested levels). * All newly-reserved resources are available for serving the instance partition's tables. * The instance partition's new resource levels are readable via the API. The returned long-running operation will have a name of the format `/operations/` and can be used to track the instance partition modification. The metadata field type is UpdateInstancePartitionMetadata. The response field type is InstancePartition, if successful. Authorization requires `spanner.instancePartitions.update` permission on the resource name.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_patch/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_patch/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. A unique identifier for the instance partition. Values are of the form `projects//instances//instancePartitions/a-z*[a-z0-9]`. The final segment of the name must be between 2 and 64 characters in length. An instance partition's name cannot be changed after the instance partition is created.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.UpdateInstancePartitionRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_patch/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_instance_partitions_patch/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_instance_partitions_patch/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_list/4","doc":"Lists all instances in the given project.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The name of the project for which a list of instances is requested. Values are of the form `projects/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - An expression for filtering the results of the request. Filter rules are case insensitive. The fields eligible for filtering are: * `name` * `display_name` * `labels.key` where key is the name of a label Some examples of using filters are: * `name:*` --> The instance has a name. * `name:Howl` --> The instance's name contains the string \"howl\". * `name:HOWL` --> Equivalent to above. * `NAME:howl` --> Equivalent to above. * `labels.env:*` --> The instance has the label \"env\". * `labels.env:dev` --> The instance has the label \"env\" and the value of the label contains the string \"dev\". * `name:howl labels.env:dev` --> The instance's name contains \"howl\" and it has the label \"env\" with its value containing \"dev\".\n    *   `:instanceDeadline` (*type:* `DateTime.t`) - Deadline used while retrieving metadata for instances. Instances whose metadata cannot be retrieved within this deadline will be added to unreachable in ListInstancesResponse.\n    *   `:pageSize` (*type:* `integer()`) - Number of instances to be returned in the response. If 0 or less, defaults to the server's maximum allowed page size.\n    *   `:pageToken` (*type:* `String.t`) - If non-empty, `page_token` should contain a next_page_token from a previous ListInstancesResponse.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListInstancesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_move/4","doc":"Moves an instance to the target instance configuration. You can use the returned long-running operation to track the progress of moving the instance. `MoveInstance` returns `FAILED_PRECONDITION` if the instance meets any of the following criteria: * Is undergoing a move to a different instance configuration * Has backups * Has an ongoing update * Contains any CMEK-enabled databases * Is a free trial instance While the operation is pending: * All other attempts to modify the instance, including changes to its compute capacity, are rejected. * The following database and backup admin operations are rejected: * `DatabaseAdmin.CreateDatabase` * `DatabaseAdmin.UpdateDatabaseDdl` (disabled if default_leader is specified in the request.) * `DatabaseAdmin.RestoreDatabase` * `DatabaseAdmin.CreateBackup` * `DatabaseAdmin.CopyBackup` * Both the source and target instance configurations are subject to hourly compute and storage charges. * The instance might experience higher read-write latencies and a higher transaction abort rate. However, moving an instance doesn't cause any downtime. The returned long-running operation has a name of the format `/operations/` and can be used to track the move instance operation. The metadata field type is MoveInstanceMetadata. The response field type is Instance, if successful. Cancelling the operation sets its metadata's cancel_time. Cancellation is not immediate because it involves moving any data previously moved to the target instance configuration back to the original instance configuration. You can use this operation to track the progress of the cancellation. Upon successful completion of the cancellation, the operation terminates with `CANCELLED` status. If not cancelled, upon completion of the returned operation: * The instance successfully moves to the target instance configuration. * You are billed for compute and storage in target instance configuration. Authorization requires the `spanner.instances.update` permission on the resource instance. For more details, see [Move an instance](https://cloud.google.com/spanner/docs/move-instance).","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_move/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_move/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The instance to move. Values are of the form `projects//instances/`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.MoveInstanceRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_move/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_move/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_move/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_operations_cancel/4","doc":"Starts asynchronous cancellation on a long-running operation. The server makes a best effort to cancel the operation, but success is not guaranteed. If the server doesn't support this method, it returns `google.rpc.Code.UNIMPLEMENTED`. Clients can use Operations.GetOperation or other methods to check whether the cancellation succeeded or whether the operation completed despite cancellation. On successful cancellation, the operation is not deleted; instead, it becomes an operation with an Operation.error value with a google.rpc.Status.code of 1, corresponding to `Code.CANCELLED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_operations_cancel/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_operations_cancel/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource to be cancelled.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_operations_cancel/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_operations_cancel/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_operations_cancel/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_operations_delete/4","doc":"Deletes a long-running operation. This method indicates that the client is no longer interested in the operation result. It does not cancel the operation. If the server doesn't support this method, it returns `google.rpc.Code.UNIMPLEMENTED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_operations_delete/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_operations_delete/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource to be deleted.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_operations_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_operations_delete/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_operations_delete/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_operations_get/4","doc":"Gets the latest state of a long-running operation. Clients can use this method to poll the operation result at intervals as recommended by the API service.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_operations_get/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_operations_get/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_operations_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_operations_get/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_operations_get/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_operations_list/4","doc":"Lists operations that match the specified filter in the request. If the server doesn't support this method, it returns `UNIMPLEMENTED`.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_operations_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_operations_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation's parent resource.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - The standard list filter.\n    *   `:pageSize` (*type:* `integer()`) - The standard list page size.\n    *   `:pageToken` (*type:* `String.t`) - The standard list page token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_operations_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_operations_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListOperationsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_operations_list/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_patch/4","doc":"Updates an instance, and begins allocating or releasing resources as requested. The returned long-running operation can be used to track the progress of updating the instance. If the named instance does not exist, returns `NOT_FOUND`. Immediately upon completion of this request: * For resource types for which a decrease in the instance's allocation has been requested, billing is based on the newly-requested level. Until completion of the returned operation: * Cancelling the operation sets its metadata's cancel_time, and begins restoring resources to their pre-request values. The operation is guaranteed to succeed at undoing all resource changes, after which point it terminates with a `CANCELLED` status. * All other attempts to modify the instance are rejected. * Reading the instance via the API continues to give the pre-request resource levels. Upon completion of the returned operation: * Billing begins for all successfully-allocated resources (some types may have lower than the requested levels). * All newly-reserved resources are available for serving the instance's tables. * The instance's new resource levels are readable via the API. The returned long-running operation will have a name of the format `/operations/` and can be used to track the instance modification. The metadata field type is UpdateInstanceMetadata. The response field type is Instance, if successful. Authorization requires `spanner.instances.update` permission on the resource name.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_patch/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_patch/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. A unique identifier for the instance, which cannot be changed after the instance is created. Values are of the form `projects//instances/a-z*[a-z0-9]`. The final segment of the name must be between 2 and 64 characters in length.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.UpdateInstanceRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_patch/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_patch/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_patch/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_set_iam_policy/4","doc":"Sets the access control policy on an instance resource. Replaces any existing policy. Authorization requires `spanner.instances.setIamPolicy` on resource.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_set_iam_policy/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_set_iam_policy/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `resource` (*type:* `String.t`) - REQUIRED: The Cloud Spanner resource for which the policy is being set. The format is `projects//instances/` for instance resources and `projects//instances//databases/` for databases resources.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.SetIamPolicyRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_set_iam_policy/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_set_iam_policy/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.Policy{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_set_iam_policy/4-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_test_iam_permissions/4","doc":"Returns permissions that the caller has on the specified instance resource. Attempting this RPC on a non-existent Cloud Spanner instance resource will result in a NOT_FOUND error if the user has `spanner.instances.list` permission on the containing Google Cloud Project. Otherwise returns an empty set of permissions.","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_test_iam_permissions/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_test_iam_permissions/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `resource` (*type:* `String.t`) - REQUIRED: The Cloud Spanner resource for which permissions are being tested. The format is `projects//instances/` for instance resources and `projects//instances//databases/` for database resources.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_test_iam_permissions/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Projects.spanner_projects_instances_test_iam_permissions/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Projects.html#spanner_projects_instances_test_iam_permissions/4-returns"},{"type":"module","title":"GoogleApi.Spanner.V1.Api.Scans","doc":"API calls for all endpoints tagged `Scans`.","ref":"GoogleApi.Spanner.V1.Api.Scans.html"},{"type":"function","title":"GoogleApi.Spanner.V1.Api.Scans.spanner_scans_list/4","doc":"Return available scans given a Database-specific resource name.","ref":"GoogleApi.Spanner.V1.Api.Scans.html#spanner_scans_list/4"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Api.Scans.spanner_scans_list/4","doc":"*   `connection` (*type:* `GoogleApi.Spanner.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The unique name of the parent resource, specific to the Database service implementing this interface.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - A filter expression to restrict the results based on information present in the available Scan collection. The filter applies to all fields within the Scan message except for `data`.\n    *   `:pageSize` (*type:* `integer()`) - The maximum number of items to return.\n    *   `:pageToken` (*type:* `String.t`) - The next_page_token value returned from a previous List request, if any.\n    *   `:view` (*type:* `String.t`) - Specifies which parts of the Scan should be returned in the response. Note, only the SUMMARY view (the default) is currently supported for ListScans.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Spanner.V1.Api.Scans.html#spanner_scans_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Api.Scans.spanner_scans_list/4","doc":"*   `{:ok, %GoogleApi.Spanner.V1.Model.ListScansResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Spanner.V1.Api.Scans.html#spanner_scans_list/4-returns"},{"type":"module","title":"GoogleApi.Spanner.V1.Connection","doc":"Handle Tesla connections for GoogleApi.Spanner.V1.","ref":"GoogleApi.Spanner.V1.Connection.html"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Spanner.V1.Connection.html#delete/3"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Spanner.V1.Connection.html#delete!/3"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.execute/2","doc":"Execute a request on this connection","ref":"GoogleApi.Spanner.V1.Connection.html#execute/2"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Connection.execute/2","doc":"*   `{:ok, Tesla.Env.t}` - If the call was successful\n*   `{:error, reason}` - If the call failed","ref":"GoogleApi.Spanner.V1.Connection.html#execute/2-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Spanner.V1.Connection.html#get/3"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Spanner.V1.Connection.html#get!/3"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Spanner.V1.Connection.html#head/3"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Spanner.V1.Connection.html#head!/3"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.new/0","doc":"Configure an authless client connection","ref":"GoogleApi.Spanner.V1.Connection.html#new/0"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Connection.new/0","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.Spanner.V1.Connection.html#new/0-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.new/1","doc":"Configure a client connection using a function which yields a Bearer token.","ref":"GoogleApi.Spanner.V1.Connection.html#new/1"},{"type":"function","title":"Parameters - GoogleApi.Spanner.V1.Connection.new/1","doc":"*   `token_fetcher` (*type:* `list(String.t()) -> String.t()`) - Callback\n    which provides an OAuth2 token given a list of scopes","ref":"GoogleApi.Spanner.V1.Connection.html#new/1-parameters"},{"type":"function","title":"Returns - GoogleApi.Spanner.V1.Connection.new/1","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.Spanner.V1.Connection.html#new/1-returns"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Spanner.V1.Connection.html#options/3"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Spanner.V1.Connection.html#options!/3"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Spanner.V1.Connection.html#patch/4"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Spanner.V1.Connection.html#patch!/4"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Spanner.V1.Connection.html#post/4"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Spanner.V1.Connection.html#post!/4"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Spanner.V1.Connection.html#put/4"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Spanner.V1.Connection.html#put!/4"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.request/2","doc":"Perform a request.","ref":"GoogleApi.Spanner.V1.Connection.html#request/2"},{"type":"function","title":"Options - GoogleApi.Spanner.V1.Connection.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyworld list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"GoogleApi.Spanner.V1.Connection.html#request/2-options"},{"type":"function","title":"Examples - GoogleApi.Spanner.V1.Connection.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"GoogleApi.Spanner.V1.Connection.html#request/2-examples"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"GoogleApi.Spanner.V1.Connection.html#request!/2"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Spanner.V1.Connection.html#trace/3"},{"type":"function","title":"GoogleApi.Spanner.V1.Connection.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Spanner.V1.Connection.html#trace!/3"},{"type":"type","title":"GoogleApi.Spanner.V1.Connection.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"GoogleApi.Spanner.V1.Connection.html#t:option/0"},{"type":"type","title":"GoogleApi.Spanner.V1.Connection.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Connection.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.AutoscalingConfig","doc":"Autoscaling configuration for an instance.","ref":"GoogleApi.Spanner.V1.Model.AutoscalingConfig.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.AutoscalingConfig","doc":"*   `autoscalingLimits` (*type:* `GoogleApi.Spanner.V1.Model.AutoscalingLimits.t`, *default:* `nil`) - Required. Autoscaling limits for an instance.\n*   `autoscalingTargets` (*type:* `GoogleApi.Spanner.V1.Model.AutoscalingTargets.t`, *default:* `nil`) - Required. The autoscaling targets for an instance.","ref":"GoogleApi.Spanner.V1.Model.AutoscalingConfig.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.AutoscalingConfig.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.AutoscalingConfig.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.AutoscalingConfig.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.AutoscalingConfig.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.AutoscalingLimits","doc":"The autoscaling limits for the instance. Users can define the minimum and maximum compute capacity allocated to the instance, and the autoscaler will only scale within that range. Users can either use nodes or processing units to specify the limits, but should use the same unit to set both the min_limit and max_limit.","ref":"GoogleApi.Spanner.V1.Model.AutoscalingLimits.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.AutoscalingLimits","doc":"*   `maxNodes` (*type:* `integer()`, *default:* `nil`) - Maximum number of nodes allocated to the instance. If set, this number should be greater than or equal to min_nodes.\n*   `maxProcessingUnits` (*type:* `integer()`, *default:* `nil`) - Maximum number of processing units allocated to the instance. If set, this number should be multiples of 1000 and be greater than or equal to min_processing_units.\n*   `minNodes` (*type:* `integer()`, *default:* `nil`) - Minimum number of nodes allocated to the instance. If set, this number should be greater than or equal to 1.\n*   `minProcessingUnits` (*type:* `integer()`, *default:* `nil`) - Minimum number of processing units allocated to the instance. If set, this number should be multiples of 1000.","ref":"GoogleApi.Spanner.V1.Model.AutoscalingLimits.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.AutoscalingLimits.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.AutoscalingLimits.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.AutoscalingLimits.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.AutoscalingLimits.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.AutoscalingTargets","doc":"The autoscaling targets for an instance.","ref":"GoogleApi.Spanner.V1.Model.AutoscalingTargets.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.AutoscalingTargets","doc":"*   `highPriorityCpuUtilizationPercent` (*type:* `integer()`, *default:* `nil`) - Required. The target high priority cpu utilization percentage that the autoscaler should be trying to achieve for the instance. This number is on a scale from 0 (no utilization) to 100 (full utilization). The valid range is [10, 90] inclusive.\n*   `storageUtilizationPercent` (*type:* `integer()`, *default:* `nil`) - Required. The target storage utilization percentage that the autoscaler should be trying to achieve for the instance. This number is on a scale from 0 (no utilization) to 100 (full utilization). The valid range is [10, 99] inclusive.","ref":"GoogleApi.Spanner.V1.Model.AutoscalingTargets.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.AutoscalingTargets.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.AutoscalingTargets.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.AutoscalingTargets.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.AutoscalingTargets.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Backup","doc":"A backup of a Cloud Spanner database.","ref":"GoogleApi.Spanner.V1.Model.Backup.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Backup","doc":"*   `backupSchedules` (*type:* `list(String.t)`, *default:* `nil`) - Output only. List of backup schedule URIs that are associated with creating this backup. This is only applicable for scheduled backups, and is empty for on-demand backups. To optimize for storage, whenever possible, multiple schedules are collapsed together to create one backup. In such cases, this field captures the list of all backup schedule URIs that are associated with creating this backup. If collapsing is not done, then this field captures the single backup schedule URI associated with creating this backup.\n*   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The time the CreateBackup request is received. If the request does not specify `version_time`, the `version_time` of the backup will be equivalent to the `create_time`.\n*   `database` (*type:* `String.t`, *default:* `nil`) - Required for the CreateBackup operation. Name of the database from which this backup was created. This needs to be in the same instance as the backup. Values are of the form `projects//instances//databases/`.\n*   `databaseDialect` (*type:* `String.t`, *default:* `nil`) - Output only. The database dialect information for the backup.\n*   `encryptionInfo` (*type:* `GoogleApi.Spanner.V1.Model.EncryptionInfo.t`, *default:* `nil`) - Output only. The encryption information for the backup.\n*   `encryptionInformation` (*type:* `list(GoogleApi.Spanner.V1.Model.EncryptionInfo.t)`, *default:* `nil`) - Output only. The encryption information for the backup, whether it is protected by one or more KMS keys. The information includes all Cloud KMS key versions used to encrypt the backup. The `encryption_status' field inside of each `EncryptionInfo` is not populated. At least one of the key versions must be available for the backup to be restored. If a key version is revoked in the middle of a restore, the restore behavior is undefined.\n*   `exclusiveSizeBytes` (*type:* `String.t`, *default:* `nil`) - Output only. For a backup in an incremental backup chain, this is the storage space needed to keep the data that has changed since the previous backup. For all other backups, this is always the size of the backup. This value may change if backups on the same chain get deleted or expired. This field can be used to calculate the total storage space used by a set of backups. For example, the total space used by all backups of a database can be computed by summing up this field.\n*   `expireTime` (*type:* `DateTime.t`, *default:* `nil`) - Required for the CreateBackup operation. The expiration time of the backup, with microseconds granularity that must be at least 6 hours and at most 366 days from the time the CreateBackup request is processed. Once the `expire_time` has passed, the backup is eligible to be automatically deleted by Cloud Spanner to free the resources used by the backup.\n*   `freeableSizeBytes` (*type:* `String.t`, *default:* `nil`) - Output only. The number of bytes that will be freed by deleting this backup. This value will be zero if, for example, this backup is part of an incremental backup chain and younger backups in the chain require that we keep its data. For backups not in an incremental backup chain, this is always the size of the backup. This value may change if backups on the same chain get created, deleted or expired.\n*   `incrementalBackupChainId` (*type:* `String.t`, *default:* `nil`) - Output only. Populated only for backups in an incremental backup chain. Backups share the same chain id if and only if they belong to the same incremental backup chain. Use this field to determine which backups are part of the same incremental backup chain. The ordering of backups in the chain can be determined by ordering the backup `version_time`.\n*   `maxExpireTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The max allowed expiration time of the backup, with microseconds granularity. A backup's expiration time can be configured in multiple APIs: CreateBackup, UpdateBackup, CopyBackup. When updating or copying an existing backup, the expiration time specified must be less than `Backup.max_expire_time`.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Output only for the CreateBackup operation. Required for the UpdateBackup operation. A globally unique identifier for the backup which cannot be changed. Values are of the form `projects//instances//backups/a-z*[a-z0-9]` The final segment of the name must be between 2 and 60 characters in length. The backup is stored in the location(s) specified in the instance configuration of the instance containing the backup, identified by the prefix of the backup name of the form `projects//instances/`.\n*   `oldestVersionTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. Data deleted at a time older than this is guaranteed not to be retained in order to support this backup. For a backup in an incremental backup chain, this is the version time of the oldest backup that exists or ever existed in the chain. For all other backups, this is the version time of the backup. This field can be used to understand what data is being retained by the backup system.\n*   `referencingBackups` (*type:* `list(String.t)`, *default:* `nil`) - Output only. The names of the destination backups being created by copying this source backup. The backup names are of the form `projects//instances//backups/`. Referencing backups may exist in different instances. The existence of any referencing backup prevents the backup from being deleted. When the copy operation is done (either successfully completed or cancelled or the destination backup is deleted), the reference to the backup is removed.\n*   `referencingDatabases` (*type:* `list(String.t)`, *default:* `nil`) - Output only. The names of the restored databases that reference the backup. The database names are of the form `projects//instances//databases/`. Referencing databases may exist in different instances. The existence of any referencing database prevents the backup from being deleted. When a restored database from the backup enters the `READY` state, the reference to the backup is removed.\n*   `sizeBytes` (*type:* `String.t`, *default:* `nil`) - Output only. Size of the backup in bytes. For a backup in an incremental backup chain, this is the sum of the `exclusive_size_bytes` of itself and all older backups in the chain.\n*   `state` (*type:* `String.t`, *default:* `nil`) - Output only. The current state of the backup.\n*   `versionTime` (*type:* `DateTime.t`, *default:* `nil`) - The backup will contain an externally consistent copy of the database at the timestamp specified by `version_time`. If `version_time` is not specified, the system will set `version_time` to the `create_time` of the backup.","ref":"GoogleApi.Spanner.V1.Model.Backup.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Backup.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Backup.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Backup.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Backup.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.BackupInfo","doc":"Information about a backup.","ref":"GoogleApi.Spanner.V1.Model.BackupInfo.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.BackupInfo","doc":"*   `backup` (*type:* `String.t`, *default:* `nil`) - Name of the backup.\n*   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - The time the CreateBackup request was received.\n*   `sourceDatabase` (*type:* `String.t`, *default:* `nil`) - Name of the database the backup was created from.\n*   `versionTime` (*type:* `DateTime.t`, *default:* `nil`) - The backup contains an externally consistent copy of `source_database` at the timestamp specified by `version_time`. If the CreateBackup request did not specify `version_time`, the `version_time` of the backup is equivalent to the `create_time`.","ref":"GoogleApi.Spanner.V1.Model.BackupInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.BackupInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.BackupInfo.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.BackupInfo.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.BackupInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.BackupSchedule","doc":"BackupSchedule expresses the automated backup creation specification for a Spanner database. Next ID: 10","ref":"GoogleApi.Spanner.V1.Model.BackupSchedule.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.BackupSchedule","doc":"*   `encryptionConfig` (*type:* `GoogleApi.Spanner.V1.Model.CreateBackupEncryptionConfig.t`, *default:* `nil`) - Optional. The encryption configuration that will be used to encrypt the backup. If this field is not specified, the backup will use the same encryption configuration as the database.\n*   `fullBackupSpec` (*type:* `GoogleApi.Spanner.V1.Model.FullBackupSpec.t`, *default:* `nil`) - The schedule creates only full backups.\n*   `incrementalBackupSpec` (*type:* `GoogleApi.Spanner.V1.Model.IncrementalBackupSpec.t`, *default:* `nil`) - The schedule creates incremental backup chains.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Identifier. Output only for the CreateBackupSchedule operation. Required for the UpdateBackupSchedule operation. A globally unique identifier for the backup schedule which cannot be changed. Values are of the form `projects//instances//databases//backupSchedules/a-z*[a-z0-9]` The final segment of the name must be between 2 and 60 characters in length.\n*   `retentionDuration` (*type:* `String.t`, *default:* `nil`) - Optional. The retention duration of a backup that must be at least 6 hours and at most 366 days. The backup is eligible to be automatically deleted once the retention period has elapsed.\n*   `spec` (*type:* `GoogleApi.Spanner.V1.Model.BackupScheduleSpec.t`, *default:* `nil`) - Optional. The schedule specification based on which the backup creations are triggered.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The timestamp at which the schedule was last updated. If the schedule has never been updated, this field contains the timestamp when the schedule was first created.","ref":"GoogleApi.Spanner.V1.Model.BackupSchedule.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.BackupSchedule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.BackupSchedule.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.BackupSchedule.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.BackupSchedule.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.BackupScheduleSpec","doc":"Defines specifications of the backup schedule.","ref":"GoogleApi.Spanner.V1.Model.BackupScheduleSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.BackupScheduleSpec","doc":"*   `cronSpec` (*type:* `GoogleApi.Spanner.V1.Model.CrontabSpec.t`, *default:* `nil`) - Cron style schedule specification.","ref":"GoogleApi.Spanner.V1.Model.BackupScheduleSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.BackupScheduleSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.BackupScheduleSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.BackupScheduleSpec.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.BackupScheduleSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.BatchCreateSessionsRequest","doc":"The request for BatchCreateSessions.","ref":"GoogleApi.Spanner.V1.Model.BatchCreateSessionsRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.BatchCreateSessionsRequest","doc":"*   `sessionCount` (*type:* `integer()`, *default:* `nil`) - Required. The number of sessions to be created in this batch call. The API may return fewer than the requested number of sessions. If a specific number of sessions are desired, the client can make additional calls to BatchCreateSessions (adjusting session_count as necessary).\n*   `sessionTemplate` (*type:* `GoogleApi.Spanner.V1.Model.Session.t`, *default:* `nil`) - Parameters to be applied to each created session.","ref":"GoogleApi.Spanner.V1.Model.BatchCreateSessionsRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.BatchCreateSessionsRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.BatchCreateSessionsRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.BatchCreateSessionsRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.BatchCreateSessionsRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.BatchCreateSessionsResponse","doc":"The response for BatchCreateSessions.","ref":"GoogleApi.Spanner.V1.Model.BatchCreateSessionsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.BatchCreateSessionsResponse","doc":"*   `session` (*type:* `list(GoogleApi.Spanner.V1.Model.Session.t)`, *default:* `nil`) - The freshly created sessions.","ref":"GoogleApi.Spanner.V1.Model.BatchCreateSessionsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.BatchCreateSessionsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.BatchCreateSessionsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.BatchCreateSessionsResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.BatchCreateSessionsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.BatchWriteRequest","doc":"The request for BatchWrite.","ref":"GoogleApi.Spanner.V1.Model.BatchWriteRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.BatchWriteRequest","doc":"*   `excludeTxnFromChangeStreams` (*type:* `boolean()`, *default:* `nil`) - Optional. When `exclude_txn_from_change_streams` is set to `true`: * Modifications from all transactions in this batch write operation will not be recorded in change streams with DDL option `allow_txn_exclusion=true` that are tracking columns modified by these transactions. * Modifications from all transactions in this batch write operation will be recorded in change streams with DDL option `allow_txn_exclusion=false or not set` that are tracking columns modified by these transactions. When `exclude_txn_from_change_streams` is set to `false` or not set, Modifications from all transactions in this batch write operation will be recorded in all change streams that are tracking columns modified by these transactions.\n*   `mutationGroups` (*type:* `list(GoogleApi.Spanner.V1.Model.MutationGroup.t)`, *default:* `nil`) - Required. The groups of mutations to be applied.\n*   `requestOptions` (*type:* `GoogleApi.Spanner.V1.Model.RequestOptions.t`, *default:* `nil`) - Common options for this request.","ref":"GoogleApi.Spanner.V1.Model.BatchWriteRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.BatchWriteRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.BatchWriteRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.BatchWriteRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.BatchWriteRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.BatchWriteResponse","doc":"The result of applying a batch of mutations.","ref":"GoogleApi.Spanner.V1.Model.BatchWriteResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.BatchWriteResponse","doc":"*   `commitTimestamp` (*type:* `DateTime.t`, *default:* `nil`) - The commit timestamp of the transaction that applied this batch. Present if `status` is `OK`, absent otherwise.\n*   `indexes` (*type:* `list(integer())`, *default:* `nil`) - The mutation groups applied in this batch. The values index into the `mutation_groups` field in the corresponding `BatchWriteRequest`.\n*   `status` (*type:* `GoogleApi.Spanner.V1.Model.Status.t`, *default:* `nil`) - An `OK` status indicates success. Any other status indicates a failure.","ref":"GoogleApi.Spanner.V1.Model.BatchWriteResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.BatchWriteResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.BatchWriteResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.BatchWriteResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.BatchWriteResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.BeginTransactionRequest","doc":"The request for BeginTransaction.","ref":"GoogleApi.Spanner.V1.Model.BeginTransactionRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.BeginTransactionRequest","doc":"*   `options` (*type:* `GoogleApi.Spanner.V1.Model.TransactionOptions.t`, *default:* `nil`) - Required. Options for the new transaction.\n*   `requestOptions` (*type:* `GoogleApi.Spanner.V1.Model.RequestOptions.t`, *default:* `nil`) - Common options for this request. Priority is ignored for this request. Setting the priority in this request_options struct will not do anything. To set the priority for a transaction, set it on the reads and writes that are part of this transaction instead.","ref":"GoogleApi.Spanner.V1.Model.BeginTransactionRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.BeginTransactionRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.BeginTransactionRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.BeginTransactionRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.BeginTransactionRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Binding","doc":"Associates `members`, or principals, with a `role`.","ref":"GoogleApi.Spanner.V1.Model.Binding.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Binding","doc":"*   `condition` (*type:* `GoogleApi.Spanner.V1.Model.Expr.t`, *default:* `nil`) - The condition that is associated with this binding. If the condition evaluates to `true`, then this binding applies to the current request. If the condition evaluates to `false`, then this binding does not apply to the current request. However, a different role binding might grant the same role to one or more of the principals in this binding. To learn which resources support conditions in their IAM policies, see the [IAM documentation](https://cloud.google.com/iam/help/conditions/resource-policies).\n*   `members` (*type:* `list(String.t)`, *default:* `nil`) - Specifies the principals requesting access for a Google Cloud resource. `members` can have the following values: * `allUsers`: A special identifier that represents anyone who is on the internet; with or without a Google account. * `allAuthenticatedUsers`: A special identifier that represents anyone who is authenticated with a Google account or a service account. Does not include identities that come from external identity providers (IdPs) through identity federation. * `user:{emailid}`: An email address that represents a specific Google account. For example, `alice@example.com` . * `serviceAccount:{emailid}`: An email address that represents a Google service account. For example, `my-other-app@appspot.gserviceaccount.com`. * `serviceAccount:{projectid}.svc.id.goog[{namespace}/{kubernetes-sa}]`: An identifier for a [Kubernetes service account](https://cloud.google.com/kubernetes-engine/docs/how-to/kubernetes-service-accounts). For example, `my-project.svc.id.goog[my-namespace/my-kubernetes-sa]`. * `group:{emailid}`: An email address that represents a Google group. For example, `admins@example.com`. * `domain:{domain}`: The G Suite domain (primary) that represents all the users of that domain. For example, `google.com` or `example.com`. * `principal://iam.googleapis.com/locations/global/workforcePools/{pool_id}/subject/{subject_attribute_value}`: A single identity in a workforce identity pool. * `principalSet://iam.googleapis.com/locations/global/workforcePools/{pool_id}/group/{group_id}`: All workforce identities in a group. * `principalSet://iam.googleapis.com/locations/global/workforcePools/{pool_id}/attribute.{attribute_name}/{attribute_value}`: All workforce identities with a specific attribute value. * `principalSet://iam.googleapis.com/locations/global/workforcePools/{pool_id}/*`: All identities in a workforce identity pool. * `principal://iam.googleapis.com/projects/{project_number}/locations/global/workloadIdentityPools/{pool_id}/subject/{subject_attribute_value}`: A single identity in a workload identity pool. * `principalSet://iam.googleapis.com/projects/{project_number}/locations/global/workloadIdentityPools/{pool_id}/group/{group_id}`: A workload identity pool group. * `principalSet://iam.googleapis.com/projects/{project_number}/locations/global/workloadIdentityPools/{pool_id}/attribute.{attribute_name}/{attribute_value}`: All identities in a workload identity pool with a certain attribute. * `principalSet://iam.googleapis.com/projects/{project_number}/locations/global/workloadIdentityPools/{pool_id}/*`: All identities in a workload identity pool. * `deleted:user:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing a user that has been recently deleted. For example, `alice@example.com?uid=123456789012345678901`. If the user is recovered, this value reverts to `user:{emailid}` and the recovered user retains the role in the binding. * `deleted:serviceAccount:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing a service account that has been recently deleted. For example, `my-other-app@appspot.gserviceaccount.com?uid=123456789012345678901`. If the service account is undeleted, this value reverts to `serviceAccount:{emailid}` and the undeleted service account retains the role in the binding. * `deleted:group:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing a Google group that has been recently deleted. For example, `admins@example.com?uid=123456789012345678901`. If the group is recovered, this value reverts to `group:{emailid}` and the recovered group retains the role in the binding. * `deleted:principal://iam.googleapis.com/locations/global/workforcePools/{pool_id}/subject/{subject_attribute_value}`: Deleted single identity in a workforce identity pool. For example, `deleted:principal://iam.googleapis.com/locations/global/workforcePools/my-pool-id/subject/my-subject-attribute-value`.\n*   `role` (*type:* `String.t`, *default:* `nil`) - Role that is assigned to the list of `members`, or principals. For example, `roles/viewer`, `roles/editor`, or `roles/owner`. For an overview of the IAM roles and permissions, see the [IAM documentation](https://cloud.google.com/iam/docs/roles-overview). For a list of the available pre-defined roles, see [here](https://cloud.google.com/iam/docs/understanding-roles).","ref":"GoogleApi.Spanner.V1.Model.Binding.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Binding.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Binding.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Binding.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Binding.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ChangeQuorumMetadata","doc":"Metadata type for the long-running operation returned by ChangeQuorum.","ref":"GoogleApi.Spanner.V1.Model.ChangeQuorumMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ChangeQuorumMetadata","doc":"*   `endTime` (*type:* `DateTime.t`, *default:* `nil`) - If set, the time at which this operation failed or was completed successfully.\n*   `request` (*type:* `GoogleApi.Spanner.V1.Model.ChangeQuorumRequest.t`, *default:* `nil`) - The request for ChangeQuorum.\n*   `startTime` (*type:* `DateTime.t`, *default:* `nil`) - Time the request was received.","ref":"GoogleApi.Spanner.V1.Model.ChangeQuorumMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ChangeQuorumMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ChangeQuorumMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ChangeQuorumMetadata.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ChangeQuorumMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ChangeQuorumRequest","doc":"The request for ChangeQuorum.","ref":"GoogleApi.Spanner.V1.Model.ChangeQuorumRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ChangeQuorumRequest","doc":"*   `etag` (*type:* `String.t`, *default:* `nil`) - Optional. The etag is the hash of the `QuorumInfo`. The `ChangeQuorum` operation is only performed if the etag matches that of the `QuorumInfo` in the current database resource. Otherwise the API returns an `ABORTED` error. The etag is used for optimistic concurrency control as a way to help prevent simultaneous change quorum requests that could create a race condition.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Required. Name of the database in which to apply `ChangeQuorum`. Values are of the form `projects//instances//databases/`.\n*   `quorumType` (*type:* `GoogleApi.Spanner.V1.Model.QuorumType.t`, *default:* `nil`) - Required. The type of this quorum.","ref":"GoogleApi.Spanner.V1.Model.ChangeQuorumRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ChangeQuorumRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ChangeQuorumRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ChangeQuorumRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ChangeQuorumRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ChildLink","doc":"Metadata associated with a parent-child relationship appearing in a PlanNode.","ref":"GoogleApi.Spanner.V1.Model.ChildLink.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ChildLink","doc":"*   `childIndex` (*type:* `integer()`, *default:* `nil`) - The node to which the link points.\n*   `type` (*type:* `String.t`, *default:* `nil`) - The type of the link. For example, in Hash Joins this could be used to distinguish between the build child and the probe child, or in the case of the child being an output variable, to represent the tag associated with the output variable.\n*   `variable` (*type:* `String.t`, *default:* `nil`) - Only present if the child node is SCALAR and corresponds to an output variable of the parent node. The field carries the name of the output variable. For example, a `TableScan` operator that reads rows from a table will have child links to the `SCALAR` nodes representing the output variables created for each column that is read by the operator. The corresponding `variable` fields will be set to the variable names assigned to the columns.","ref":"GoogleApi.Spanner.V1.Model.ChildLink.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ChildLink.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ChildLink.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ChildLink.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ChildLink.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CommitRequest","doc":"The request for Commit.","ref":"GoogleApi.Spanner.V1.Model.CommitRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CommitRequest","doc":"*   `maxCommitDelay` (*type:* `String.t`, *default:* `nil`) - Optional. The amount of latency this request is configured to incur in order to improve throughput. If this field is not set, Spanner assumes requests are relatively latency sensitive and automatically determines an appropriate delay time. You can specify a commit delay value between 0 and 500 ms.\n*   `mutations` (*type:* `list(GoogleApi.Spanner.V1.Model.Mutation.t)`, *default:* `nil`) - The mutations to be executed when this transaction commits. All mutations are applied atomically, in the order they appear in this list.\n*   `requestOptions` (*type:* `GoogleApi.Spanner.V1.Model.RequestOptions.t`, *default:* `nil`) - Common options for this request.\n*   `returnCommitStats` (*type:* `boolean()`, *default:* `nil`) - If `true`, then statistics related to the transaction will be included in the CommitResponse. Default value is `false`.\n*   `singleUseTransaction` (*type:* `GoogleApi.Spanner.V1.Model.TransactionOptions.t`, *default:* `nil`) - Execute mutations in a temporary transaction. Note that unlike commit of a previously-started transaction, commit with a temporary transaction is non-idempotent. That is, if the `CommitRequest` is sent to Cloud Spanner more than once (for instance, due to retries in the application, or in the transport library), it is possible that the mutations are executed more than once. If this is undesirable, use BeginTransaction and Commit instead.\n*   `transactionId` (*type:* `String.t`, *default:* `nil`) - Commit a previously-started transaction.","ref":"GoogleApi.Spanner.V1.Model.CommitRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CommitRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CommitRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CommitRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CommitRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CommitResponse","doc":"The response for Commit.","ref":"GoogleApi.Spanner.V1.Model.CommitResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CommitResponse","doc":"*   `commitStats` (*type:* `GoogleApi.Spanner.V1.Model.CommitStats.t`, *default:* `nil`) - The statistics about this Commit. Not returned by default. For more information, see CommitRequest.return_commit_stats.\n*   `commitTimestamp` (*type:* `DateTime.t`, *default:* `nil`) - The Cloud Spanner timestamp at which the transaction committed.","ref":"GoogleApi.Spanner.V1.Model.CommitResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CommitResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CommitResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CommitResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CommitResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CommitStats","doc":"Additional statistics about a commit.","ref":"GoogleApi.Spanner.V1.Model.CommitStats.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CommitStats","doc":"*   `mutationCount` (*type:* `String.t`, *default:* `nil`) - The total number of mutations for the transaction. Knowing the `mutation_count` value can help you maximize the number of mutations in a transaction and minimize the number of API round trips. You can also monitor this value to prevent transactions from exceeding the system [limit](https://cloud.google.com/spanner/quotas#limits_for_creating_reading_updating_and_deleting_data). If the number of mutations exceeds the limit, the server returns [INVALID_ARGUMENT](https://cloud.google.com/spanner/docs/reference/rest/v1/Code#ENUM_VALUES.INVALID_ARGUMENT).","ref":"GoogleApi.Spanner.V1.Model.CommitStats.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CommitStats.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CommitStats.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CommitStats.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CommitStats.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ContextValue","doc":"A message representing context for a KeyRangeInfo, including a label, value, unit, and severity.","ref":"GoogleApi.Spanner.V1.Model.ContextValue.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ContextValue","doc":"*   `label` (*type:* `GoogleApi.Spanner.V1.Model.LocalizedString.t`, *default:* `nil`) - The label for the context value. e.g. \"latency\".\n*   `severity` (*type:* `String.t`, *default:* `nil`) - The severity of this context.\n*   `unit` (*type:* `String.t`, *default:* `nil`) - The unit of the context value.\n*   `value` (*type:* `number()`, *default:* `nil`) - The value for the context.","ref":"GoogleApi.Spanner.V1.Model.ContextValue.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ContextValue.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ContextValue.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ContextValue.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ContextValue.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CopyBackupEncryptionConfig","doc":"Encryption configuration for the copied backup.","ref":"GoogleApi.Spanner.V1.Model.CopyBackupEncryptionConfig.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CopyBackupEncryptionConfig","doc":"*   `encryptionType` (*type:* `String.t`, *default:* `nil`) - Required. The encryption type of the backup.\n*   `kmsKeyName` (*type:* `String.t`, *default:* `nil`) - Optional. The Cloud KMS key that will be used to protect the backup. This field should be set only when encryption_type is `CUSTOMER_MANAGED_ENCRYPTION`. Values are of the form `projects//locations//keyRings//cryptoKeys/`.\n*   `kmsKeyNames` (*type:* `list(String.t)`, *default:* `nil`) - Optional. Specifies the KMS configuration for the one or more keys used to protect the backup. Values are of the form `projects//locations//keyRings//cryptoKeys/`. Kms keys specified can be in any order. The keys referenced by kms_key_names must fully cover all regions of the backup's instance configuration. Some examples: * For single region instance configs, specify a single regional location KMS key. * For multi-regional instance configs of type GOOGLE_MANAGED, either specify a multi-regional location KMS key or multiple regional location KMS keys that cover all regions in the instance config. * For an instance config of type USER_MANAGED, please specify only regional location KMS keys to cover each region in the instance config. Multi-regional location KMS keys are not supported for USER_MANAGED instance configs.","ref":"GoogleApi.Spanner.V1.Model.CopyBackupEncryptionConfig.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CopyBackupEncryptionConfig.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CopyBackupEncryptionConfig.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CopyBackupEncryptionConfig.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CopyBackupEncryptionConfig.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CopyBackupMetadata","doc":"Metadata type for the operation returned by CopyBackup.","ref":"GoogleApi.Spanner.V1.Model.CopyBackupMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CopyBackupMetadata","doc":"*   `cancelTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which cancellation of CopyBackup operation was received. Operations.CancelOperation starts asynchronous cancellation on a long-running operation. The server makes a best effort to cancel the operation, but success is not guaranteed. Clients can use Operations.GetOperation or other methods to check whether the cancellation succeeded or whether the operation completed despite cancellation. On successful cancellation, the operation is not deleted; instead, it becomes an operation with an Operation.error value with a google.rpc.Status.code of 1, corresponding to `Code.CANCELLED`.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The name of the backup being created through the copy operation. Values are of the form `projects//instances//backups/`.\n*   `progress` (*type:* `GoogleApi.Spanner.V1.Model.OperationProgress.t`, *default:* `nil`) - The progress of the CopyBackup operation.\n*   `sourceBackup` (*type:* `String.t`, *default:* `nil`) - The name of the source backup that is being copied. Values are of the form `projects//instances//backups/`.","ref":"GoogleApi.Spanner.V1.Model.CopyBackupMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CopyBackupMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CopyBackupMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CopyBackupMetadata.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CopyBackupMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CopyBackupRequest","doc":"The request for CopyBackup.","ref":"GoogleApi.Spanner.V1.Model.CopyBackupRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CopyBackupRequest","doc":"*   `backupId` (*type:* `String.t`, *default:* `nil`) - Required. The id of the backup copy. The `backup_id` appended to `parent` forms the full backup_uri of the form `projects//instances//backups/`.\n*   `encryptionConfig` (*type:* `GoogleApi.Spanner.V1.Model.CopyBackupEncryptionConfig.t`, *default:* `nil`) - Optional. The encryption configuration used to encrypt the backup. If this field is not specified, the backup will use the same encryption configuration as the source backup by default, namely encryption_type = `USE_CONFIG_DEFAULT_OR_BACKUP_ENCRYPTION`.\n*   `expireTime` (*type:* `DateTime.t`, *default:* `nil`) - Required. The expiration time of the backup in microsecond granularity. The expiration time must be at least 6 hours and at most 366 days from the `create_time` of the source backup. Once the `expire_time` has passed, the backup is eligible to be automatically deleted by Cloud Spanner to free the resources used by the backup.\n*   `sourceBackup` (*type:* `String.t`, *default:* `nil`) - Required. The source backup to be copied. The source backup needs to be in READY state for it to be copied. Once CopyBackup is in progress, the source backup cannot be deleted or cleaned up on expiration until CopyBackup is finished. Values are of the form: `projects//instances//backups/`.","ref":"GoogleApi.Spanner.V1.Model.CopyBackupRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CopyBackupRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CopyBackupRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CopyBackupRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CopyBackupRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CreateBackupEncryptionConfig","doc":"Encryption configuration for the backup to create.","ref":"GoogleApi.Spanner.V1.Model.CreateBackupEncryptionConfig.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CreateBackupEncryptionConfig","doc":"*   `encryptionType` (*type:* `String.t`, *default:* `nil`) - Required. The encryption type of the backup.\n*   `kmsKeyName` (*type:* `String.t`, *default:* `nil`) - Optional. The Cloud KMS key that will be used to protect the backup. This field should be set only when encryption_type is `CUSTOMER_MANAGED_ENCRYPTION`. Values are of the form `projects//locations//keyRings//cryptoKeys/`.\n*   `kmsKeyNames` (*type:* `list(String.t)`, *default:* `nil`) - Optional. Specifies the KMS configuration for the one or more keys used to protect the backup. Values are of the form `projects//locations//keyRings//cryptoKeys/`. The keys referenced by kms_key_names must fully cover all regions of the backup's instance configuration. Some examples: * For single region instance configs, specify a single regional location KMS key. * For multi-regional instance configs of type GOOGLE_MANAGED, either specify a multi-regional location KMS key or multiple regional location KMS keys that cover all regions in the instance config. * For an instance config of type USER_MANAGED, please specify only regional location KMS keys to cover each region in the instance config. Multi-regional location KMS keys are not supported for USER_MANAGED instance configs.","ref":"GoogleApi.Spanner.V1.Model.CreateBackupEncryptionConfig.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CreateBackupEncryptionConfig.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CreateBackupEncryptionConfig.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CreateBackupEncryptionConfig.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CreateBackupEncryptionConfig.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CreateBackupMetadata","doc":"Metadata type for the operation returned by CreateBackup.","ref":"GoogleApi.Spanner.V1.Model.CreateBackupMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CreateBackupMetadata","doc":"*   `cancelTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which cancellation of this operation was received. Operations.CancelOperation starts asynchronous cancellation on a long-running operation. The server makes a best effort to cancel the operation, but success is not guaranteed. Clients can use Operations.GetOperation or other methods to check whether the cancellation succeeded or whether the operation completed despite cancellation. On successful cancellation, the operation is not deleted; instead, it becomes an operation with an Operation.error value with a google.rpc.Status.code of 1, corresponding to `Code.CANCELLED`.\n*   `database` (*type:* `String.t`, *default:* `nil`) - The name of the database the backup is created from.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The name of the backup being created.\n*   `progress` (*type:* `GoogleApi.Spanner.V1.Model.OperationProgress.t`, *default:* `nil`) - The progress of the CreateBackup operation.","ref":"GoogleApi.Spanner.V1.Model.CreateBackupMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CreateBackupMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CreateBackupMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CreateBackupMetadata.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CreateBackupMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CreateDatabaseMetadata","doc":"Metadata type for the operation returned by CreateDatabase.","ref":"GoogleApi.Spanner.V1.Model.CreateDatabaseMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CreateDatabaseMetadata","doc":"*   `database` (*type:* `String.t`, *default:* `nil`) - The database being created.","ref":"GoogleApi.Spanner.V1.Model.CreateDatabaseMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CreateDatabaseMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CreateDatabaseMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CreateDatabaseMetadata.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CreateDatabaseMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CreateDatabaseRequest","doc":"The request for CreateDatabase.","ref":"GoogleApi.Spanner.V1.Model.CreateDatabaseRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CreateDatabaseRequest","doc":"*   `createStatement` (*type:* `String.t`, *default:* `nil`) - Required. A `CREATE DATABASE` statement, which specifies the ID of the new database. The database ID must conform to the regular expression `a-z*[a-z0-9]` and be between 2 and 30 characters in length. If the database ID is a reserved word or if it contains a hyphen, the database ID must be enclosed in backticks (`` ` ``).\n*   `databaseDialect` (*type:* `String.t`, *default:* `nil`) - Optional. The dialect of the Cloud Spanner Database.\n*   `encryptionConfig` (*type:* `GoogleApi.Spanner.V1.Model.EncryptionConfig.t`, *default:* `nil`) - Optional. The encryption configuration for the database. If this field is not specified, Cloud Spanner will encrypt/decrypt all data at rest using Google default encryption.\n*   `extraStatements` (*type:* `list(String.t)`, *default:* `nil`) - Optional. A list of DDL statements to run inside the newly created database. Statements can create tables, indexes, etc. These statements execute atomically with the creation of the database: if there is an error in any statement, the database is not created.\n*   `protoDescriptors` (*type:* `String.t`, *default:* `nil`) - Optional. Proto descriptors used by `CREATE/ALTER PROTO BUNDLE` statements in 'extra_statements'. Contains a protobuf-serialized [`google.protobuf.FileDescriptorSet`](https://github.com/protocolbuffers/protobuf/blob/main/src/google/protobuf/descriptor.proto) descriptor set. To generate it, [install](https://grpc.io/docs/protoc-installation/) and run `protoc` with --include_imports and --descriptor_set_out. For example, to generate for moon/shot/app.proto, run ``` $protoc --proto_path=/app_path --proto_path=/lib_path \\ --include_imports \\ --descriptor_set_out=descriptors.data \\ moon/shot/app.proto ``` For more details, see protobuffer [self description](https://developers.google.com/protocol-buffers/docs/techniques#self-description).","ref":"GoogleApi.Spanner.V1.Model.CreateDatabaseRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CreateDatabaseRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CreateDatabaseRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CreateDatabaseRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CreateDatabaseRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CreateInstanceConfigMetadata","doc":"Metadata type for the operation returned by CreateInstanceConfig.","ref":"GoogleApi.Spanner.V1.Model.CreateInstanceConfigMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CreateInstanceConfigMetadata","doc":"*   `cancelTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which this operation was cancelled.\n*   `instanceConfig` (*type:* `GoogleApi.Spanner.V1.Model.InstanceConfig.t`, *default:* `nil`) - The target instance configuration end state.\n*   `progress` (*type:* `GoogleApi.Spanner.V1.Model.InstanceOperationProgress.t`, *default:* `nil`) - The progress of the CreateInstanceConfig operation.","ref":"GoogleApi.Spanner.V1.Model.CreateInstanceConfigMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CreateInstanceConfigMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CreateInstanceConfigMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CreateInstanceConfigMetadata.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CreateInstanceConfigMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CreateInstanceConfigRequest","doc":"The request for CreateInstanceConfigRequest.","ref":"GoogleApi.Spanner.V1.Model.CreateInstanceConfigRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CreateInstanceConfigRequest","doc":"*   `instanceConfig` (*type:* `GoogleApi.Spanner.V1.Model.InstanceConfig.t`, *default:* `nil`) - Required. The `InstanceConfig` proto of the configuration to create. `instance_config.name` must be `/instanceConfigs/`. `instance_config.base_config` must be a Google-managed configuration name, e.g. /instanceConfigs/us-east1, /instanceConfigs/nam3.\n*   `instanceConfigId` (*type:* `String.t`, *default:* `nil`) - Required. The ID of the instance configuration to create. Valid identifiers are of the form `custom-[-a-z0-9]*[a-z0-9]` and must be between 2 and 64 characters in length. The `custom-` prefix is required to avoid name conflicts with Google-managed configurations.\n*   `validateOnly` (*type:* `boolean()`, *default:* `nil`) - An option to validate, but not actually execute, a request, and provide the same response.","ref":"GoogleApi.Spanner.V1.Model.CreateInstanceConfigRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CreateInstanceConfigRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CreateInstanceConfigRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CreateInstanceConfigRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CreateInstanceConfigRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CreateInstanceMetadata","doc":"Metadata type for the operation returned by CreateInstance.","ref":"GoogleApi.Spanner.V1.Model.CreateInstanceMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CreateInstanceMetadata","doc":"*   `cancelTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which this operation was cancelled. If set, this operation is in the process of undoing itself (which is guaranteed to succeed) and cannot be cancelled again.\n*   `endTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which this operation failed or was completed successfully.\n*   `expectedFulfillmentPeriod` (*type:* `String.t`, *default:* `nil`) - The expected fulfillment period of this create operation.\n*   `instance` (*type:* `GoogleApi.Spanner.V1.Model.Instance.t`, *default:* `nil`) - The instance being created.\n*   `startTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which the CreateInstance request was received.","ref":"GoogleApi.Spanner.V1.Model.CreateInstanceMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CreateInstanceMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CreateInstanceMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CreateInstanceMetadata.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CreateInstanceMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CreateInstancePartitionMetadata","doc":"Metadata type for the operation returned by CreateInstancePartition.","ref":"GoogleApi.Spanner.V1.Model.CreateInstancePartitionMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CreateInstancePartitionMetadata","doc":"*   `cancelTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which this operation was cancelled. If set, this operation is in the process of undoing itself (which is guaranteed to succeed) and cannot be cancelled again.\n*   `endTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which this operation failed or was completed successfully.\n*   `instancePartition` (*type:* `GoogleApi.Spanner.V1.Model.InstancePartition.t`, *default:* `nil`) - The instance partition being created.\n*   `startTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which the CreateInstancePartition request was received.","ref":"GoogleApi.Spanner.V1.Model.CreateInstancePartitionMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CreateInstancePartitionMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CreateInstancePartitionMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CreateInstancePartitionMetadata.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CreateInstancePartitionMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CreateInstancePartitionRequest","doc":"The request for CreateInstancePartition.","ref":"GoogleApi.Spanner.V1.Model.CreateInstancePartitionRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CreateInstancePartitionRequest","doc":"*   `instancePartition` (*type:* `GoogleApi.Spanner.V1.Model.InstancePartition.t`, *default:* `nil`) - Required. The instance partition to create. The instance_partition.name may be omitted, but if specified must be `/instancePartitions/`.\n*   `instancePartitionId` (*type:* `String.t`, *default:* `nil`) - Required. The ID of the instance partition to create. Valid identifiers are of the form `a-z*[a-z0-9]` and must be between 2 and 64 characters in length.","ref":"GoogleApi.Spanner.V1.Model.CreateInstancePartitionRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CreateInstancePartitionRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CreateInstancePartitionRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CreateInstancePartitionRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CreateInstancePartitionRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CreateInstanceRequest","doc":"The request for CreateInstance.","ref":"GoogleApi.Spanner.V1.Model.CreateInstanceRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CreateInstanceRequest","doc":"*   `instance` (*type:* `GoogleApi.Spanner.V1.Model.Instance.t`, *default:* `nil`) - Required. The instance to create. The name may be omitted, but if specified must be `/instances/`.\n*   `instanceId` (*type:* `String.t`, *default:* `nil`) - Required. The ID of the instance to create. Valid identifiers are of the form `a-z*[a-z0-9]` and must be between 2 and 64 characters in length.","ref":"GoogleApi.Spanner.V1.Model.CreateInstanceRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CreateInstanceRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CreateInstanceRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CreateInstanceRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CreateInstanceRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CreateSessionRequest","doc":"The request for CreateSession.","ref":"GoogleApi.Spanner.V1.Model.CreateSessionRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CreateSessionRequest","doc":"*   `session` (*type:* `GoogleApi.Spanner.V1.Model.Session.t`, *default:* `nil`) - Required. The session to create.","ref":"GoogleApi.Spanner.V1.Model.CreateSessionRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CreateSessionRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CreateSessionRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CreateSessionRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CreateSessionRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.CrontabSpec","doc":"CrontabSpec can be used to specify the version time and frequency at which the backup should be created.","ref":"GoogleApi.Spanner.V1.Model.CrontabSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.CrontabSpec","doc":"*   `creationWindow` (*type:* `String.t`, *default:* `nil`) - Output only. Schedule backups will contain an externally consistent copy of the database at the version time specified in `schedule_spec.cron_spec`. However, Spanner may not initiate the creation of the scheduled backups at that version time. Spanner will initiate the creation of scheduled backups within the time window bounded by the version_time specified in `schedule_spec.cron_spec` and version_time + `creation_window`.\n*   `text` (*type:* `String.t`, *default:* `nil`) - Required. Textual representation of the crontab. User can customize the backup frequency and the backup version time using the cron expression. The version time must be in UTC timzeone. The backup will contain an externally consistent copy of the database at the version time. Allowed frequencies are 12 hour, 1 day, 1 week and 1 month. Examples of valid cron specifications: * `0 2/12 * * * ` : every 12 hours at (2, 14) hours past midnight in UTC. * `0 2,14 * * * ` : every 12 hours at (2,14) hours past midnight in UTC. * `0 2 * * * ` : once a day at 2 past midnight in UTC. * `0 2 * * 0 ` : once a week every Sunday at 2 past midnight in UTC. * `0 2 8 * * ` : once a month on 8th day at 2 past midnight in UTC.\n*   `timeZone` (*type:* `String.t`, *default:* `nil`) - Output only. The time zone of the times in `CrontabSpec.text`. Currently only UTC is supported.","ref":"GoogleApi.Spanner.V1.Model.CrontabSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.CrontabSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.CrontabSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.CrontabSpec.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.CrontabSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Database","doc":"A Cloud Spanner database.","ref":"GoogleApi.Spanner.V1.Model.Database.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Database","doc":"*   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. If exists, the time at which the database creation started.\n*   `databaseDialect` (*type:* `String.t`, *default:* `nil`) - Output only. The dialect of the Cloud Spanner Database.\n*   `defaultLeader` (*type:* `String.t`, *default:* `nil`) - Output only. The read-write region which contains the database's leader replicas. This is the same as the value of default_leader database option set using DatabaseAdmin.CreateDatabase or DatabaseAdmin.UpdateDatabaseDdl. If not explicitly set, this is empty.\n*   `earliestVersionTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. Earliest timestamp at which older versions of the data can be read. This value is continuously updated by Cloud Spanner and becomes stale the moment it is queried. If you are using this value to recover data, make sure to account for the time from the moment when the value is queried to the moment when you initiate the recovery.\n*   `enableDropProtection` (*type:* `boolean()`, *default:* `nil`) - Optional. Whether drop protection is enabled for this database. Defaults to false, if not set. For more details, please see how to [prevent accidental database deletion](https://cloud.google.com/spanner/docs/prevent-database-deletion).\n*   `encryptionConfig` (*type:* `GoogleApi.Spanner.V1.Model.EncryptionConfig.t`, *default:* `nil`) - Output only. For databases that are using customer managed encryption, this field contains the encryption configuration for the database. For databases that are using Google default or other types of encryption, this field is empty.\n*   `encryptionInfo` (*type:* `list(GoogleApi.Spanner.V1.Model.EncryptionInfo.t)`, *default:* `nil`) - Output only. For databases that are using customer managed encryption, this field contains the encryption information for the database, such as all Cloud KMS key versions that are in use. The `encryption_status' field inside of each `EncryptionInfo` is not populated. For databases that are using Google default or other types of encryption, this field is empty. This field is propagated lazily from the backend. There might be a delay from when a key version is being used and when it appears in this field.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Required. The name of the database. Values are of the form `projects//instances//databases/`, where `` is as specified in the `CREATE DATABASE` statement. This name can be passed to other API methods to identify the database.\n*   `quorumInfo` (*type:* `GoogleApi.Spanner.V1.Model.QuorumInfo.t`, *default:* `nil`) - Output only. Applicable only for databases that use dual-region instance configurations. Contains information about the quorum.\n*   `reconciling` (*type:* `boolean()`, *default:* `nil`) - Output only. If true, the database is being updated. If false, there are no ongoing update operations for the database.\n*   `restoreInfo` (*type:* `GoogleApi.Spanner.V1.Model.RestoreInfo.t`, *default:* `nil`) - Output only. Applicable only for restored databases. Contains information about the restore source.\n*   `state` (*type:* `String.t`, *default:* `nil`) - Output only. The current database state.\n*   `versionRetentionPeriod` (*type:* `String.t`, *default:* `nil`) - Output only. The period in which Cloud Spanner retains all versions of data for the database. This is the same as the value of version_retention_period database option set using UpdateDatabaseDdl. Defaults to 1 hour, if not set.","ref":"GoogleApi.Spanner.V1.Model.Database.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Database.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Database.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Database.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Database.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.DatabaseRole","doc":"A Cloud Spanner database role.","ref":"GoogleApi.Spanner.V1.Model.DatabaseRole.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.DatabaseRole","doc":"*   `name` (*type:* `String.t`, *default:* `nil`) - Required. The name of the database role. Values are of the form `projects//instances//databases//databaseRoles/` where `` is as specified in the `CREATE ROLE` DDL statement.","ref":"GoogleApi.Spanner.V1.Model.DatabaseRole.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.DatabaseRole.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.DatabaseRole.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.DatabaseRole.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.DatabaseRole.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.DdlStatementActionInfo","doc":"Action information extracted from a DDL statement. This proto is used to display the brief info of the DDL statement for the operation UpdateDatabaseDdl.","ref":"GoogleApi.Spanner.V1.Model.DdlStatementActionInfo.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.DdlStatementActionInfo","doc":"*   `action` (*type:* `String.t`, *default:* `nil`) - The action for the DDL statement, e.g. CREATE, ALTER, DROP, GRANT, etc. This field is a non-empty string.\n*   `entityNames` (*type:* `list(String.t)`, *default:* `nil`) - The entity name(s) being operated on the DDL statement. E.g. 1. For statement \"CREATE TABLE t1(...)\", `entity_names` = [\"t1\"]. 2. For statement \"GRANT ROLE r1, r2 ...\", `entity_names` = [\"r1\", \"r2\"]. 3. For statement \"ANALYZE\", `entity_names` = [].\n*   `entityType` (*type:* `String.t`, *default:* `nil`) - The entity type for the DDL statement, e.g. TABLE, INDEX, VIEW, etc. This field can be empty string for some DDL statement, e.g. for statement \"ANALYZE\", `entity_type` = \"\".","ref":"GoogleApi.Spanner.V1.Model.DdlStatementActionInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.DdlStatementActionInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.DdlStatementActionInfo.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.DdlStatementActionInfo.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.DdlStatementActionInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Delete","doc":"Arguments to delete operations.","ref":"GoogleApi.Spanner.V1.Model.Delete.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Delete","doc":"*   `keySet` (*type:* `GoogleApi.Spanner.V1.Model.KeySet.t`, *default:* `nil`) - Required. The primary keys of the rows within table to delete. The primary keys must be specified in the order in which they appear in the `PRIMARY KEY()` clause of the table's equivalent DDL statement (the DDL statement used to create the table). Delete is idempotent. The transaction will succeed even if some or all rows do not exist.\n*   `table` (*type:* `String.t`, *default:* `nil`) - Required. The table whose rows will be deleted.","ref":"GoogleApi.Spanner.V1.Model.Delete.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Delete.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Delete.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Delete.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Delete.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.DerivedMetric","doc":"A message representing a derived metric.","ref":"GoogleApi.Spanner.V1.Model.DerivedMetric.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.DerivedMetric","doc":"*   `denominator` (*type:* `GoogleApi.Spanner.V1.Model.LocalizedString.t`, *default:* `nil`) - The name of the denominator metric. e.g. \"rows\".\n*   `numerator` (*type:* `GoogleApi.Spanner.V1.Model.LocalizedString.t`, *default:* `nil`) - The name of the numerator metric. e.g. \"latency\".","ref":"GoogleApi.Spanner.V1.Model.DerivedMetric.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.DerivedMetric.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.DerivedMetric.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.DerivedMetric.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.DerivedMetric.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.DiagnosticMessage","doc":"A message representing the key visualizer diagnostic messages.","ref":"GoogleApi.Spanner.V1.Model.DiagnosticMessage.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.DiagnosticMessage","doc":"*   `info` (*type:* `GoogleApi.Spanner.V1.Model.LocalizedString.t`, *default:* `nil`) - Information about this diagnostic information.\n*   `metric` (*type:* `GoogleApi.Spanner.V1.Model.LocalizedString.t`, *default:* `nil`) - The metric.\n*   `metricSpecific` (*type:* `boolean()`, *default:* `nil`) - Whether this message is specific only for the current metric. By default Diagnostics are shown for all metrics, regardless which metric is the currently selected metric in the UI. However occasionally a metric will generate so many messages that the resulting visual clutter becomes overwhelming. In this case setting this to true, will show the diagnostic messages for that metric only if it is the currently selected metric.\n*   `severity` (*type:* `String.t`, *default:* `nil`) - The severity of the diagnostic message.\n*   `shortMessage` (*type:* `GoogleApi.Spanner.V1.Model.LocalizedString.t`, *default:* `nil`) - The short message.","ref":"GoogleApi.Spanner.V1.Model.DiagnosticMessage.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.DiagnosticMessage.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.DiagnosticMessage.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.DiagnosticMessage.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.DiagnosticMessage.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.DirectedReadOptions","doc":"The DirectedReadOptions can be used to indicate which replicas or regions should be used for non-transactional reads or queries. DirectedReadOptions may only be specified for a read-only transaction, otherwise the API will return an `INVALID_ARGUMENT` error.","ref":"GoogleApi.Spanner.V1.Model.DirectedReadOptions.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.DirectedReadOptions","doc":"*   `excludeReplicas` (*type:* `GoogleApi.Spanner.V1.Model.ExcludeReplicas.t`, *default:* `nil`) - Exclude_replicas indicates that specified replicas should be excluded from serving requests. Spanner will not route requests to the replicas in this list.\n*   `includeReplicas` (*type:* `GoogleApi.Spanner.V1.Model.IncludeReplicas.t`, *default:* `nil`) - Include_replicas indicates the order of replicas (as they appear in this list) to process the request. If auto_failover_disabled is set to true and all replicas are exhausted without finding a healthy replica, Spanner will wait for a replica in the list to become available, requests may fail due to `DEADLINE_EXCEEDED` errors.","ref":"GoogleApi.Spanner.V1.Model.DirectedReadOptions.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.DirectedReadOptions.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.DirectedReadOptions.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.DirectedReadOptions.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.DirectedReadOptions.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.DualRegionQuorum","doc":"Message type for a dual-region quorum. Currently this type has no options.","ref":"GoogleApi.Spanner.V1.Model.DualRegionQuorum.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.DualRegionQuorum","doc":"","ref":"GoogleApi.Spanner.V1.Model.DualRegionQuorum.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.DualRegionQuorum.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.DualRegionQuorum.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.DualRegionQuorum.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.DualRegionQuorum.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Empty","doc":"A generic empty message that you can re-use to avoid defining duplicated empty messages in your APIs. A typical example is to use it as the request or the response type of an API method. For instance: service Foo { rpc Bar(google.protobuf.Empty) returns (google.protobuf.Empty); }","ref":"GoogleApi.Spanner.V1.Model.Empty.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Empty","doc":"","ref":"GoogleApi.Spanner.V1.Model.Empty.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Empty.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Empty.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Empty.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Empty.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.EncryptionConfig","doc":"Encryption configuration for a Cloud Spanner database.","ref":"GoogleApi.Spanner.V1.Model.EncryptionConfig.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.EncryptionConfig","doc":"*   `kmsKeyName` (*type:* `String.t`, *default:* `nil`) - The Cloud KMS key to be used for encrypting and decrypting the database. Values are of the form `projects//locations//keyRings//cryptoKeys/`.\n*   `kmsKeyNames` (*type:* `list(String.t)`, *default:* `nil`) - Specifies the KMS configuration for the one or more keys used to encrypt the database. Values are of the form `projects//locations//keyRings//cryptoKeys/`. The keys referenced by kms_key_names must fully cover all regions of the database instance configuration. Some examples: * For single region database instance configs, specify a single regional location KMS key. * For multi-regional database instance configs of type GOOGLE_MANAGED, either specify a multi-regional location KMS key or multiple regional location KMS keys that cover all regions in the instance config. * For a database instance config of type USER_MANAGED, please specify only regional location KMS keys to cover each region in the instance config. Multi-regional location KMS keys are not supported for USER_MANAGED instance configs.","ref":"GoogleApi.Spanner.V1.Model.EncryptionConfig.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.EncryptionConfig.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.EncryptionConfig.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.EncryptionConfig.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.EncryptionConfig.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.EncryptionInfo","doc":"Encryption information for a Cloud Spanner database or backup.","ref":"GoogleApi.Spanner.V1.Model.EncryptionInfo.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.EncryptionInfo","doc":"*   `encryptionStatus` (*type:* `GoogleApi.Spanner.V1.Model.Status.t`, *default:* `nil`) - Output only. If present, the status of a recent encrypt/decrypt call on underlying data for this database or backup. Regardless of status, data is always encrypted at rest.\n*   `encryptionType` (*type:* `String.t`, *default:* `nil`) - Output only. The type of encryption.\n*   `kmsKeyVersion` (*type:* `String.t`, *default:* `nil`) - Output only. A Cloud KMS key version that is being used to protect the database or backup.","ref":"GoogleApi.Spanner.V1.Model.EncryptionInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.EncryptionInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.EncryptionInfo.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.EncryptionInfo.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.EncryptionInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ExcludeReplicas","doc":"An ExcludeReplicas contains a repeated set of ReplicaSelection that should be excluded from serving requests.","ref":"GoogleApi.Spanner.V1.Model.ExcludeReplicas.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ExcludeReplicas","doc":"*   `replicaSelections` (*type:* `list(GoogleApi.Spanner.V1.Model.ReplicaSelection.t)`, *default:* `nil`) - The directed read replica selector.","ref":"GoogleApi.Spanner.V1.Model.ExcludeReplicas.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ExcludeReplicas.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ExcludeReplicas.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ExcludeReplicas.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ExcludeReplicas.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlRequest","doc":"The request for ExecuteBatchDml.","ref":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ExecuteBatchDmlRequest","doc":"*   `requestOptions` (*type:* `GoogleApi.Spanner.V1.Model.RequestOptions.t`, *default:* `nil`) - Common options for this request.\n*   `seqno` (*type:* `String.t`, *default:* `nil`) - Required. A per-transaction sequence number used to identify this request. This field makes each request idempotent such that if the request is received multiple times, at most one will succeed. The sequence number must be monotonically increasing within the transaction. If a request arrives for the first time with an out-of-order sequence number, the transaction may be aborted. Replays of previously handled requests will yield the same response as the first execution.\n*   `statements` (*type:* `list(GoogleApi.Spanner.V1.Model.Statement.t)`, *default:* `nil`) - Required. The list of statements to execute in this batch. Statements are executed serially, such that the effects of statement `i` are visible to statement `i+1`. Each statement must be a DML statement. Execution stops at the first failed statement; the remaining statements are not executed. Callers must provide at least one statement.\n*   `transaction` (*type:* `GoogleApi.Spanner.V1.Model.TransactionSelector.t`, *default:* `nil`) - Required. The transaction to use. Must be a read-write transaction. To protect against replays, single-use transactions are not supported. The caller must either supply an existing transaction ID or begin a new transaction.","ref":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlResponse","doc":"The response for ExecuteBatchDml. Contains a list of ResultSet messages, one for each DML statement that has successfully executed, in the same order as the statements in the request. If a statement fails, the status in the response body identifies the cause of the failure. To check for DML statements that failed, use the following approach: 1. Check the status in the response message. The google.rpc.Code enum value `OK` indicates that all statements were executed successfully. 2. If the status was not `OK`, check the number of result sets in the response. If the response contains `N` ResultSet messages, then statement `N+1` in the request failed. Example 1: * Request: 5 DML statements, all executed successfully. * Response: 5 ResultSet messages, with the status `OK`. Example 2: * Request: 5 DML statements. The third statement has a syntax error. * Response: 2 ResultSet messages, and a syntax error (`INVALID_ARGUMENT`) status. The number of ResultSet messages indicates that the third statement failed, and the fourth and fifth statements were not executed.","ref":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ExecuteBatchDmlResponse","doc":"*   `resultSets` (*type:* `list(GoogleApi.Spanner.V1.Model.ResultSet.t)`, *default:* `nil`) - One ResultSet for each statement in the request that ran successfully, in the same order as the statements in the request. Each ResultSet does not contain any rows. The ResultSetStats in each ResultSet contain the number of rows modified by the statement. Only the first ResultSet in the response contains valid ResultSetMetadata.\n*   `status` (*type:* `GoogleApi.Spanner.V1.Model.Status.t`, *default:* `nil`) - If all DML statements are executed successfully, the status is `OK`. Otherwise, the error status of the first failed statement.","ref":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ExecuteBatchDmlResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ExecuteSqlRequest","doc":"The request for ExecuteSql and ExecuteStreamingSql.","ref":"GoogleApi.Spanner.V1.Model.ExecuteSqlRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ExecuteSqlRequest","doc":"*   `dataBoostEnabled` (*type:* `boolean()`, *default:* `nil`) - If this is for a partitioned query and this field is set to `true`, the request is executed with Spanner Data Boost independent compute resources. If the field is set to `true` but the request does not set `partition_token`, the API returns an `INVALID_ARGUMENT` error.\n*   `directedReadOptions` (*type:* `GoogleApi.Spanner.V1.Model.DirectedReadOptions.t`, *default:* `nil`) - Directed read options for this request.\n*   `paramTypes` (*type:* `%{optional(String.t) => GoogleApi.Spanner.V1.Model.Type.t}`, *default:* `nil`) - It is not always possible for Cloud Spanner to infer the right SQL type from a JSON value. For example, values of type `BYTES` and values of type `STRING` both appear in params as JSON strings. In these cases, `param_types` can be used to specify the exact SQL type for some or all of the SQL statement parameters. See the definition of Type for more information about SQL types.\n*   `params` (*type:* `map()`, *default:* `nil`) - Parameter names and values that bind to placeholders in the SQL string. A parameter placeholder consists of the `@` character followed by the parameter name (for example, `@firstName`). Parameter names must conform to the naming requirements of identifiers as specified at https://cloud.google.com/spanner/docs/lexical#identifiers. Parameters can appear anywhere that a literal value is expected. The same parameter name can be used more than once, for example: `\"WHERE id > @msg_id AND id < @msg_id + 100\"` It is an error to execute a SQL statement with unbound parameters.\n*   `partitionToken` (*type:* `String.t`, *default:* `nil`) - If present, results will be restricted to the specified partition previously created using PartitionQuery(). There must be an exact match for the values of fields common to this message and the PartitionQueryRequest message used to create this partition_token.\n*   `queryMode` (*type:* `String.t`, *default:* `nil`) - Used to control the amount of debugging information returned in ResultSetStats. If partition_token is set, query_mode can only be set to QueryMode.NORMAL.\n*   `queryOptions` (*type:* `GoogleApi.Spanner.V1.Model.QueryOptions.t`, *default:* `nil`) - Query optimizer configuration to use for the given query.\n*   `requestOptions` (*type:* `GoogleApi.Spanner.V1.Model.RequestOptions.t`, *default:* `nil`) - Common options for this request.\n*   `resumeToken` (*type:* `String.t`, *default:* `nil`) - If this request is resuming a previously interrupted SQL statement execution, `resume_token` should be copied from the last PartialResultSet yielded before the interruption. Doing this enables the new SQL statement execution to resume where the last one left off. The rest of the request parameters must exactly match the request that yielded this token.\n*   `seqno` (*type:* `String.t`, *default:* `nil`) - A per-transaction sequence number used to identify this request. This field makes each request idempotent such that if the request is received multiple times, at most one will succeed. The sequence number must be monotonically increasing within the transaction. If a request arrives for the first time with an out-of-order sequence number, the transaction may be aborted. Replays of previously handled requests will yield the same response as the first execution. Required for DML statements. Ignored for queries.\n*   `sql` (*type:* `String.t`, *default:* `nil`) - Required. The SQL string.\n*   `transaction` (*type:* `GoogleApi.Spanner.V1.Model.TransactionSelector.t`, *default:* `nil`) - The transaction to use. For queries, if none is provided, the default is a temporary read-only transaction with strong concurrency. Standard DML statements require a read-write transaction. To protect against replays, single-use transactions are not supported. The caller must either supply an existing transaction ID or begin a new transaction. Partitioned DML requires an existing Partitioned DML transaction ID.","ref":"GoogleApi.Spanner.V1.Model.ExecuteSqlRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ExecuteSqlRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ExecuteSqlRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ExecuteSqlRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ExecuteSqlRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Expr","doc":"Represents a textual expression in the Common Expression Language (CEL) syntax. CEL is a C-like expression language. The syntax and semantics of CEL are documented at https://github.com/google/cel-spec. Example (Comparison): title: \"Summary size limit\" description: \"Determines if a summary is less than 100 chars\" expression: \"document.summary.size() < 100\" Example (Equality): title: \"Requestor is owner\" description: \"Determines if requestor is the document owner\" expression: \"document.owner == request.auth.claims.email\" Example (Logic): title: \"Public documents\" description: \"Determine whether the document should be publicly visible\" expression: \"document.type != 'private' && document.type != 'internal'\" Example (Data Manipulation): title: \"Notification string\" description: \"Create a notification string with a timestamp.\" expression: \"'New message received at ' + string(document.create_time)\" The exact variables and functions that may be referenced within an expression are determined by the service that evaluates it. See the service documentation for additional information.","ref":"GoogleApi.Spanner.V1.Model.Expr.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Expr","doc":"*   `description` (*type:* `String.t`, *default:* `nil`) - Optional. Description of the expression. This is a longer text which describes the expression, e.g. when hovered over it in a UI.\n*   `expression` (*type:* `String.t`, *default:* `nil`) - Textual representation of an expression in Common Expression Language syntax.\n*   `location` (*type:* `String.t`, *default:* `nil`) - Optional. String indicating the location of the expression for error reporting, e.g. a file name and a position in the file.\n*   `title` (*type:* `String.t`, *default:* `nil`) - Optional. Title for the expression, i.e. a short string describing its purpose. This can be used e.g. in UIs which allow to enter the expression.","ref":"GoogleApi.Spanner.V1.Model.Expr.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Expr.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Expr.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Expr.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Expr.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Field","doc":"Message representing a single field of a struct.","ref":"GoogleApi.Spanner.V1.Model.Field.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Field","doc":"*   `name` (*type:* `String.t`, *default:* `nil`) - The name of the field. For reads, this is the column name. For SQL queries, it is the column alias (e.g., `\"Word\"` in the query `\"SELECT 'hello' AS Word\"`), or the column name (e.g., `\"ColName\"` in the query `\"SELECT ColName FROM Table\"`). Some columns might have an empty name (e.g., `\"SELECT UPPER(ColName)\"`). Note that a query result can contain multiple fields with the same name.\n*   `type` (*type:* `GoogleApi.Spanner.V1.Model.Type.t`, *default:* `nil`) - The type of the field.","ref":"GoogleApi.Spanner.V1.Model.Field.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Field.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Field.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Field.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Field.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.FreeInstanceMetadata","doc":"Free instance specific metadata that is kept even after an instance has been upgraded for tracking purposes.","ref":"GoogleApi.Spanner.V1.Model.FreeInstanceMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.FreeInstanceMetadata","doc":"*   `expireBehavior` (*type:* `String.t`, *default:* `nil`) - Specifies the expiration behavior of a free instance. The default of ExpireBehavior is `REMOVE_AFTER_GRACE_PERIOD`. This can be modified during or after creation, and before expiration.\n*   `expireTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. Timestamp after which the instance will either be upgraded or scheduled for deletion after a grace period. ExpireBehavior is used to choose between upgrading or scheduling the free instance for deletion. This timestamp is set during the creation of a free instance.\n*   `upgradeTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. If present, the timestamp at which the free instance was upgraded to a provisioned instance.","ref":"GoogleApi.Spanner.V1.Model.FreeInstanceMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.FreeInstanceMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.FreeInstanceMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.FreeInstanceMetadata.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.FreeInstanceMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.FullBackupSpec","doc":"The specification for full backups. A full backup stores the entire contents of the database at a given version time.","ref":"GoogleApi.Spanner.V1.Model.FullBackupSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.FullBackupSpec","doc":"","ref":"GoogleApi.Spanner.V1.Model.FullBackupSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.FullBackupSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.FullBackupSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.FullBackupSpec.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.FullBackupSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.GetDatabaseDdlResponse","doc":"The response for GetDatabaseDdl.","ref":"GoogleApi.Spanner.V1.Model.GetDatabaseDdlResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.GetDatabaseDdlResponse","doc":"*   `protoDescriptors` (*type:* `String.t`, *default:* `nil`) - Proto descriptors stored in the database. Contains a protobuf-serialized [google.protobuf.FileDescriptorSet](https://github.com/protocolbuffers/protobuf/blob/main/src/google/protobuf/descriptor.proto). For more details, see protobuffer [self description](https://developers.google.com/protocol-buffers/docs/techniques#self-description).\n*   `statements` (*type:* `list(String.t)`, *default:* `nil`) - A list of formatted DDL statements defining the schema of the database specified in the request.","ref":"GoogleApi.Spanner.V1.Model.GetDatabaseDdlResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.GetDatabaseDdlResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.GetDatabaseDdlResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.GetDatabaseDdlResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.GetDatabaseDdlResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.GetIamPolicyRequest","doc":"Request message for `GetIamPolicy` method.","ref":"GoogleApi.Spanner.V1.Model.GetIamPolicyRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.GetIamPolicyRequest","doc":"*   `options` (*type:* `GoogleApi.Spanner.V1.Model.GetPolicyOptions.t`, *default:* `nil`) - OPTIONAL: A `GetPolicyOptions` object for specifying options to `GetIamPolicy`.","ref":"GoogleApi.Spanner.V1.Model.GetIamPolicyRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.GetIamPolicyRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.GetIamPolicyRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.GetIamPolicyRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.GetIamPolicyRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.GetPolicyOptions","doc":"Encapsulates settings provided to GetIamPolicy.","ref":"GoogleApi.Spanner.V1.Model.GetPolicyOptions.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.GetPolicyOptions","doc":"*   `requestedPolicyVersion` (*type:* `integer()`, *default:* `nil`) - Optional. The maximum policy version that will be used to format the policy. Valid values are 0, 1, and 3. Requests specifying an invalid value will be rejected. Requests for policies with any conditional role bindings must specify version 3. Policies with no conditional role bindings may specify any valid value or leave the field unset. The policy in the response might use the policy version that you specified, or it might use a lower policy version. For example, if you specify version 3, but the policy has no conditional role bindings, the response uses version 1. To learn which resources support conditions in their IAM policies, see the [IAM documentation](https://cloud.google.com/iam/help/conditions/resource-policies).","ref":"GoogleApi.Spanner.V1.Model.GetPolicyOptions.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.GetPolicyOptions.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.GetPolicyOptions.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.GetPolicyOptions.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.GetPolicyOptions.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.IncludeReplicas","doc":"An IncludeReplicas contains a repeated set of ReplicaSelection which indicates the order in which replicas should be considered.","ref":"GoogleApi.Spanner.V1.Model.IncludeReplicas.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.IncludeReplicas","doc":"*   `autoFailoverDisabled` (*type:* `boolean()`, *default:* `nil`) - If true, Spanner will not route requests to a replica outside the include_replicas list when all of the specified replicas are unavailable or unhealthy. Default value is `false`.\n*   `replicaSelections` (*type:* `list(GoogleApi.Spanner.V1.Model.ReplicaSelection.t)`, *default:* `nil`) - The directed read replica selector.","ref":"GoogleApi.Spanner.V1.Model.IncludeReplicas.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.IncludeReplicas.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.IncludeReplicas.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.IncludeReplicas.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.IncludeReplicas.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.IncrementalBackupSpec","doc":"The specification for incremental backup chains. An incremental backup stores the delta of changes between a previous backup and the database contents at a given version time. An incremental backup chain consists of a full backup and zero or more successive incremental backups. The first backup created for an incremental backup chain is always a full backup.","ref":"GoogleApi.Spanner.V1.Model.IncrementalBackupSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.IncrementalBackupSpec","doc":"","ref":"GoogleApi.Spanner.V1.Model.IncrementalBackupSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.IncrementalBackupSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.IncrementalBackupSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.IncrementalBackupSpec.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.IncrementalBackupSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.IndexAdvice","doc":"Recommendation to add new indexes to run queries more efficiently.","ref":"GoogleApi.Spanner.V1.Model.IndexAdvice.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.IndexAdvice","doc":"*   `ddl` (*type:* `list(String.t)`, *default:* `nil`) - Optional. DDL statements to add new indexes that will improve the query.\n*   `improvementFactor` (*type:* `float()`, *default:* `nil`) - Optional. Estimated latency improvement factor. For example if the query currently takes 500 ms to run and the estimated latency with new indexes is 100 ms this field will be 5.","ref":"GoogleApi.Spanner.V1.Model.IndexAdvice.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.IndexAdvice.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.IndexAdvice.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.IndexAdvice.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.IndexAdvice.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.IndexedHotKey","doc":"A message representing a (sparse) collection of hot keys for specific key buckets.","ref":"GoogleApi.Spanner.V1.Model.IndexedHotKey.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.IndexedHotKey","doc":"*   `sparseHotKeys` (*type:* `map()`, *default:* `nil`) - A (sparse) mapping from key bucket index to the index of the specific hot row key for that key bucket. The index of the hot row key can be translated to the actual row key via the ScanData.VisualizationData.indexed_keys repeated field.","ref":"GoogleApi.Spanner.V1.Model.IndexedHotKey.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.IndexedHotKey.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.IndexedHotKey.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.IndexedHotKey.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.IndexedHotKey.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.IndexedKeyRangeInfos","doc":"A message representing a (sparse) collection of KeyRangeInfos for specific key buckets.","ref":"GoogleApi.Spanner.V1.Model.IndexedKeyRangeInfos.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.IndexedKeyRangeInfos","doc":"*   `keyRangeInfos` (*type:* `%{optional(String.t) => GoogleApi.Spanner.V1.Model.KeyRangeInfos.t}`, *default:* `nil`) - A (sparse) mapping from key bucket index to the KeyRangeInfos for that key bucket.","ref":"GoogleApi.Spanner.V1.Model.IndexedKeyRangeInfos.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.IndexedKeyRangeInfos.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.IndexedKeyRangeInfos.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.IndexedKeyRangeInfos.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.IndexedKeyRangeInfos.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Instance","doc":"An isolated set of Cloud Spanner resources on which databases can be hosted.","ref":"GoogleApi.Spanner.V1.Model.Instance.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Instance","doc":"*   `autoscalingConfig` (*type:* `GoogleApi.Spanner.V1.Model.AutoscalingConfig.t`, *default:* `nil`) - Optional. The autoscaling configuration. Autoscaling is enabled if this field is set. When autoscaling is enabled, node_count and processing_units are treated as OUTPUT_ONLY fields and reflect the current compute capacity allocated to the instance.\n*   `config` (*type:* `String.t`, *default:* `nil`) - Required. The name of the instance's configuration. Values are of the form `projects//instanceConfigs/`. See also InstanceConfig and ListInstanceConfigs.\n*   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The time at which the instance was created.\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - Required. The descriptive name for this instance as it appears in UIs. Must be unique per project and between 4 and 30 characters in length.\n*   `edition` (*type:* `String.t`, *default:* `nil`) - Optional. The `Edition` of the current instance.\n*   `endpointUris` (*type:* `list(String.t)`, *default:* `nil`) - Deprecated. This field is not populated.\n*   `freeInstanceMetadata` (*type:* `GoogleApi.Spanner.V1.Model.FreeInstanceMetadata.t`, *default:* `nil`) - Free instance metadata. Only populated for free instances.\n*   `instanceType` (*type:* `String.t`, *default:* `nil`) - The `InstanceType` of the current instance.\n*   `labels` (*type:* `map()`, *default:* `nil`) - Cloud Labels are a flexible and lightweight mechanism for organizing cloud resources into groups that reflect a customer's organizational needs and deployment strategies. Cloud Labels can be used to filter collections of resources. They can be used to control how resource metrics are aggregated. And they can be used as arguments to policy management rules (e.g. route, firewall, load balancing, etc.). * Label keys must be between 1 and 63 characters long and must conform to the following regular expression: `a-z{0,62}`. * Label values must be between 0 and 63 characters long and must conform to the regular expression `[a-z0-9_-]{0,63}`. * No more than 64 labels can be associated with a given resource. See https://goo.gl/xmQnxf for more information on and examples of labels. If you plan to use labels in your own code, please note that additional characters may be allowed in the future. And so you are advised to use an internal label representation, such as JSON, which doesn't rely upon specific characters being disallowed. For example, representing labels as the string: name + \"_\" + value would prove problematic if we were to allow \"_\" in a future release.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Required. A unique identifier for the instance, which cannot be changed after the instance is created. Values are of the form `projects//instances/a-z*[a-z0-9]`. The final segment of the name must be between 2 and 64 characters in length.\n*   `nodeCount` (*type:* `integer()`, *default:* `nil`) - The number of nodes allocated to this instance. At most, one of either `node_count` or `processing_units` should be present in the message. Users can set the `node_count` field to specify the target number of nodes allocated to the instance. If autoscaling is enabled, `node_count` is treated as an `OUTPUT_ONLY` field and reflects the current number of nodes allocated to the instance. This might be zero in API responses for instances that are not yet in the `READY` state. For more information, see [Compute capacity, nodes, and processing units](https://cloud.google.com/spanner/docs/compute-capacity).\n*   `processingUnits` (*type:* `integer()`, *default:* `nil`) - The number of processing units allocated to this instance. At most, one of either `processing_units` or `node_count` should be present in the message. Users can set the `processing_units` field to specify the target number of processing units allocated to the instance. If autoscaling is enabled, `processing_units` is treated as an `OUTPUT_ONLY` field and reflects the current number of processing units allocated to the instance. This might be zero in API responses for instances that are not yet in the `READY` state. For more information, see [Compute capacity, nodes and processing units](https://cloud.google.com/spanner/docs/compute-capacity).\n*   `state` (*type:* `String.t`, *default:* `nil`) - Output only. The current instance state. For CreateInstance, the state must be either omitted or set to `CREATING`. For UpdateInstance, the state must be either omitted or set to `READY`.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The time at which the instance was most recently updated.","ref":"GoogleApi.Spanner.V1.Model.Instance.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Instance.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Instance.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Instance.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Instance.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.InstanceConfig","doc":"A possible configuration for a Cloud Spanner instance. Configurations define the geographic placement of nodes and their replication.","ref":"GoogleApi.Spanner.V1.Model.InstanceConfig.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.InstanceConfig","doc":"*   `baseConfig` (*type:* `String.t`, *default:* `nil`) - Base configuration name, e.g. projects//instanceConfigs/nam3, based on which this configuration is created. Only set for user-managed configurations. `base_config` must refer to a configuration of type `GOOGLE_MANAGED` in the same project as this configuration.\n*   `configType` (*type:* `String.t`, *default:* `nil`) - Output only. Whether this instance configuration is a Google-managed or user-managed configuration.\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - The name of this instance configuration as it appears in UIs.\n*   `etag` (*type:* `String.t`, *default:* `nil`) - etag is used for optimistic concurrency control as a way to help prevent simultaneous updates of a instance configuration from overwriting each other. It is strongly suggested that systems make use of the etag in the read-modify-write cycle to perform instance configuration updates in order to avoid race conditions: An etag is returned in the response which contains instance configurations, and systems are expected to put that etag in the request to update instance configuration to ensure that their change is applied to the same version of the instance configuration. If no etag is provided in the call to update the instance configuration, then the existing instance configuration is overwritten blindly.\n*   `freeInstanceAvailability` (*type:* `String.t`, *default:* `nil`) - Output only. Describes whether free instances are available to be created in this instance configuration.\n*   `labels` (*type:* `map()`, *default:* `nil`) - Cloud Labels are a flexible and lightweight mechanism for organizing cloud resources into groups that reflect a customer's organizational needs and deployment strategies. Cloud Labels can be used to filter collections of resources. They can be used to control how resource metrics are aggregated. And they can be used as arguments to policy management rules (e.g. route, firewall, load balancing, etc.). * Label keys must be between 1 and 63 characters long and must conform to the following regular expression: `a-z{0,62}`. * Label values must be between 0 and 63 characters long and must conform to the regular expression `[a-z0-9_-]{0,63}`. * No more than 64 labels can be associated with a given resource. See https://goo.gl/xmQnxf for more information on and examples of labels. If you plan to use labels in your own code, please note that additional characters may be allowed in the future. Therefore, you are advised to use an internal label representation, such as JSON, which doesn't rely upon specific characters being disallowed. For example, representing labels as the string: name + \"_\" + value would prove problematic if we were to allow \"_\" in a future release.\n*   `leaderOptions` (*type:* `list(String.t)`, *default:* `nil`) - Allowed values of the \"default_leader\" schema option for databases in instances that use this instance configuration.\n*   `name` (*type:* `String.t`, *default:* `nil`) - A unique identifier for the instance configuration. Values are of the form `projects//instanceConfigs/a-z*`. User instance configuration must start with `custom-`.\n*   `optionalReplicas` (*type:* `list(GoogleApi.Spanner.V1.Model.ReplicaInfo.t)`, *default:* `nil`) - Output only. The available optional replicas to choose from for user-managed configurations. Populated for Google-managed configurations.\n*   `quorumType` (*type:* `String.t`, *default:* `nil`) - Output only. The `QuorumType` of the instance configuration.\n*   `reconciling` (*type:* `boolean()`, *default:* `nil`) - Output only. If true, the instance configuration is being created or updated. If false, there are no ongoing operations for the instance configuration.\n*   `replicas` (*type:* `list(GoogleApi.Spanner.V1.Model.ReplicaInfo.t)`, *default:* `nil`) - The geographic placement of nodes in this instance configuration and their replication properties. To create user-managed configurations, input `replicas` must include all replicas in `replicas` of the `base_config` and include one or more replicas in the `optional_replicas` of the `base_config`.\n*   `state` (*type:* `String.t`, *default:* `nil`) - Output only. The current instance configuration state. Applicable only for `USER_MANAGED` configurations.\n*   `storageLimitPerProcessingUnit` (*type:* `String.t`, *default:* `nil`) - Output only. The storage limit in bytes per processing unit.","ref":"GoogleApi.Spanner.V1.Model.InstanceConfig.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.InstanceConfig.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.InstanceConfig.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.InstanceConfig.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.InstanceConfig.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.InstanceOperationProgress","doc":"Encapsulates progress related information for a Cloud Spanner long running instance operations.","ref":"GoogleApi.Spanner.V1.Model.InstanceOperationProgress.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.InstanceOperationProgress","doc":"*   `endTime` (*type:* `DateTime.t`, *default:* `nil`) - If set, the time at which this operation failed or was completed successfully.\n*   `progressPercent` (*type:* `integer()`, *default:* `nil`) - Percent completion of the operation. Values are between 0 and 100 inclusive.\n*   `startTime` (*type:* `DateTime.t`, *default:* `nil`) - Time the request was received.","ref":"GoogleApi.Spanner.V1.Model.InstanceOperationProgress.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.InstanceOperationProgress.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.InstanceOperationProgress.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.InstanceOperationProgress.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.InstanceOperationProgress.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.InstancePartition","doc":"An isolated set of Cloud Spanner resources that databases can define placements on.","ref":"GoogleApi.Spanner.V1.Model.InstancePartition.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.InstancePartition","doc":"*   `config` (*type:* `String.t`, *default:* `nil`) - Required. The name of the instance partition's configuration. Values are of the form `projects//instanceConfigs/`. See also InstanceConfig and ListInstanceConfigs.\n*   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The time at which the instance partition was created.\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - Required. The descriptive name for this instance partition as it appears in UIs. Must be unique per project and between 4 and 30 characters in length.\n*   `etag` (*type:* `String.t`, *default:* `nil`) - Used for optimistic concurrency control as a way to help prevent simultaneous updates of a instance partition from overwriting each other. It is strongly suggested that systems make use of the etag in the read-modify-write cycle to perform instance partition updates in order to avoid race conditions: An etag is returned in the response which contains instance partitions, and systems are expected to put that etag in the request to update instance partitions to ensure that their change will be applied to the same version of the instance partition. If no etag is provided in the call to update instance partition, then the existing instance partition is overwritten blindly.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Required. A unique identifier for the instance partition. Values are of the form `projects//instances//instancePartitions/a-z*[a-z0-9]`. The final segment of the name must be between 2 and 64 characters in length. An instance partition's name cannot be changed after the instance partition is created.\n*   `nodeCount` (*type:* `integer()`, *default:* `nil`) - The number of nodes allocated to this instance partition. Users can set the `node_count` field to specify the target number of nodes allocated to the instance partition. This may be zero in API responses for instance partitions that are not yet in state `READY`.\n*   `processingUnits` (*type:* `integer()`, *default:* `nil`) - The number of processing units allocated to this instance partition. Users can set the `processing_units` field to specify the target number of processing units allocated to the instance partition. This might be zero in API responses for instance partitions that are not yet in the `READY` state.\n*   `referencingBackups` (*type:* `list(String.t)`, *default:* `nil`) - Output only. Deprecated: This field is not populated. Output only. The names of the backups that reference this instance partition. Referencing backups should share the parent instance. The existence of any referencing backup prevents the instance partition from being deleted.\n*   `referencingDatabases` (*type:* `list(String.t)`, *default:* `nil`) - Output only. The names of the databases that reference this instance partition. Referencing databases should share the parent instance. The existence of any referencing database prevents the instance partition from being deleted.\n*   `state` (*type:* `String.t`, *default:* `nil`) - Output only. The current instance partition state.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The time at which the instance partition was most recently updated.","ref":"GoogleApi.Spanner.V1.Model.InstancePartition.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.InstancePartition.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.InstancePartition.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.InstancePartition.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.InstancePartition.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.KeyRange","doc":"KeyRange represents a range of rows in a table or index. A range has a start key and an end key. These keys can be open or closed, indicating if the range includes rows with that key. Keys are represented by lists, where the ith value in the list corresponds to the ith component of the table or index primary key. Individual values are encoded as described here. For example, consider the following table definition: CREATE TABLE UserEvents ( UserName STRING(MAX), EventDate STRING(10) ) PRIMARY KEY(UserName, EventDate); The following keys name rows in this table: \"Bob\", \"2014-09-23\" Since the `UserEvents` table's `PRIMARY KEY` clause names two columns, each `UserEvents` key has two elements; the first is the `UserName`, and the second is the `EventDate`. Key ranges with multiple components are interpreted lexicographically by component using the table or index key's declared sort order. For example, the following range returns all events for user `\"Bob\"` that occurred in the year 2015: \"start_closed\": [\"Bob\", \"2015-01-01\"] \"end_closed\": [\"Bob\", \"2015-12-31\"] Start and end keys can omit trailing key components. This affects the inclusion and exclusion of rows that exactly match the provided key components: if the key is closed, then rows that exactly match the provided components are included; if the key is open, then rows that exactly match are not included. For example, the following range includes all events for `\"Bob\"` that occurred during and after the year 2000: \"start_closed\": [\"Bob\", \"2000-01-01\"] \"end_closed\": [\"Bob\"] The next example retrieves all events for `\"Bob\"`: \"start_closed\": [\"Bob\"] \"end_closed\": [\"Bob\"] To retrieve events before the year 2000: \"start_closed\": [\"Bob\"] \"end_open\": [\"Bob\", \"2000-01-01\"] The following range includes all rows in the table: \"start_closed\": [] \"end_closed\": [] This range returns all users whose `UserName` begins with any character from A to C: \"start_closed\": [\"A\"] \"end_open\": [\"D\"] This range returns all users whose `UserName` begins with B: \"start_closed\": [\"B\"] \"end_open\": [\"C\"] Key ranges honor column sort order. For example, suppose a table is defined as follows: CREATE TABLE DescendingSortedTable { Key INT64, ... ) PRIMARY KEY(Key DESC); The following range retrieves all rows with key values between 1 and 100 inclusive: \"start_closed\": [\"100\"] \"end_closed\": [\"1\"] Note that 100 is passed as the start, and 1 is passed as the end, because `Key` is a descending column in the schema.","ref":"GoogleApi.Spanner.V1.Model.KeyRange.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.KeyRange","doc":"*   `endClosed` (*type:* `list(any())`, *default:* `nil`) - If the end is closed, then the range includes all rows whose first `len(end_closed)` key columns exactly match `end_closed`.\n*   `endOpen` (*type:* `list(any())`, *default:* `nil`) - If the end is open, then the range excludes rows whose first `len(end_open)` key columns exactly match `end_open`.\n*   `startClosed` (*type:* `list(any())`, *default:* `nil`) - If the start is closed, then the range includes all rows whose first `len(start_closed)` key columns exactly match `start_closed`.\n*   `startOpen` (*type:* `list(any())`, *default:* `nil`) - If the start is open, then the range excludes rows whose first `len(start_open)` key columns exactly match `start_open`.","ref":"GoogleApi.Spanner.V1.Model.KeyRange.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.KeyRange.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.KeyRange.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.KeyRange.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.KeyRange.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.KeyRangeInfo","doc":"A message representing information for a key range (possibly one key).","ref":"GoogleApi.Spanner.V1.Model.KeyRangeInfo.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.KeyRangeInfo","doc":"*   `contextValues` (*type:* `list(GoogleApi.Spanner.V1.Model.ContextValue.t)`, *default:* `nil`) - The list of context values for this key range.\n*   `endKeyIndex` (*type:* `integer()`, *default:* `nil`) - The index of the end key in indexed_keys.\n*   `info` (*type:* `GoogleApi.Spanner.V1.Model.LocalizedString.t`, *default:* `nil`) - Information about this key range, for all metrics.\n*   `keysCount` (*type:* `String.t`, *default:* `nil`) - The number of keys this range covers.\n*   `metric` (*type:* `GoogleApi.Spanner.V1.Model.LocalizedString.t`, *default:* `nil`) - The name of the metric. e.g. \"latency\".\n*   `startKeyIndex` (*type:* `integer()`, *default:* `nil`) - The index of the start key in indexed_keys.\n*   `timeOffset` (*type:* `String.t`, *default:* `nil`) - The time offset. This is the time since the start of the time interval.\n*   `unit` (*type:* `GoogleApi.Spanner.V1.Model.LocalizedString.t`, *default:* `nil`) - The unit of the metric. This is an unstructured field and will be mapped as is to the user.\n*   `value` (*type:* `number()`, *default:* `nil`) - The value of the metric.","ref":"GoogleApi.Spanner.V1.Model.KeyRangeInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.KeyRangeInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.KeyRangeInfo.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.KeyRangeInfo.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.KeyRangeInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.KeyRangeInfos","doc":"A message representing a list of specific information for multiple key ranges.","ref":"GoogleApi.Spanner.V1.Model.KeyRangeInfos.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.KeyRangeInfos","doc":"*   `infos` (*type:* `list(GoogleApi.Spanner.V1.Model.KeyRangeInfo.t)`, *default:* `nil`) - The list individual KeyRangeInfos.\n*   `totalSize` (*type:* `integer()`, *default:* `nil`) - The total size of the list of all KeyRangeInfos. This may be larger than the number of repeated messages above. If that is the case, this number may be used to determine how many are not being shown.","ref":"GoogleApi.Spanner.V1.Model.KeyRangeInfos.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.KeyRangeInfos.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.KeyRangeInfos.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.KeyRangeInfos.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.KeyRangeInfos.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.KeySet","doc":"`KeySet` defines a collection of Cloud Spanner keys and/or key ranges. All the keys are expected to be in the same table or index. The keys need not be sorted in any particular way. If the same key is specified multiple times in the set (for example if two ranges, two keys, or a key and a range overlap), Cloud Spanner behaves as if the key were only specified once.","ref":"GoogleApi.Spanner.V1.Model.KeySet.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.KeySet","doc":"*   `all` (*type:* `boolean()`, *default:* `nil`) - For convenience `all` can be set to `true` to indicate that this `KeySet` matches all keys in the table or index. Note that any keys specified in `keys` or `ranges` are only yielded once.\n*   `keys` (*type:* `list(list(any()))`, *default:* `nil`) - A list of specific keys. Entries in `keys` should have exactly as many elements as there are columns in the primary or index key with which this `KeySet` is used. Individual key values are encoded as described here.\n*   `ranges` (*type:* `list(GoogleApi.Spanner.V1.Model.KeyRange.t)`, *default:* `nil`) - A list of key ranges. See KeyRange for more information about key range specifications.","ref":"GoogleApi.Spanner.V1.Model.KeySet.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.KeySet.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.KeySet.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.KeySet.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.KeySet.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ListBackupOperationsResponse","doc":"The response for ListBackupOperations.","ref":"GoogleApi.Spanner.V1.Model.ListBackupOperationsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ListBackupOperationsResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - `next_page_token` can be sent in a subsequent ListBackupOperations call to fetch more of the matching metadata.\n*   `operations` (*type:* `list(GoogleApi.Spanner.V1.Model.Operation.t)`, *default:* `nil`) - The list of matching backup long-running operations. Each operation's name will be prefixed by the backup's name. The operation's metadata field type `metadata.type_url` describes the type of the metadata. Operations returned include those that are pending or have completed/failed/canceled within the last 7 days. Operations returned are ordered by `operation.metadata.value.progress.start_time` in descending order starting from the most recently started operation.","ref":"GoogleApi.Spanner.V1.Model.ListBackupOperationsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ListBackupOperationsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ListBackupOperationsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ListBackupOperationsResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ListBackupOperationsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ListBackupSchedulesResponse","doc":"The response for ListBackupSchedules.","ref":"GoogleApi.Spanner.V1.Model.ListBackupSchedulesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ListBackupSchedulesResponse","doc":"*   `backupSchedules` (*type:* `list(GoogleApi.Spanner.V1.Model.BackupSchedule.t)`, *default:* `nil`) - The list of backup schedules for a database.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - `next_page_token` can be sent in a subsequent ListBackupSchedules call to fetch more of the schedules.","ref":"GoogleApi.Spanner.V1.Model.ListBackupSchedulesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ListBackupSchedulesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ListBackupSchedulesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ListBackupSchedulesResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ListBackupSchedulesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ListBackupsResponse","doc":"The response for ListBackups.","ref":"GoogleApi.Spanner.V1.Model.ListBackupsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ListBackupsResponse","doc":"*   `backups` (*type:* `list(GoogleApi.Spanner.V1.Model.Backup.t)`, *default:* `nil`) - The list of matching backups. Backups returned are ordered by `create_time` in descending order, starting from the most recent `create_time`.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - `next_page_token` can be sent in a subsequent ListBackups call to fetch more of the matching backups.","ref":"GoogleApi.Spanner.V1.Model.ListBackupsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ListBackupsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ListBackupsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ListBackupsResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ListBackupsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ListDatabaseOperationsResponse","doc":"The response for ListDatabaseOperations.","ref":"GoogleApi.Spanner.V1.Model.ListDatabaseOperationsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ListDatabaseOperationsResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - `next_page_token` can be sent in a subsequent ListDatabaseOperations call to fetch more of the matching metadata.\n*   `operations` (*type:* `list(GoogleApi.Spanner.V1.Model.Operation.t)`, *default:* `nil`) - The list of matching database long-running operations. Each operation's name will be prefixed by the database's name. The operation's metadata field type `metadata.type_url` describes the type of the metadata.","ref":"GoogleApi.Spanner.V1.Model.ListDatabaseOperationsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ListDatabaseOperationsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ListDatabaseOperationsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ListDatabaseOperationsResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ListDatabaseOperationsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ListDatabaseRolesResponse","doc":"The response for ListDatabaseRoles.","ref":"GoogleApi.Spanner.V1.Model.ListDatabaseRolesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ListDatabaseRolesResponse","doc":"*   `databaseRoles` (*type:* `list(GoogleApi.Spanner.V1.Model.DatabaseRole.t)`, *default:* `nil`) - Database roles that matched the request.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - `next_page_token` can be sent in a subsequent ListDatabaseRoles call to fetch more of the matching roles.","ref":"GoogleApi.Spanner.V1.Model.ListDatabaseRolesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ListDatabaseRolesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ListDatabaseRolesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ListDatabaseRolesResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ListDatabaseRolesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ListDatabasesResponse","doc":"The response for ListDatabases.","ref":"GoogleApi.Spanner.V1.Model.ListDatabasesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ListDatabasesResponse","doc":"*   `databases` (*type:* `list(GoogleApi.Spanner.V1.Model.Database.t)`, *default:* `nil`) - Databases that matched the request.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - `next_page_token` can be sent in a subsequent ListDatabases call to fetch more of the matching databases.","ref":"GoogleApi.Spanner.V1.Model.ListDatabasesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ListDatabasesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ListDatabasesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ListDatabasesResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ListDatabasesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ListInstanceConfigOperationsResponse","doc":"The response for ListInstanceConfigOperations.","ref":"GoogleApi.Spanner.V1.Model.ListInstanceConfigOperationsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ListInstanceConfigOperationsResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - `next_page_token` can be sent in a subsequent ListInstanceConfigOperations call to fetch more of the matching metadata.\n*   `operations` (*type:* `list(GoogleApi.Spanner.V1.Model.Operation.t)`, *default:* `nil`) - The list of matching instance configuration long-running operations. Each operation's name will be prefixed by the name of the instance configuration. The operation's metadata field type `metadata.type_url` describes the type of the metadata.","ref":"GoogleApi.Spanner.V1.Model.ListInstanceConfigOperationsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ListInstanceConfigOperationsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ListInstanceConfigOperationsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ListInstanceConfigOperationsResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ListInstanceConfigOperationsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ListInstanceConfigsResponse","doc":"The response for ListInstanceConfigs.","ref":"GoogleApi.Spanner.V1.Model.ListInstanceConfigsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ListInstanceConfigsResponse","doc":"*   `instanceConfigs` (*type:* `list(GoogleApi.Spanner.V1.Model.InstanceConfig.t)`, *default:* `nil`) - The list of requested instance configurations.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - `next_page_token` can be sent in a subsequent ListInstanceConfigs call to fetch more of the matching instance configurations.","ref":"GoogleApi.Spanner.V1.Model.ListInstanceConfigsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ListInstanceConfigsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ListInstanceConfigsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ListInstanceConfigsResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ListInstanceConfigsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ListInstancePartitionOperationsResponse","doc":"The response for ListInstancePartitionOperations.","ref":"GoogleApi.Spanner.V1.Model.ListInstancePartitionOperationsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ListInstancePartitionOperationsResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - `next_page_token` can be sent in a subsequent ListInstancePartitionOperations call to fetch more of the matching metadata.\n*   `operations` (*type:* `list(GoogleApi.Spanner.V1.Model.Operation.t)`, *default:* `nil`) - The list of matching instance partition long-running operations. Each operation's name will be prefixed by the instance partition's name. The operation's metadata field type `metadata.type_url` describes the type of the metadata.\n*   `unreachableInstancePartitions` (*type:* `list(String.t)`, *default:* `nil`) - The list of unreachable instance partitions. It includes the names of instance partitions whose operation metadata could not be retrieved within instance_partition_deadline.","ref":"GoogleApi.Spanner.V1.Model.ListInstancePartitionOperationsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ListInstancePartitionOperationsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ListInstancePartitionOperationsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ListInstancePartitionOperationsResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ListInstancePartitionOperationsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ListInstancePartitionsResponse","doc":"The response for ListInstancePartitions.","ref":"GoogleApi.Spanner.V1.Model.ListInstancePartitionsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ListInstancePartitionsResponse","doc":"*   `instancePartitions` (*type:* `list(GoogleApi.Spanner.V1.Model.InstancePartition.t)`, *default:* `nil`) - The list of requested instancePartitions.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - `next_page_token` can be sent in a subsequent ListInstancePartitions call to fetch more of the matching instance partitions.\n*   `unreachable` (*type:* `list(String.t)`, *default:* `nil`) - The list of unreachable instances or instance partitions. It includes the names of instances or instance partitions whose metadata could not be retrieved within instance_partition_deadline.","ref":"GoogleApi.Spanner.V1.Model.ListInstancePartitionsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ListInstancePartitionsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ListInstancePartitionsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ListInstancePartitionsResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ListInstancePartitionsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ListInstancesResponse","doc":"The response for ListInstances.","ref":"GoogleApi.Spanner.V1.Model.ListInstancesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ListInstancesResponse","doc":"*   `instances` (*type:* `list(GoogleApi.Spanner.V1.Model.Instance.t)`, *default:* `nil`) - The list of requested instances.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - `next_page_token` can be sent in a subsequent ListInstances call to fetch more of the matching instances.\n*   `unreachable` (*type:* `list(String.t)`, *default:* `nil`) - The list of unreachable instances. It includes the names of instances whose metadata could not be retrieved within instance_deadline.","ref":"GoogleApi.Spanner.V1.Model.ListInstancesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ListInstancesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ListInstancesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ListInstancesResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ListInstancesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ListOperationsResponse","doc":"The response message for Operations.ListOperations.","ref":"GoogleApi.Spanner.V1.Model.ListOperationsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ListOperationsResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - The standard List next-page token.\n*   `operations` (*type:* `list(GoogleApi.Spanner.V1.Model.Operation.t)`, *default:* `nil`) - A list of operations that matches the specified filter in the request.","ref":"GoogleApi.Spanner.V1.Model.ListOperationsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ListOperationsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ListOperationsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ListOperationsResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ListOperationsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ListScansResponse","doc":"Response method from the ListScans method.","ref":"GoogleApi.Spanner.V1.Model.ListScansResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ListScansResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token to retrieve the next page of results, or empty if there are no more results in the list.\n*   `scans` (*type:* `list(GoogleApi.Spanner.V1.Model.Scan.t)`, *default:* `nil`) - Available scans based on the list query parameters.","ref":"GoogleApi.Spanner.V1.Model.ListScansResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ListScansResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ListScansResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ListScansResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ListScansResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ListSessionsResponse","doc":"The response for ListSessions.","ref":"GoogleApi.Spanner.V1.Model.ListSessionsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ListSessionsResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - `next_page_token` can be sent in a subsequent ListSessions call to fetch more of the matching sessions.\n*   `sessions` (*type:* `list(GoogleApi.Spanner.V1.Model.Session.t)`, *default:* `nil`) - The list of requested sessions.","ref":"GoogleApi.Spanner.V1.Model.ListSessionsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ListSessionsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ListSessionsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ListSessionsResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ListSessionsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.LocalizedString","doc":"A message representing a user-facing string whose value may need to be translated before being displayed.","ref":"GoogleApi.Spanner.V1.Model.LocalizedString.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.LocalizedString","doc":"*   `args` (*type:* `map()`, *default:* `nil`) - A map of arguments used when creating the localized message. Keys represent parameter names which may be used by the localized version when substituting dynamic values.\n*   `message` (*type:* `String.t`, *default:* `nil`) - The canonical English version of this message. If no token is provided or the front-end has no message associated with the token, this text will be displayed as-is.\n*   `token` (*type:* `String.t`, *default:* `nil`) - The token identifying the message, e.g. 'METRIC_READ_CPU'. This should be unique within the service.","ref":"GoogleApi.Spanner.V1.Model.LocalizedString.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.LocalizedString.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.LocalizedString.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.LocalizedString.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.LocalizedString.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Metric","doc":"A message representing the actual monitoring data, values for each key bucket over time, of a metric.","ref":"GoogleApi.Spanner.V1.Model.Metric.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Metric","doc":"*   `aggregation` (*type:* `String.t`, *default:* `nil`) - The aggregation function used to aggregate each key bucket\n*   `category` (*type:* `GoogleApi.Spanner.V1.Model.LocalizedString.t`, *default:* `nil`) - The category of the metric, e.g. \"Activity\", \"Alerts\", \"Reads\", etc.\n*   `derived` (*type:* `GoogleApi.Spanner.V1.Model.DerivedMetric.t`, *default:* `nil`) - The references to numerator and denominator metrics for a derived metric.\n*   `displayLabel` (*type:* `GoogleApi.Spanner.V1.Model.LocalizedString.t`, *default:* `nil`) - The displayed label of the metric.\n*   `hasNonzeroData` (*type:* `boolean()`, *default:* `nil`) - Whether the metric has any non-zero data.\n*   `hotValue` (*type:* `number()`, *default:* `nil`) - The value that is considered hot for the metric. On a per metric basis hotness signals high utilization and something that might potentially be a cause for concern by the end user. hot_value is used to calibrate and scale visual color scales.\n*   `indexedHotKeys` (*type:* `%{optional(String.t) => GoogleApi.Spanner.V1.Model.IndexedHotKey.t}`, *default:* `nil`) - The (sparse) mapping from time index to an IndexedHotKey message, representing those time intervals for which there are hot keys.\n*   `indexedKeyRangeInfos` (*type:* `%{optional(String.t) => GoogleApi.Spanner.V1.Model.IndexedKeyRangeInfos.t}`, *default:* `nil`) - The (sparse) mapping from time interval index to an IndexedKeyRangeInfos message, representing those time intervals for which there are informational messages concerning key ranges.\n*   `info` (*type:* `GoogleApi.Spanner.V1.Model.LocalizedString.t`, *default:* `nil`) - Information about the metric.\n*   `matrix` (*type:* `GoogleApi.Spanner.V1.Model.MetricMatrix.t`, *default:* `nil`) - The data for the metric as a matrix.\n*   `unit` (*type:* `GoogleApi.Spanner.V1.Model.LocalizedString.t`, *default:* `nil`) - The unit of the metric.\n*   `visible` (*type:* `boolean()`, *default:* `nil`) - Whether the metric is visible to the end user.","ref":"GoogleApi.Spanner.V1.Model.Metric.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Metric.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Metric.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Metric.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Metric.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.MetricMatrix","doc":"A message representing a matrix of floats.","ref":"GoogleApi.Spanner.V1.Model.MetricMatrix.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.MetricMatrix","doc":"*   `rows` (*type:* `list(GoogleApi.Spanner.V1.Model.MetricMatrixRow.t)`, *default:* `nil`) - The rows of the matrix.","ref":"GoogleApi.Spanner.V1.Model.MetricMatrix.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.MetricMatrix.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.MetricMatrix.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.MetricMatrix.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.MetricMatrix.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.MetricMatrixRow","doc":"A message representing a row of a matrix of floats.","ref":"GoogleApi.Spanner.V1.Model.MetricMatrixRow.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.MetricMatrixRow","doc":"*   `cols` (*type:* `list(number())`, *default:* `nil`) - The columns of the row.","ref":"GoogleApi.Spanner.V1.Model.MetricMatrixRow.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.MetricMatrixRow.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.MetricMatrixRow.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.MetricMatrixRow.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.MetricMatrixRow.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.MoveInstanceRequest","doc":"The request for MoveInstance.","ref":"GoogleApi.Spanner.V1.Model.MoveInstanceRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.MoveInstanceRequest","doc":"*   `targetConfig` (*type:* `String.t`, *default:* `nil`) - Required. The target instance configuration where to move the instance. Values are of the form `projects//instanceConfigs/`.","ref":"GoogleApi.Spanner.V1.Model.MoveInstanceRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.MoveInstanceRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.MoveInstanceRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.MoveInstanceRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.MoveInstanceRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Mutation","doc":"A modification to one or more Cloud Spanner rows. Mutations can be applied to a Cloud Spanner database by sending them in a Commit call.","ref":"GoogleApi.Spanner.V1.Model.Mutation.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Mutation","doc":"*   `delete` (*type:* `GoogleApi.Spanner.V1.Model.Delete.t`, *default:* `nil`) - Delete rows from a table. Succeeds whether or not the named rows were present.\n*   `insert` (*type:* `GoogleApi.Spanner.V1.Model.Write.t`, *default:* `nil`) - Insert new rows in a table. If any of the rows already exist, the write or transaction fails with error `ALREADY_EXISTS`.\n*   `insertOrUpdate` (*type:* `GoogleApi.Spanner.V1.Model.Write.t`, *default:* `nil`) - Like insert, except that if the row already exists, then its column values are overwritten with the ones provided. Any column values not explicitly written are preserved. When using insert_or_update, just as when using insert, all `NOT NULL` columns in the table must be given a value. This holds true even when the row already exists and will therefore actually be updated.\n*   `replace` (*type:* `GoogleApi.Spanner.V1.Model.Write.t`, *default:* `nil`) - Like insert, except that if the row already exists, it is deleted, and the column values provided are inserted instead. Unlike insert_or_update, this means any values not explicitly written become `NULL`. In an interleaved table, if you create the child table with the `ON DELETE CASCADE` annotation, then replacing a parent row also deletes the child rows. Otherwise, you must delete the child rows before you replace the parent row.\n*   `update` (*type:* `GoogleApi.Spanner.V1.Model.Write.t`, *default:* `nil`) - Update existing rows in a table. If any of the rows does not already exist, the transaction fails with error `NOT_FOUND`.","ref":"GoogleApi.Spanner.V1.Model.Mutation.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Mutation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Mutation.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Mutation.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Mutation.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.MutationGroup","doc":"A group of mutations to be committed together. Related mutations should be placed in a group. For example, two mutations inserting rows with the same primary key prefix in both parent and child tables are related.","ref":"GoogleApi.Spanner.V1.Model.MutationGroup.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.MutationGroup","doc":"*   `mutations` (*type:* `list(GoogleApi.Spanner.V1.Model.Mutation.t)`, *default:* `nil`) - Required. The mutations in this group.","ref":"GoogleApi.Spanner.V1.Model.MutationGroup.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.MutationGroup.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.MutationGroup.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.MutationGroup.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.MutationGroup.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Operation","doc":"This resource represents a long-running operation that is the result of a network API call.","ref":"GoogleApi.Spanner.V1.Model.Operation.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Operation","doc":"*   `done` (*type:* `boolean()`, *default:* `nil`) - If the value is `false`, it means the operation is still in progress. If `true`, the operation is completed, and either `error` or `response` is available.\n*   `error` (*type:* `GoogleApi.Spanner.V1.Model.Status.t`, *default:* `nil`) - The error result of the operation in case of failure or cancellation.\n*   `metadata` (*type:* `map()`, *default:* `nil`) - Service-specific metadata associated with the operation. It typically contains progress information and common metadata such as create time. Some services might not provide such metadata. Any method that returns a long-running operation should document the metadata type, if any.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The server-assigned name, which is only unique within the same service that originally returns it. If you use the default HTTP mapping, the `name` should be a resource name ending with `operations/{unique_id}`.\n*   `response` (*type:* `map()`, *default:* `nil`) - The normal, successful response of the operation. If the original method returns no data on success, such as `Delete`, the response is `google.protobuf.Empty`. If the original method is standard `Get`/`Create`/`Update`, the response should be the resource. For other methods, the response should have the type `XxxResponse`, where `Xxx` is the original method name. For example, if the original method name is `TakeSnapshot()`, the inferred response type is `TakeSnapshotResponse`.","ref":"GoogleApi.Spanner.V1.Model.Operation.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Operation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Operation.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Operation.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Operation.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.OperationProgress","doc":"Encapsulates progress related information for a Cloud Spanner long running operation.","ref":"GoogleApi.Spanner.V1.Model.OperationProgress.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.OperationProgress","doc":"*   `endTime` (*type:* `DateTime.t`, *default:* `nil`) - If set, the time at which this operation failed or was completed successfully.\n*   `progressPercent` (*type:* `integer()`, *default:* `nil`) - Percent completion of the operation. Values are between 0 and 100 inclusive.\n*   `startTime` (*type:* `DateTime.t`, *default:* `nil`) - Time the request was received.","ref":"GoogleApi.Spanner.V1.Model.OperationProgress.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.OperationProgress.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.OperationProgress.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.OperationProgress.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.OperationProgress.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.OptimizeRestoredDatabaseMetadata","doc":"Metadata type for the long-running operation used to track the progress of optimizations performed on a newly restored database. This long-running operation is automatically created by the system after the successful completion of a database restore, and cannot be cancelled.","ref":"GoogleApi.Spanner.V1.Model.OptimizeRestoredDatabaseMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.OptimizeRestoredDatabaseMetadata","doc":"*   `name` (*type:* `String.t`, *default:* `nil`) - Name of the restored database being optimized.\n*   `progress` (*type:* `GoogleApi.Spanner.V1.Model.OperationProgress.t`, *default:* `nil`) - The progress of the post-restore optimizations.","ref":"GoogleApi.Spanner.V1.Model.OptimizeRestoredDatabaseMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.OptimizeRestoredDatabaseMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.OptimizeRestoredDatabaseMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.OptimizeRestoredDatabaseMetadata.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.OptimizeRestoredDatabaseMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.PartialResultSet","doc":"Partial results from a streaming read or SQL query. Streaming reads and SQL queries better tolerate large result sets, large rows, and large values, but are a little trickier to consume.","ref":"GoogleApi.Spanner.V1.Model.PartialResultSet.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.PartialResultSet","doc":"*   `chunkedValue` (*type:* `boolean()`, *default:* `nil`) - If true, then the final value in values is chunked, and must be combined with more values from subsequent `PartialResultSet`s to obtain a complete field value.\n*   `metadata` (*type:* `GoogleApi.Spanner.V1.Model.ResultSetMetadata.t`, *default:* `nil`) - Metadata about the result set, such as row type information. Only present in the first response.\n*   `resumeToken` (*type:* `String.t`, *default:* `nil`) - Streaming calls might be interrupted for a variety of reasons, such as TCP connection loss. If this occurs, the stream of results can be resumed by re-sending the original request and including `resume_token`. Note that executing any other transaction in the same session invalidates the token.\n*   `stats` (*type:* `GoogleApi.Spanner.V1.Model.ResultSetStats.t`, *default:* `nil`) - Query plan and execution statistics for the statement that produced this streaming result set. These can be requested by setting ExecuteSqlRequest.query_mode and are sent only once with the last response in the stream. This field will also be present in the last response for DML statements.\n*   `values` (*type:* `list(any())`, *default:* `nil`) - A streamed result set consists of a stream of values, which might be split into many `PartialResultSet` messages to accommodate large rows and/or large values. Every N complete values defines a row, where N is equal to the number of entries in metadata.row_type.fields. Most values are encoded based on type as described here. It is possible that the last value in values is \"chunked\", meaning that the rest of the value is sent in subsequent `PartialResultSet`(s). This is denoted by the chunked_value field. Two or more chunked values can be merged to form a complete value as follows: * `bool/number/null`: cannot be chunked * `string`: concatenate the strings * `list`: concatenate the lists. If the last element in a list is a `string`, `list`, or `object`, merge it with the first element in the next list by applying these rules recursively. * `object`: concatenate the (field name, field value) pairs. If a field name is duplicated, then apply these rules recursively to merge the field values. Some examples of merging: # Strings are concatenated. \"foo\", \"bar\" => \"foobar\" # Lists of non-strings are concatenated. [2, 3], [4] => [2, 3, 4] # Lists are concatenated, but the last and first elements are merged # because they are strings. [\"a\", \"b\"], [\"c\", \"d\"] => [\"a\", \"bc\", \"d\"] # Lists are concatenated, but the last and first elements are merged # because they are lists. Recursively, the last and first elements # of the inner lists are merged because they are strings. [\"a\", [\"b\", \"c\"]], [[\"d\"], \"e\"] => [\"a\", [\"b\", \"cd\"], \"e\"] # Non-overlapping object fields are combined. {\"a\": \"1\"}, {\"b\": \"2\"} => {\"a\": \"1\", \"b\": 2\"} # Overlapping object fields are merged. {\"a\": \"1\"}, {\"a\": \"2\"} => {\"a\": \"12\"} # Examples of merging objects containing lists of strings. {\"a\": [\"1\"]}, {\"a\": [\"2\"]} => {\"a\": [\"12\"]} For a more complete example, suppose a streaming SQL query is yielding a result set whose rows contain a single string field. The following `PartialResultSet`s might be yielded: { \"metadata\": { ... } \"values\": [\"Hello\", \"W\"] \"chunked_value\": true \"resume_token\": \"Af65...\" } { \"values\": [\"orl\"] \"chunked_value\": true } { \"values\": [\"d\"] \"resume_token\": \"Zx1B...\" } This sequence of `PartialResultSet`s encodes two rows, one containing the field value `\"Hello\"`, and a second containing the field value `\"World\" = \"W\" + \"orl\" + \"d\"`. Not all `PartialResultSet`s contain a `resume_token`. Execution can only be resumed from a previously yielded `resume_token`. For the above sequence of `PartialResultSet`s, resuming the query with `\"resume_token\": \"Af65...\"` will yield results from the `PartialResultSet` with value `[\"orl\"]`.","ref":"GoogleApi.Spanner.V1.Model.PartialResultSet.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.PartialResultSet.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.PartialResultSet.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.PartialResultSet.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.PartialResultSet.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Partition","doc":"Information returned for each partition returned in a PartitionResponse.","ref":"GoogleApi.Spanner.V1.Model.Partition.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Partition","doc":"*   `partitionToken` (*type:* `String.t`, *default:* `nil`) - This token can be passed to Read, StreamingRead, ExecuteSql, or ExecuteStreamingSql requests to restrict the results to those identified by this partition token.","ref":"GoogleApi.Spanner.V1.Model.Partition.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Partition.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Partition.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Partition.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Partition.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.PartitionOptions","doc":"Options for a PartitionQueryRequest and PartitionReadRequest.","ref":"GoogleApi.Spanner.V1.Model.PartitionOptions.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.PartitionOptions","doc":"*   `maxPartitions` (*type:* `String.t`, *default:* `nil`) - **Note:** This hint is currently ignored by PartitionQuery and PartitionRead requests. The desired maximum number of partitions to return. For example, this may be set to the number of workers available. The default for this option is currently 10,000. The maximum value is currently 200,000. This is only a hint. The actual number of partitions returned may be smaller or larger than this maximum count request.\n*   `partitionSizeBytes` (*type:* `String.t`, *default:* `nil`) - **Note:** This hint is currently ignored by PartitionQuery and PartitionRead requests. The desired data size for each partition generated. The default for this option is currently 1 GiB. This is only a hint. The actual size of each partition may be smaller or larger than this size request.","ref":"GoogleApi.Spanner.V1.Model.PartitionOptions.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.PartitionOptions.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.PartitionOptions.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.PartitionOptions.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.PartitionOptions.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.PartitionQueryRequest","doc":"The request for PartitionQuery","ref":"GoogleApi.Spanner.V1.Model.PartitionQueryRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.PartitionQueryRequest","doc":"*   `paramTypes` (*type:* `%{optional(String.t) => GoogleApi.Spanner.V1.Model.Type.t}`, *default:* `nil`) - It is not always possible for Cloud Spanner to infer the right SQL type from a JSON value. For example, values of type `BYTES` and values of type `STRING` both appear in params as JSON strings. In these cases, `param_types` can be used to specify the exact SQL type for some or all of the SQL query parameters. See the definition of Type for more information about SQL types.\n*   `params` (*type:* `map()`, *default:* `nil`) - Parameter names and values that bind to placeholders in the SQL string. A parameter placeholder consists of the `@` character followed by the parameter name (for example, `@firstName`). Parameter names can contain letters, numbers, and underscores. Parameters can appear anywhere that a literal value is expected. The same parameter name can be used more than once, for example: `\"WHERE id > @msg_id AND id < @msg_id + 100\"` It is an error to execute a SQL statement with unbound parameters.\n*   `partitionOptions` (*type:* `GoogleApi.Spanner.V1.Model.PartitionOptions.t`, *default:* `nil`) - Additional options that affect how many partitions are created.\n*   `sql` (*type:* `String.t`, *default:* `nil`) - Required. The query request to generate partitions for. The request fails if the query is not root partitionable. For a query to be root partitionable, it needs to satisfy a few conditions. For example, if the query execution plan contains a distributed union operator, then it must be the first operator in the plan. For more information about other conditions, see [Read data in parallel](https://cloud.google.com/spanner/docs/reads#read_data_in_parallel). The query request must not contain DML commands, such as `INSERT`, `UPDATE`, or `DELETE`. Use `ExecuteStreamingSql` with a PartitionedDml transaction for large, partition-friendly DML operations.\n*   `transaction` (*type:* `GoogleApi.Spanner.V1.Model.TransactionSelector.t`, *default:* `nil`) - Read only snapshot transactions are supported, read/write and single use transactions are not.","ref":"GoogleApi.Spanner.V1.Model.PartitionQueryRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.PartitionQueryRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.PartitionQueryRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.PartitionQueryRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.PartitionQueryRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.PartitionReadRequest","doc":"The request for PartitionRead","ref":"GoogleApi.Spanner.V1.Model.PartitionReadRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.PartitionReadRequest","doc":"*   `columns` (*type:* `list(String.t)`, *default:* `nil`) - The columns of table to be returned for each row matching this request.\n*   `index` (*type:* `String.t`, *default:* `nil`) - If non-empty, the name of an index on table. This index is used instead of the table primary key when interpreting key_set and sorting result rows. See key_set for further information.\n*   `keySet` (*type:* `GoogleApi.Spanner.V1.Model.KeySet.t`, *default:* `nil`) - Required. `key_set` identifies the rows to be yielded. `key_set` names the primary keys of the rows in table to be yielded, unless index is present. If index is present, then key_set instead names index keys in index. It is not an error for the `key_set` to name rows that do not exist in the database. Read yields nothing for nonexistent rows.\n*   `partitionOptions` (*type:* `GoogleApi.Spanner.V1.Model.PartitionOptions.t`, *default:* `nil`) - Additional options that affect how many partitions are created.\n*   `table` (*type:* `String.t`, *default:* `nil`) - Required. The name of the table in the database to be read.\n*   `transaction` (*type:* `GoogleApi.Spanner.V1.Model.TransactionSelector.t`, *default:* `nil`) - Read only snapshot transactions are supported, read/write and single use transactions are not.","ref":"GoogleApi.Spanner.V1.Model.PartitionReadRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.PartitionReadRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.PartitionReadRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.PartitionReadRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.PartitionReadRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.PartitionResponse","doc":"The response for PartitionQuery or PartitionRead","ref":"GoogleApi.Spanner.V1.Model.PartitionResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.PartitionResponse","doc":"*   `partitions` (*type:* `list(GoogleApi.Spanner.V1.Model.Partition.t)`, *default:* `nil`) - Partitions created by this request.\n*   `transaction` (*type:* `GoogleApi.Spanner.V1.Model.Transaction.t`, *default:* `nil`) - Transaction created by this request.","ref":"GoogleApi.Spanner.V1.Model.PartitionResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.PartitionResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.PartitionResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.PartitionResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.PartitionResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.PartitionedDml","doc":"Message type to initiate a Partitioned DML transaction.","ref":"GoogleApi.Spanner.V1.Model.PartitionedDml.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.PartitionedDml","doc":"","ref":"GoogleApi.Spanner.V1.Model.PartitionedDml.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.PartitionedDml.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.PartitionedDml.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.PartitionedDml.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.PartitionedDml.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.PlanNode","doc":"Node information for nodes appearing in a QueryPlan.plan_nodes.","ref":"GoogleApi.Spanner.V1.Model.PlanNode.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.PlanNode","doc":"*   `childLinks` (*type:* `list(GoogleApi.Spanner.V1.Model.ChildLink.t)`, *default:* `nil`) - List of child node `index`es and their relationship to this parent.\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - The display name for the node.\n*   `executionStats` (*type:* `map()`, *default:* `nil`) - The execution statistics associated with the node, contained in a group of key-value pairs. Only present if the plan was returned as a result of a profile query. For example, number of executions, number of rows/time per execution etc.\n*   `index` (*type:* `integer()`, *default:* `nil`) - The `PlanNode`'s index in node list.\n*   `kind` (*type:* `String.t`, *default:* `nil`) - Used to determine the type of node. May be needed for visualizing different kinds of nodes differently. For example, If the node is a SCALAR node, it will have a condensed representation which can be used to directly embed a description of the node in its parent.\n*   `metadata` (*type:* `map()`, *default:* `nil`) - Attributes relevant to the node contained in a group of key-value pairs. For example, a Parameter Reference node could have the following information in its metadata: { \"parameter_reference\": \"param1\", \"parameter_type\": \"array\" }\n*   `shortRepresentation` (*type:* `GoogleApi.Spanner.V1.Model.ShortRepresentation.t`, *default:* `nil`) - Condensed representation for SCALAR nodes.","ref":"GoogleApi.Spanner.V1.Model.PlanNode.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.PlanNode.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.PlanNode.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.PlanNode.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.PlanNode.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Policy","doc":"An Identity and Access Management (IAM) policy, which specifies access controls for Google Cloud resources. A `Policy` is a collection of `bindings`. A `binding` binds one or more `members`, or principals, to a single `role`. Principals can be user accounts, service accounts, Google groups, and domains (such as G Suite). A `role` is a named list of permissions; each `role` can be an IAM predefined role or a user-created custom role. For some types of Google Cloud resources, a `binding` can also specify a `condition`, which is a logical expression that allows access to a resource only if the expression evaluates to `true`. A condition can add constraints based on attributes of the request, the resource, or both. To learn which resources support conditions in their IAM policies, see the [IAM documentation](https://cloud.google.com/iam/help/conditions/resource-policies). **JSON example:** ``` { \"bindings\": [ { \"role\": \"roles/resourcemanager.organizationAdmin\", \"members\": [ \"user:mike@example.com\", \"group:admins@example.com\", \"domain:google.com\", \"serviceAccount:my-project-id@appspot.gserviceaccount.com\" ] }, { \"role\": \"roles/resourcemanager.organizationViewer\", \"members\": [ \"user:eve@example.com\" ], \"condition\": { \"title\": \"expirable access\", \"description\": \"Does not grant access after Sep 2020\", \"expression\": \"request.time < timestamp('2020-10-01T00:00:00.000Z')\", } } ], \"etag\": \"BwWWja0YfJA=\", \"version\": 3 } ``` **YAML example:** ``` bindings: - members: - user:mike@example.com - group:admins@example.com - domain:google.com - serviceAccount:my-project-id@appspot.gserviceaccount.com role: roles/resourcemanager.organizationAdmin - members: - user:eve@example.com role: roles/resourcemanager.organizationViewer condition: title: expirable access description: Does not grant access after Sep 2020 expression: request.time < timestamp('2020-10-01T00:00:00.000Z') etag: BwWWja0YfJA= version: 3 ``` For a description of IAM and its features, see the [IAM documentation](https://cloud.google.com/iam/docs/).","ref":"GoogleApi.Spanner.V1.Model.Policy.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Policy","doc":"*   `bindings` (*type:* `list(GoogleApi.Spanner.V1.Model.Binding.t)`, *default:* `nil`) - Associates a list of `members`, or principals, with a `role`. Optionally, may specify a `condition` that determines how and when the `bindings` are applied. Each of the `bindings` must contain at least one principal. The `bindings` in a `Policy` can refer to up to 1,500 principals; up to 250 of these principals can be Google groups. Each occurrence of a principal counts towards these limits. For example, if the `bindings` grant 50 different roles to `user:alice@example.com`, and not to any other principal, then you can add another 1,450 principals to the `bindings` in the `Policy`.\n*   `etag` (*type:* `String.t`, *default:* `nil`) - `etag` is used for optimistic concurrency control as a way to help prevent simultaneous updates of a policy from overwriting each other. It is strongly suggested that systems make use of the `etag` in the read-modify-write cycle to perform policy updates in order to avoid race conditions: An `etag` is returned in the response to `getIamPolicy`, and systems are expected to put that etag in the request to `setIamPolicy` to ensure that their change will be applied to the same version of the policy. **Important:** If you use IAM Conditions, you must include the `etag` field whenever you call `setIamPolicy`. If you omit this field, then IAM allows you to overwrite a version `3` policy with a version `1` policy, and all of the conditions in the version `3` policy are lost.\n*   `version` (*type:* `integer()`, *default:* `nil`) - Specifies the format of the policy. Valid values are `0`, `1`, and `3`. Requests that specify an invalid value are rejected. Any operation that affects conditional role bindings must specify version `3`. This requirement applies to the following operations: * Getting a policy that includes a conditional role binding * Adding a conditional role binding to a policy * Changing a conditional role binding in a policy * Removing any role binding, with or without a condition, from a policy that includes conditions **Important:** If you use IAM Conditions, you must include the `etag` field whenever you call `setIamPolicy`. If you omit this field, then IAM allows you to overwrite a version `3` policy with a version `1` policy, and all of the conditions in the version `3` policy are lost. If a policy does not include any conditions, operations on that policy may specify any valid version or leave the field unset. To learn which resources support conditions in their IAM policies, see the [IAM documentation](https://cloud.google.com/iam/help/conditions/resource-policies).","ref":"GoogleApi.Spanner.V1.Model.Policy.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Policy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Policy.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Policy.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Policy.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.PrefixNode","doc":"A message representing a key prefix node in the key prefix hierarchy. for eg. Bigtable keyspaces are lexicographically ordered mappings of keys to values. Keys often have a shared prefix structure where users use the keys to organize data. Eg ///employee In this case Keysight will possibly use one node for a company and reuse it for all employees that fall under the company. Doing so improves legibility in the UI.","ref":"GoogleApi.Spanner.V1.Model.PrefixNode.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.PrefixNode","doc":"*   `dataSourceNode` (*type:* `boolean()`, *default:* `nil`) - Whether this corresponds to a data_source name.\n*   `depth` (*type:* `integer()`, *default:* `nil`) - The depth in the prefix hierarchy.\n*   `endIndex` (*type:* `integer()`, *default:* `nil`) - The index of the end key bucket of the range that this node spans.\n*   `startIndex` (*type:* `integer()`, *default:* `nil`) - The index of the start key bucket of the range that this node spans.\n*   `word` (*type:* `String.t`, *default:* `nil`) - The string represented by the prefix node.","ref":"GoogleApi.Spanner.V1.Model.PrefixNode.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.PrefixNode.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.PrefixNode.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.PrefixNode.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.PrefixNode.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.QueryAdvisorResult","doc":"Output of query advisor analysis.","ref":"GoogleApi.Spanner.V1.Model.QueryAdvisorResult.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.QueryAdvisorResult","doc":"*   `indexAdvice` (*type:* `list(GoogleApi.Spanner.V1.Model.IndexAdvice.t)`, *default:* `nil`) - Optional. Index Recommendation for a query. This is an optional field and the recommendation will only be available when the recommendation guarantees significant improvement in query performance.","ref":"GoogleApi.Spanner.V1.Model.QueryAdvisorResult.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.QueryAdvisorResult.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.QueryAdvisorResult.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.QueryAdvisorResult.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.QueryAdvisorResult.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.QueryOptions","doc":"Query optimizer configuration.","ref":"GoogleApi.Spanner.V1.Model.QueryOptions.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.QueryOptions","doc":"*   `optimizerStatisticsPackage` (*type:* `String.t`, *default:* `nil`) - An option to control the selection of optimizer statistics package. This parameter allows individual queries to use a different query optimizer statistics package. Specifying `latest` as a value instructs Cloud Spanner to use the latest generated statistics package. If not specified, Cloud Spanner uses the statistics package set at the database level options, or the latest package if the database option is not set. The statistics package requested by the query has to be exempt from garbage collection. This can be achieved with the following DDL statement: ``` ALTER STATISTICS SET OPTIONS (allow_gc=false) ``` The list of available statistics packages can be queried from `INFORMATION_SCHEMA.SPANNER_STATISTICS`. Executing a SQL statement with an invalid optimizer statistics package or with a statistics package that allows garbage collection fails with an `INVALID_ARGUMENT` error.\n*   `optimizerVersion` (*type:* `String.t`, *default:* `nil`) - An option to control the selection of optimizer version. This parameter allows individual queries to pick different query optimizer versions. Specifying `latest` as a value instructs Cloud Spanner to use the latest supported query optimizer version. If not specified, Cloud Spanner uses the optimizer version set at the database level options. Any other positive integer (from the list of supported optimizer versions) overrides the default optimizer version for query execution. The list of supported optimizer versions can be queried from SPANNER_SYS.SUPPORTED_OPTIMIZER_VERSIONS. Executing a SQL statement with an invalid optimizer version fails with an `INVALID_ARGUMENT` error. See https://cloud.google.com/spanner/docs/query-optimizer/manage-query-optimizer for more information on managing the query optimizer. The `optimizer_version` statement hint has precedence over this setting.","ref":"GoogleApi.Spanner.V1.Model.QueryOptions.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.QueryOptions.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.QueryOptions.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.QueryOptions.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.QueryOptions.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.QueryPlan","doc":"Contains an ordered list of nodes appearing in the query plan.","ref":"GoogleApi.Spanner.V1.Model.QueryPlan.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.QueryPlan","doc":"*   `planNodes` (*type:* `list(GoogleApi.Spanner.V1.Model.PlanNode.t)`, *default:* `nil`) - The nodes in the query plan. Plan nodes are returned in pre-order starting with the plan root. Each PlanNode's `id` corresponds to its index in `plan_nodes`.\n*   `queryAdvice` (*type:* `GoogleApi.Spanner.V1.Model.QueryAdvisorResult.t`, *default:* `nil`) - Optional. The advices/recommendations for a query. Currently this field will be serving index recommendations for a query.","ref":"GoogleApi.Spanner.V1.Model.QueryPlan.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.QueryPlan.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.QueryPlan.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.QueryPlan.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.QueryPlan.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.QuorumInfo","doc":"Information about the dual-region quorum.","ref":"GoogleApi.Spanner.V1.Model.QuorumInfo.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.QuorumInfo","doc":"*   `etag` (*type:* `String.t`, *default:* `nil`) - Output only. The etag is used for optimistic concurrency control as a way to help prevent simultaneous `ChangeQuorum` requests that might create a race condition.\n*   `initiator` (*type:* `String.t`, *default:* `nil`) - Output only. Whether this `ChangeQuorum` is Google or User initiated.\n*   `quorumType` (*type:* `GoogleApi.Spanner.V1.Model.QuorumType.t`, *default:* `nil`) - Output only. The type of this quorum. See QuorumType for more information about quorum type specifications.\n*   `startTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The timestamp when the request was triggered.","ref":"GoogleApi.Spanner.V1.Model.QuorumInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.QuorumInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.QuorumInfo.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.QuorumInfo.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.QuorumInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.QuorumType","doc":"Information about the database quorum type. This only applies to dual-region instance configs.","ref":"GoogleApi.Spanner.V1.Model.QuorumType.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.QuorumType","doc":"*   `dualRegion` (*type:* `GoogleApi.Spanner.V1.Model.DualRegionQuorum.t`, *default:* `nil`) - Dual-region quorum type.\n*   `singleRegion` (*type:* `GoogleApi.Spanner.V1.Model.SingleRegionQuorum.t`, *default:* `nil`) - Single-region quorum type.","ref":"GoogleApi.Spanner.V1.Model.QuorumType.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.QuorumType.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.QuorumType.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.QuorumType.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.QuorumType.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ReadOnly","doc":"Message type to initiate a read-only transaction.","ref":"GoogleApi.Spanner.V1.Model.ReadOnly.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ReadOnly","doc":"*   `exactStaleness` (*type:* `String.t`, *default:* `nil`) - Executes all reads at a timestamp that is `exact_staleness` old. The timestamp is chosen soon after the read is started. Guarantees that all writes that have committed more than the specified number of seconds ago are visible. Because Cloud Spanner chooses the exact timestamp, this mode works even if the client's local clock is substantially skewed from Cloud Spanner commit timestamps. Useful for reading at nearby replicas without the distributed timestamp negotiation overhead of `max_staleness`.\n*   `maxStaleness` (*type:* `String.t`, *default:* `nil`) - Read data at a timestamp >= `NOW - max_staleness` seconds. Guarantees that all writes that have committed more than the specified number of seconds ago are visible. Because Cloud Spanner chooses the exact timestamp, this mode works even if the client's local clock is substantially skewed from Cloud Spanner commit timestamps. Useful for reading the freshest data available at a nearby replica, while bounding the possible staleness if the local replica has fallen behind. Note that this option can only be used in single-use transactions.\n*   `minReadTimestamp` (*type:* `DateTime.t`, *default:* `nil`) - Executes all reads at a timestamp >= `min_read_timestamp`. This is useful for requesting fresher data than some previous read, or data that is fresh enough to observe the effects of some previously committed transaction whose timestamp is known. Note that this option can only be used in single-use transactions. A timestamp in RFC3339 UTC \\\"Zulu\\\" format, accurate to nanoseconds. Example: `\"2014-10-02T15:01:23.045123456Z\"`.\n*   `readTimestamp` (*type:* `DateTime.t`, *default:* `nil`) - Executes all reads at the given timestamp. Unlike other modes, reads at a specific timestamp are repeatable; the same read at the same timestamp always returns the same data. If the timestamp is in the future, the read will block until the specified timestamp, modulo the read's deadline. Useful for large scale consistent reads such as mapreduces, or for coordinating many reads against a consistent snapshot of the data. A timestamp in RFC3339 UTC \\\"Zulu\\\" format, accurate to nanoseconds. Example: `\"2014-10-02T15:01:23.045123456Z\"`.\n*   `returnReadTimestamp` (*type:* `boolean()`, *default:* `nil`) - If true, the Cloud Spanner-selected read timestamp is included in the Transaction message that describes the transaction.\n*   `strong` (*type:* `boolean()`, *default:* `nil`) - Read at a timestamp where all previously committed transactions are visible.","ref":"GoogleApi.Spanner.V1.Model.ReadOnly.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ReadOnly.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ReadOnly.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ReadOnly.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ReadOnly.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ReadRequest","doc":"The request for Read and StreamingRead.","ref":"GoogleApi.Spanner.V1.Model.ReadRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ReadRequest","doc":"*   `columns` (*type:* `list(String.t)`, *default:* `nil`) - Required. The columns of table to be returned for each row matching this request.\n*   `dataBoostEnabled` (*type:* `boolean()`, *default:* `nil`) - If this is for a partitioned read and this field is set to `true`, the request is executed with Spanner Data Boost independent compute resources. If the field is set to `true` but the request does not set `partition_token`, the API returns an `INVALID_ARGUMENT` error.\n*   `directedReadOptions` (*type:* `GoogleApi.Spanner.V1.Model.DirectedReadOptions.t`, *default:* `nil`) - Directed read options for this request.\n*   `index` (*type:* `String.t`, *default:* `nil`) - If non-empty, the name of an index on table. This index is used instead of the table primary key when interpreting key_set and sorting result rows. See key_set for further information.\n*   `keySet` (*type:* `GoogleApi.Spanner.V1.Model.KeySet.t`, *default:* `nil`) - Required. `key_set` identifies the rows to be yielded. `key_set` names the primary keys of the rows in table to be yielded, unless index is present. If index is present, then key_set instead names index keys in index. If the partition_token field is empty, rows are yielded in table primary key order (if index is empty) or index key order (if index is non-empty). If the partition_token field is not empty, rows will be yielded in an unspecified order. It is not an error for the `key_set` to name rows that do not exist in the database. Read yields nothing for nonexistent rows.\n*   `limit` (*type:* `String.t`, *default:* `nil`) - If greater than zero, only the first `limit` rows are yielded. If `limit` is zero, the default is no limit. A limit cannot be specified if `partition_token` is set.\n*   `lockHint` (*type:* `String.t`, *default:* `nil`) - Optional. Lock Hint for the request, it can only be used with read-write transactions.\n*   `orderBy` (*type:* `String.t`, *default:* `nil`) - Optional. Order for the returned rows. By default, Spanner will return result rows in primary key order except for PartitionRead requests. For applications that do not require rows to be returned in primary key (`ORDER_BY_PRIMARY_KEY`) order, setting `ORDER_BY_NO_ORDER` option allows Spanner to optimize row retrieval, resulting in lower latencies in certain cases (e.g. bulk point lookups).\n*   `partitionToken` (*type:* `String.t`, *default:* `nil`) - If present, results will be restricted to the specified partition previously created using PartitionRead(). There must be an exact match for the values of fields common to this message and the PartitionReadRequest message used to create this partition_token.\n*   `requestOptions` (*type:* `GoogleApi.Spanner.V1.Model.RequestOptions.t`, *default:* `nil`) - Common options for this request.\n*   `resumeToken` (*type:* `String.t`, *default:* `nil`) - If this request is resuming a previously interrupted read, `resume_token` should be copied from the last PartialResultSet yielded before the interruption. Doing this enables the new read to resume where the last read left off. The rest of the request parameters must exactly match the request that yielded this token.\n*   `table` (*type:* `String.t`, *default:* `nil`) - Required. The name of the table in the database to be read.\n*   `transaction` (*type:* `GoogleApi.Spanner.V1.Model.TransactionSelector.t`, *default:* `nil`) - The transaction to use. If none is provided, the default is a temporary read-only transaction with strong concurrency.","ref":"GoogleApi.Spanner.V1.Model.ReadRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ReadRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ReadRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ReadRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ReadRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ReadWrite","doc":"Message type to initiate a read-write transaction. Currently this transaction type has no options.","ref":"GoogleApi.Spanner.V1.Model.ReadWrite.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ReadWrite","doc":"*   `readLockMode` (*type:* `String.t`, *default:* `nil`) - Read lock mode for the transaction.","ref":"GoogleApi.Spanner.V1.Model.ReadWrite.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ReadWrite.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ReadWrite.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ReadWrite.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ReadWrite.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ReplicaInfo","doc":"","ref":"GoogleApi.Spanner.V1.Model.ReplicaInfo.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ReplicaInfo","doc":"*   `defaultLeaderLocation` (*type:* `boolean()`, *default:* `nil`) - If true, this location is designated as the default leader location where leader replicas are placed. See the [region types documentation](https://cloud.google.com/spanner/docs/instances#region_types) for more details.\n*   `location` (*type:* `String.t`, *default:* `nil`) - The location of the serving resources, e.g., \"us-central1\".\n*   `type` (*type:* `String.t`, *default:* `nil`) - The type of replica.","ref":"GoogleApi.Spanner.V1.Model.ReplicaInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ReplicaInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ReplicaInfo.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ReplicaInfo.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ReplicaInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ReplicaSelection","doc":"The directed read replica selector. Callers must provide one or more of the following fields for replica selection: * `location` - The location must be one of the regions within the multi-region configuration of your database. * `type` - The type of the replica. Some examples of using replica_selectors are: * `location:us-east1` --> The \"us-east1\" replica(s) of any available type will be used to process the request. * `type:READ_ONLY` --> The \"READ_ONLY\" type replica(s) in nearest available location will be used to process the request. * `location:us-east1 type:READ_ONLY` --> The \"READ_ONLY\" type replica(s) in location \"us-east1\" will be used to process the request.","ref":"GoogleApi.Spanner.V1.Model.ReplicaSelection.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ReplicaSelection","doc":"*   `location` (*type:* `String.t`, *default:* `nil`) - The location or region of the serving requests, e.g. \"us-east1\".\n*   `type` (*type:* `String.t`, *default:* `nil`) - The type of replica.","ref":"GoogleApi.Spanner.V1.Model.ReplicaSelection.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ReplicaSelection.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ReplicaSelection.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ReplicaSelection.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ReplicaSelection.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.RequestOptions","doc":"Common request options for various APIs.","ref":"GoogleApi.Spanner.V1.Model.RequestOptions.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.RequestOptions","doc":"*   `priority` (*type:* `String.t`, *default:* `nil`) - Priority for the request.\n*   `requestTag` (*type:* `String.t`, *default:* `nil`) - A per-request tag which can be applied to queries or reads, used for statistics collection. Both request_tag and transaction_tag can be specified for a read or query that belongs to a transaction. This field is ignored for requests where it's not applicable (e.g. CommitRequest). Legal characters for `request_tag` values are all printable characters (ASCII 32 - 126) and the length of a request_tag is limited to 50 characters. Values that exceed this limit are truncated. Any leading underscore (_) characters will be removed from the string.\n*   `transactionTag` (*type:* `String.t`, *default:* `nil`) - A tag used for statistics collection about this transaction. Both request_tag and transaction_tag can be specified for a read or query that belongs to a transaction. The value of transaction_tag should be the same for all requests belonging to the same transaction. If this request doesn't belong to any transaction, transaction_tag will be ignored. Legal characters for `transaction_tag` values are all printable characters (ASCII 32 - 126) and the length of a transaction_tag is limited to 50 characters. Values that exceed this limit are truncated. Any leading underscore (_) characters will be removed from the string.","ref":"GoogleApi.Spanner.V1.Model.RequestOptions.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.RequestOptions.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.RequestOptions.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.RequestOptions.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.RequestOptions.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.RestoreDatabaseEncryptionConfig","doc":"Encryption configuration for the restored database.","ref":"GoogleApi.Spanner.V1.Model.RestoreDatabaseEncryptionConfig.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.RestoreDatabaseEncryptionConfig","doc":"*   `encryptionType` (*type:* `String.t`, *default:* `nil`) - Required. The encryption type of the restored database.\n*   `kmsKeyName` (*type:* `String.t`, *default:* `nil`) - Optional. The Cloud KMS key that will be used to encrypt/decrypt the restored database. This field should be set only when encryption_type is `CUSTOMER_MANAGED_ENCRYPTION`. Values are of the form `projects//locations//keyRings//cryptoKeys/`.\n*   `kmsKeyNames` (*type:* `list(String.t)`, *default:* `nil`) - Optional. Specifies the KMS configuration for the one or more keys used to encrypt the database. Values have the form `projects//locations//keyRings//cryptoKeys/`. The keys referenced by kms_key_names must fully cover all regions of the database instance configuration. Some examples: * For single region database instance configurations, specify a single regional location KMS key. * For multi-regional database instance configurations of type `GOOGLE_MANAGED`, either specify a multi-regional location KMS key or multiple regional location KMS keys that cover all regions in the instance configuration. * For a database instance configuration of type `USER_MANAGED`, please specify only regional location KMS keys to cover each region in the instance configuration. Multi-regional location KMS keys are not supported for USER_MANAGED instance configurations.","ref":"GoogleApi.Spanner.V1.Model.RestoreDatabaseEncryptionConfig.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.RestoreDatabaseEncryptionConfig.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.RestoreDatabaseEncryptionConfig.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.RestoreDatabaseEncryptionConfig.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.RestoreDatabaseEncryptionConfig.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.RestoreDatabaseMetadata","doc":"Metadata type for the long-running operation returned by RestoreDatabase.","ref":"GoogleApi.Spanner.V1.Model.RestoreDatabaseMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.RestoreDatabaseMetadata","doc":"*   `backupInfo` (*type:* `GoogleApi.Spanner.V1.Model.BackupInfo.t`, *default:* `nil`) - Information about the backup used to restore the database.\n*   `cancelTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which cancellation of this operation was received. Operations.CancelOperation starts asynchronous cancellation on a long-running operation. The server makes a best effort to cancel the operation, but success is not guaranteed. Clients can use Operations.GetOperation or other methods to check whether the cancellation succeeded or whether the operation completed despite cancellation. On successful cancellation, the operation is not deleted; instead, it becomes an operation with an Operation.error value with a google.rpc.Status.code of 1, corresponding to `Code.CANCELLED`.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Name of the database being created and restored to.\n*   `optimizeDatabaseOperationName` (*type:* `String.t`, *default:* `nil`) - If exists, the name of the long-running operation that will be used to track the post-restore optimization process to optimize the performance of the restored database, and remove the dependency on the restore source. The name is of the form `projects//instances//databases//operations/` where the is the name of database being created and restored to. The metadata type of the long-running operation is OptimizeRestoredDatabaseMetadata. This long-running operation will be automatically created by the system after the RestoreDatabase long-running operation completes successfully. This operation will not be created if the restore was not successful.\n*   `progress` (*type:* `GoogleApi.Spanner.V1.Model.OperationProgress.t`, *default:* `nil`) - The progress of the RestoreDatabase operation.\n*   `sourceType` (*type:* `String.t`, *default:* `nil`) - The type of the restore source.","ref":"GoogleApi.Spanner.V1.Model.RestoreDatabaseMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.RestoreDatabaseMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.RestoreDatabaseMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.RestoreDatabaseMetadata.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.RestoreDatabaseMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.RestoreDatabaseRequest","doc":"The request for RestoreDatabase.","ref":"GoogleApi.Spanner.V1.Model.RestoreDatabaseRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.RestoreDatabaseRequest","doc":"*   `backup` (*type:* `String.t`, *default:* `nil`) - Name of the backup from which to restore. Values are of the form `projects//instances//backups/`.\n*   `databaseId` (*type:* `String.t`, *default:* `nil`) - Required. The id of the database to create and restore to. This database must not already exist. The `database_id` appended to `parent` forms the full database name of the form `projects//instances//databases/`.\n*   `encryptionConfig` (*type:* `GoogleApi.Spanner.V1.Model.RestoreDatabaseEncryptionConfig.t`, *default:* `nil`) - Optional. An encryption configuration describing the encryption type and key resources in Cloud KMS used to encrypt/decrypt the database to restore to. If this field is not specified, the restored database will use the same encryption configuration as the backup by default, namely encryption_type = `USE_CONFIG_DEFAULT_OR_BACKUP_ENCRYPTION`.","ref":"GoogleApi.Spanner.V1.Model.RestoreDatabaseRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.RestoreDatabaseRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.RestoreDatabaseRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.RestoreDatabaseRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.RestoreDatabaseRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.RestoreInfo","doc":"Information about the database restore.","ref":"GoogleApi.Spanner.V1.Model.RestoreInfo.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.RestoreInfo","doc":"*   `backupInfo` (*type:* `GoogleApi.Spanner.V1.Model.BackupInfo.t`, *default:* `nil`) - Information about the backup used to restore the database. The backup may no longer exist.\n*   `sourceType` (*type:* `String.t`, *default:* `nil`) - The type of the restore source.","ref":"GoogleApi.Spanner.V1.Model.RestoreInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.RestoreInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.RestoreInfo.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.RestoreInfo.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.RestoreInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ResultSet","doc":"Results from Read or ExecuteSql.","ref":"GoogleApi.Spanner.V1.Model.ResultSet.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ResultSet","doc":"*   `metadata` (*type:* `GoogleApi.Spanner.V1.Model.ResultSetMetadata.t`, *default:* `nil`) - Metadata about the result set, such as row type information.\n*   `rows` (*type:* `list(list(any()))`, *default:* `nil`) - Each element in `rows` is a row whose format is defined by metadata.row_type. The ith element in each row matches the ith field in metadata.row_type. Elements are encoded based on type as described here.\n*   `stats` (*type:* `GoogleApi.Spanner.V1.Model.ResultSetStats.t`, *default:* `nil`) - Query plan and execution statistics for the SQL statement that produced this result set. These can be requested by setting ExecuteSqlRequest.query_mode. DML statements always produce stats containing the number of rows modified, unless executed using the ExecuteSqlRequest.QueryMode.PLAN ExecuteSqlRequest.query_mode. Other fields may or may not be populated, based on the ExecuteSqlRequest.query_mode.","ref":"GoogleApi.Spanner.V1.Model.ResultSet.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ResultSet.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ResultSet.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ResultSet.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ResultSet.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ResultSetMetadata","doc":"Metadata about a ResultSet or PartialResultSet.","ref":"GoogleApi.Spanner.V1.Model.ResultSetMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ResultSetMetadata","doc":"*   `rowType` (*type:* `GoogleApi.Spanner.V1.Model.StructType.t`, *default:* `nil`) - Indicates the field names and types for the rows in the result set. For example, a SQL query like `\"SELECT UserId, UserName FROM Users\"` could return a `row_type` value like: \"fields\": [ { \"name\": \"UserId\", \"type\": { \"code\": \"INT64\" } }, { \"name\": \"UserName\", \"type\": { \"code\": \"STRING\" } }, ]\n*   `transaction` (*type:* `GoogleApi.Spanner.V1.Model.Transaction.t`, *default:* `nil`) - If the read or SQL query began a transaction as a side-effect, the information about the new transaction is yielded here.\n*   `undeclaredParameters` (*type:* `GoogleApi.Spanner.V1.Model.StructType.t`, *default:* `nil`) - A SQL query can be parameterized. In PLAN mode, these parameters can be undeclared. This indicates the field names and types for those undeclared parameters in the SQL query. For example, a SQL query like `\"SELECT * FROM Users where UserId = @userId and UserName = @userName \"` could return a `undeclared_parameters` value like: \"fields\": [ { \"name\": \"UserId\", \"type\": { \"code\": \"INT64\" } }, { \"name\": \"UserName\", \"type\": { \"code\": \"STRING\" } }, ]","ref":"GoogleApi.Spanner.V1.Model.ResultSetMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ResultSetMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ResultSetMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ResultSetMetadata.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ResultSetMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ResultSetStats","doc":"Additional statistics about a ResultSet or PartialResultSet.","ref":"GoogleApi.Spanner.V1.Model.ResultSetStats.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ResultSetStats","doc":"*   `queryPlan` (*type:* `GoogleApi.Spanner.V1.Model.QueryPlan.t`, *default:* `nil`) - QueryPlan for the query associated with this result.\n*   `queryStats` (*type:* `map()`, *default:* `nil`) - Aggregated statistics from the execution of the query. Only present when the query is profiled. For example, a query could return the statistics as follows: { \"rows_returned\": \"3\", \"elapsed_time\": \"1.22 secs\", \"cpu_time\": \"1.19 secs\" }\n*   `rowCountExact` (*type:* `String.t`, *default:* `nil`) - Standard DML returns an exact count of rows that were modified.\n*   `rowCountLowerBound` (*type:* `String.t`, *default:* `nil`) - Partitioned DML does not offer exactly-once semantics, so it returns a lower bound of the rows modified.","ref":"GoogleApi.Spanner.V1.Model.ResultSetStats.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ResultSetStats.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ResultSetStats.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ResultSetStats.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ResultSetStats.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.RollbackRequest","doc":"The request for Rollback.","ref":"GoogleApi.Spanner.V1.Model.RollbackRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.RollbackRequest","doc":"*   `transactionId` (*type:* `String.t`, *default:* `nil`) - Required. The transaction to roll back.","ref":"GoogleApi.Spanner.V1.Model.RollbackRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.RollbackRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.RollbackRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.RollbackRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.RollbackRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Scan","doc":"Scan is a structure which describes Cloud Key Visualizer scan information.","ref":"GoogleApi.Spanner.V1.Model.Scan.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Scan","doc":"*   `details` (*type:* `map()`, *default:* `nil`) - Additional information provided by the implementer.\n*   `endTime` (*type:* `DateTime.t`, *default:* `nil`) - The upper bound for when the scan is defined.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The unique name of the scan, specific to the Database service implementing this interface.\n*   `scanData` (*type:* `GoogleApi.Spanner.V1.Model.ScanData.t`, *default:* `nil`) - Output only. Cloud Key Visualizer scan data. Note, this field is not available to the ListScans method.\n*   `startTime` (*type:* `DateTime.t`, *default:* `nil`) - A range of time (inclusive) for when the scan is defined. The lower bound for when the scan is defined.","ref":"GoogleApi.Spanner.V1.Model.Scan.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Scan.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Scan.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Scan.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Scan.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ScanData","doc":"ScanData contains Cloud Key Visualizer scan data used by the caller to construct a visualization.","ref":"GoogleApi.Spanner.V1.Model.ScanData.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ScanData","doc":"*   `data` (*type:* `GoogleApi.Spanner.V1.Model.VisualizationData.t`, *default:* `nil`) - Cloud Key Visualizer scan data. The range of time this information covers is captured via the above time range fields. Note, this field is not available to the ListScans method.\n*   `endTime` (*type:* `DateTime.t`, *default:* `nil`) - The upper bound for when the contained data is defined.\n*   `startTime` (*type:* `DateTime.t`, *default:* `nil`) - A range of time (inclusive) for when the contained data is defined. The lower bound for when the contained data is defined.","ref":"GoogleApi.Spanner.V1.Model.ScanData.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ScanData.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ScanData.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ScanData.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ScanData.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Session","doc":"A session in the Cloud Spanner API.","ref":"GoogleApi.Spanner.V1.Model.Session.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Session","doc":"*   `approximateLastUseTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The approximate timestamp when the session is last used. It is typically earlier than the actual last use time.\n*   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The timestamp when the session is created.\n*   `creatorRole` (*type:* `String.t`, *default:* `nil`) - The database role which created this session.\n*   `labels` (*type:* `map()`, *default:* `nil`) - The labels for the session. * Label keys must be between 1 and 63 characters long and must conform to the following regular expression: `[a-z]([-a-z0-9]*[a-z0-9])?`. * Label values must be between 0 and 63 characters long and must conform to the regular expression `([a-z]([-a-z0-9]*[a-z0-9])?)?`. * No more than 64 labels can be associated with a given session. See https://goo.gl/xmQnxf for more information on and examples of labels.\n*   `multiplexed` (*type:* `boolean()`, *default:* `nil`) - Optional. If true, specifies a multiplexed session. Use a multiplexed session for multiple, concurrent read-only operations. Don't use them for read-write transactions, partitioned reads, or partitioned queries. Use CreateSession to create multiplexed sessions. Don't use BatchCreateSessions to create a multiplexed session. You can't delete or list multiplexed sessions.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Output only. The name of the session. This is always system-assigned.","ref":"GoogleApi.Spanner.V1.Model.Session.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Session.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Session.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Session.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Session.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.SetIamPolicyRequest","doc":"Request message for `SetIamPolicy` method.","ref":"GoogleApi.Spanner.V1.Model.SetIamPolicyRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.SetIamPolicyRequest","doc":"*   `policy` (*type:* `GoogleApi.Spanner.V1.Model.Policy.t`, *default:* `nil`) - REQUIRED: The complete policy to be applied to the `resource`. The size of the policy is limited to a few 10s of KB. An empty policy is a valid policy but certain Google Cloud services (such as Projects) might reject them.","ref":"GoogleApi.Spanner.V1.Model.SetIamPolicyRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.SetIamPolicyRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.SetIamPolicyRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.SetIamPolicyRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.SetIamPolicyRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.ShortRepresentation","doc":"Condensed representation of a node and its subtree. Only present for `SCALAR` PlanNode(s).","ref":"GoogleApi.Spanner.V1.Model.ShortRepresentation.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.ShortRepresentation","doc":"*   `description` (*type:* `String.t`, *default:* `nil`) - A string representation of the expression subtree rooted at this node.\n*   `subqueries` (*type:* `map()`, *default:* `nil`) - A mapping of (subquery variable name) -> (subquery node id) for cases where the `description` string of this node references a `SCALAR` subquery contained in the expression subtree rooted at this node. The referenced `SCALAR` subquery may not necessarily be a direct child of this node.","ref":"GoogleApi.Spanner.V1.Model.ShortRepresentation.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.ShortRepresentation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.ShortRepresentation.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.ShortRepresentation.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.ShortRepresentation.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.SingleRegionQuorum","doc":"Message type for a single-region quorum.","ref":"GoogleApi.Spanner.V1.Model.SingleRegionQuorum.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.SingleRegionQuorum","doc":"*   `servingLocation` (*type:* `String.t`, *default:* `nil`) - Required. The location of the serving region, e.g. \"us-central1\". The location must be one of the regions within the dual-region instance configuration of your database. The list of valid locations is available using the GetInstanceConfig API. This should only be used if you plan to change quorum to the single-region quorum type.","ref":"GoogleApi.Spanner.V1.Model.SingleRegionQuorum.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.SingleRegionQuorum.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.SingleRegionQuorum.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.SingleRegionQuorum.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.SingleRegionQuorum.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Statement","doc":"A single DML statement.","ref":"GoogleApi.Spanner.V1.Model.Statement.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Statement","doc":"*   `paramTypes` (*type:* `%{optional(String.t) => GoogleApi.Spanner.V1.Model.Type.t}`, *default:* `nil`) - It is not always possible for Cloud Spanner to infer the right SQL type from a JSON value. For example, values of type `BYTES` and values of type `STRING` both appear in params as JSON strings. In these cases, `param_types` can be used to specify the exact SQL type for some or all of the SQL statement parameters. See the definition of Type for more information about SQL types.\n*   `params` (*type:* `map()`, *default:* `nil`) - Parameter names and values that bind to placeholders in the DML string. A parameter placeholder consists of the `@` character followed by the parameter name (for example, `@firstName`). Parameter names can contain letters, numbers, and underscores. Parameters can appear anywhere that a literal value is expected. The same parameter name can be used more than once, for example: `\"WHERE id > @msg_id AND id < @msg_id + 100\"` It is an error to execute a SQL statement with unbound parameters.\n*   `sql` (*type:* `String.t`, *default:* `nil`) - Required. The DML string.","ref":"GoogleApi.Spanner.V1.Model.Statement.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Statement.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Statement.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Statement.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Statement.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Status","doc":"The `Status` type defines a logical error model that is suitable for different programming environments, including REST APIs and RPC APIs. It is used by [gRPC](https://github.com/grpc). Each `Status` message contains three pieces of data: error code, error message, and error details. You can find out more about this error model and how to work with it in the [API Design Guide](https://cloud.google.com/apis/design/errors).","ref":"GoogleApi.Spanner.V1.Model.Status.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Status","doc":"*   `code` (*type:* `integer()`, *default:* `nil`) - The status code, which should be an enum value of google.rpc.Code.\n*   `details` (*type:* `list(map())`, *default:* `nil`) - A list of messages that carry the error details. There is a common set of message types for APIs to use.\n*   `message` (*type:* `String.t`, *default:* `nil`) - A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the google.rpc.Status.details field, or localized by the client.","ref":"GoogleApi.Spanner.V1.Model.Status.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Status.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Status.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Status.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Status.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.StructType","doc":"`StructType` defines the fields of a STRUCT type.","ref":"GoogleApi.Spanner.V1.Model.StructType.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.StructType","doc":"*   `fields` (*type:* `list(GoogleApi.Spanner.V1.Model.Field.t)`, *default:* `nil`) - The list of fields that make up this struct. Order is significant, because values of this struct type are represented as lists, where the order of field values matches the order of fields in the StructType. In turn, the order of fields matches the order of columns in a read request, or the order of fields in the `SELECT` clause of a query.","ref":"GoogleApi.Spanner.V1.Model.StructType.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.StructType.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.StructType.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.StructType.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.StructType.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest","doc":"Request message for `TestIamPermissions` method.","ref":"GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest","doc":"*   `permissions` (*type:* `list(String.t)`, *default:* `nil`) - REQUIRED: The set of permissions to check for 'resource'. Permissions with wildcards (such as '*', 'spanner.*', 'spanner.instances.*') are not allowed.","ref":"GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.TestIamPermissionsRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse","doc":"Response message for `TestIamPermissions` method.","ref":"GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse","doc":"*   `permissions` (*type:* `list(String.t)`, *default:* `nil`) - A subset of `TestPermissionsRequest.permissions` that the caller is allowed.","ref":"GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.TestIamPermissionsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Transaction","doc":"A transaction.","ref":"GoogleApi.Spanner.V1.Model.Transaction.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Transaction","doc":"*   `id` (*type:* `String.t`, *default:* `nil`) - `id` may be used to identify the transaction in subsequent Read, ExecuteSql, Commit, or Rollback calls. Single-use read-only transactions do not have IDs, because single-use transactions do not support multiple requests.\n*   `readTimestamp` (*type:* `DateTime.t`, *default:* `nil`) - For snapshot read-only transactions, the read timestamp chosen for the transaction. Not returned by default: see TransactionOptions.ReadOnly.return_read_timestamp. A timestamp in RFC3339 UTC \\\"Zulu\\\" format, accurate to nanoseconds. Example: `\"2014-10-02T15:01:23.045123456Z\"`.","ref":"GoogleApi.Spanner.V1.Model.Transaction.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Transaction.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Transaction.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Transaction.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Transaction.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.TransactionOptions","doc":"Transactions: Each session can have at most one active transaction at a time (note that standalone reads and queries use a transaction internally and do count towards the one transaction limit). After the active transaction is completed, the session can immediately be re-used for the next transaction. It is not necessary to create a new session for each transaction. Transaction modes: Cloud Spanner supports three transaction modes: 1. Locking read-write. This type of transaction is the only way to write data into Cloud Spanner. These transactions rely on pessimistic locking and, if necessary, two-phase commit. Locking read-write transactions may abort, requiring the application to retry. 2. Snapshot read-only. Snapshot read-only transactions provide guaranteed consistency across several reads, but do not allow writes. Snapshot read-only transactions can be configured to read at timestamps in the past, or configured to perform a strong read (where Spanner will select a timestamp such that the read is guaranteed to see the effects of all transactions that have committed before the start of the read). Snapshot read-only transactions do not need to be committed. Queries on change streams must be performed with the snapshot read-only transaction mode, specifying a strong read. See TransactionOptions.ReadOnly.strong for more details. 3. Partitioned DML. This type of transaction is used to execute a single Partitioned DML statement. Partitioned DML partitions the key space and runs the DML statement over each partition in parallel using separate, internal transactions that commit independently. Partitioned DML transactions do not need to be committed. For transactions that only read, snapshot read-only transactions provide simpler semantics and are almost always faster. In particular, read-only transactions do not take locks, so they do not conflict with read-write transactions. As a consequence of not taking locks, they also do not abort, so retry loops are not needed. Transactions may only read-write data in a single database. They may, however, read-write data in different tables within that database. Locking read-write transactions: Locking transactions may be used to atomically read-modify-write data anywhere in a database. This type of transaction is externally consistent. Clients should attempt to minimize the amount of time a transaction is active. Faster transactions commit with higher probability and cause less contention. Cloud Spanner attempts to keep read locks active as long as the transaction continues to do reads, and the transaction has not been terminated by Commit or Rollback. Long periods of inactivity at the client may cause Cloud Spanner to release a transaction's locks and abort it. Conceptually, a read-write transaction consists of zero or more reads or SQL statements followed by Commit. At any time before Commit, the client can send a Rollback request to abort the transaction. Semantics: Cloud Spanner can commit the transaction if all read locks it acquired are still valid at commit time, and it is able to acquire write locks for all writes. Cloud Spanner can abort the transaction for any reason. If a commit attempt returns `ABORTED`, Cloud Spanner guarantees that the transaction has not modified any user data in Cloud Spanner. Unless the transaction commits, Cloud Spanner makes no guarantees about how long the transaction's locks were held for. It is an error to use Cloud Spanner locks for any sort of mutual exclusion other than between Cloud Spanner transactions themselves. Retrying aborted transactions: When a transaction aborts, the application can choose to retry the whole transaction again. To maximize the chances of successfully committing the retry, the client should execute the retry in the same session as the original attempt. The original session's lock priority increases with each consecutive abort, meaning that each attempt has a slightly better chance of success than the previous. Note that the lock priority is preserved per session (not per transaction). Lock priority is set by the first read or write in the first attempt of a read-write transaction. If the application starts a new session to retry the whole transaction, the transaction loses its original lock priority. Moreover, the lock priority is only preserved if the transaction fails with an `ABORTED` error. Under some circumstances (for example, many transactions attempting to modify the same row(s)), a transaction can abort many times in a short period before successfully committing. Thus, it is not a good idea to cap the number of retries a transaction can attempt; instead, it is better to limit the total amount of time spent retrying. Idle transactions: A transaction is considered idle if it has no outstanding reads or SQL queries and has not started a read or SQL query within the last 10 seconds. Idle transactions can be aborted by Cloud Spanner so that they don't hold on to locks indefinitely. If an idle transaction is aborted, the commit will fail with error `ABORTED`. If this behavior is undesirable, periodically executing a simple SQL query in the transaction (for example, `SELECT 1`) prevents the transaction from becoming idle. Snapshot read-only transactions: Snapshot read-only transactions provides a simpler method than locking read-write transactions for doing several consistent reads. However, this type of transaction does not support writes. Snapshot transactions do not take locks. Instead, they work by choosing a Cloud Spanner timestamp, then executing all reads at that timestamp. Since they do not acquire locks, they do not block concurrent read-write transactions. Unlike locking read-write transactions, snapshot read-only transactions never abort. They can fail if the chosen read timestamp is garbage collected; however, the default garbage collection policy is generous enough that most applications do not need to worry about this in practice. Snapshot read-only transactions do not need to call Commit or Rollback (and in fact are not permitted to do so). To execute a snapshot transaction, the client specifies a timestamp bound, which tells Cloud Spanner how to choose a read timestamp. The types of timestamp bound are: - Strong (the default). - Bounded staleness. - Exact staleness. If the Cloud Spanner database to be read is geographically distributed, stale read-only transactions can execute more quickly than strong or read-write transactions, because they are able to execute far from the leader replica. Each type of timestamp bound is discussed in detail below. Strong: Strong reads are guaranteed to see the effects of all transactions that have committed before the start of the read. Furthermore, all rows yielded by a single read are consistent with each other -- if any part of the read observes a transaction, all parts of the read see the transaction. Strong reads are not repeatable: two consecutive strong read-only transactions might return inconsistent results if there are concurrent writes. If consistency across reads is required, the reads should be executed within a transaction or at an exact read timestamp. Queries on change streams (see below for more details) must also specify the strong read timestamp bound. See TransactionOptions.ReadOnly.strong. Exact staleness: These timestamp bounds execute reads at a user-specified timestamp. Reads at a timestamp are guaranteed to see a consistent prefix of the global transaction history: they observe modifications done by all transactions with a commit timestamp less than or equal to the read timestamp, and observe none of the modifications done by transactions with a larger commit timestamp. They will block until all conflicting transactions that may be assigned commit timestamps <= the read timestamp have finished. The timestamp can either be expressed as an absolute Cloud Spanner commit timestamp or a staleness relative to the current time. These modes do not require a \"negotiation phase\" to pick a timestamp. As a result, they execute slightly faster than the equivalent boundedly stale concurrency modes. On the other hand, boundedly stale reads usually return fresher results. See TransactionOptions.ReadOnly.read_timestamp and TransactionOptions.ReadOnly.exact_staleness. Bounded staleness: Bounded staleness modes allow Cloud Spanner to pick the read timestamp, subject to a user-provided staleness bound. Cloud Spanner chooses the newest timestamp within the staleness bound that allows execution of the reads at the closest available replica without blocking. All rows yielded are consistent with each other -- if any part of the read observes a transaction, all parts of the read see the transaction. Boundedly stale reads are not repeatable: two stale reads, even if they use the same staleness bound, can execute at different timestamps and thus return inconsistent results. Boundedly stale reads execute in two phases: the first phase negotiates a timestamp among all replicas needed to serve the read. In the second phase, reads are executed at the negotiated timestamp. As a result of the two phase execution, bounded staleness reads are usually a little slower than comparable exact staleness reads. However, they are typically able to return fresher results, and are more likely to execute at the closest replica. Because the timestamp negotiation requires up-front knowledge of which rows will be read, it can only be used with single-use read-only transactions. See TransactionOptions.ReadOnly.max_staleness and TransactionOptions.ReadOnly.min_read_timestamp. Old read timestamps and garbage collection: Cloud Spanner continuously garbage collects deleted and overwritten data in the background to reclaim storage space. This process is known as \"version GC\". By default, version GC reclaims versions after they are one hour old. Because of this, Cloud Spanner cannot perform reads at read timestamps more than one hour in the past. This restriction also applies to in-progress reads and/or SQL queries whose timestamp become too old while executing. Reads and SQL queries with too-old read timestamps fail with the error `FAILED_PRECONDITION`. You can configure and extend the `VERSION_RETENTION_PERIOD` of a database up to a period as long as one week, which allows Cloud Spanner to perform reads up to one week in the past. Querying change Streams: A Change Stream is a schema object that can be configured to watch data changes on the entire database, a set of tables, or a set of columns in a database. When a change stream is created, Spanner automatically defines a corresponding SQL Table-Valued Function (TVF) that can be used to query the change records in the associated change stream using the ExecuteStreamingSql API. The name of the TVF for a change stream is generated from the name of the change stream: READ_. All queries on change stream TVFs must be executed using the ExecuteStreamingSql API with a single-use read-only transaction with a strong read-only timestamp_bound. The change stream TVF allows users to specify the start_timestamp and end_timestamp for the time range of interest. All change records within the retention period is accessible using the strong read-only timestamp_bound. All other TransactionOptions are invalid for change stream queries. In addition, if TransactionOptions.read_only.return_read_timestamp is set to true, a special value of 2^63 - 2 will be returned in the Transaction message that describes the transaction, instead of a valid read timestamp. This special value should be discarded and not used for any subsequent queries. Please see https://cloud.google.com/spanner/docs/change-streams for more details on how to query the change stream TVFs. Partitioned DML transactions: Partitioned DML transactions are used to execute DML statements with a different execution strategy that provides different, and often better, scalability properties for large, table-wide operations than DML in a ReadWrite transaction. Smaller scoped statements, such as an OLTP workload, should prefer using ReadWrite transactions. Partitioned DML partitions the keyspace and runs the DML statement on each partition in separate, internal transactions. These transactions commit automatically when complete, and run independently from one another. To reduce lock contention, this execution strategy only acquires read locks on rows that match the WHERE clause of the statement. Additionally, the smaller per-partition transactions hold locks for less time. That said, Partitioned DML is not a drop-in replacement for standard DML used in ReadWrite transactions. - The DML statement must be fully-partitionable. Specifically, the statement must be expressible as the union of many statements which each access only a single row of the table. - The statement is not applied atomically to all rows of the table. Rather, the statement is applied atomically to partitions of the table, in independent transactions. Secondary index rows are updated atomically with the base table rows. - Partitioned DML does not guarantee exactly-once execution semantics against a partition. The statement is applied at least once to each partition. It is strongly recommended that the DML statement should be idempotent to avoid unexpected results. For instance, it is potentially dangerous to run a statement such as `UPDATE table SET column = column + 1` as it could be run multiple times against some rows. - The partitions are committed automatically - there is no support for Commit or Rollback. If the call returns an error, or if the client issuing the ExecuteSql call dies, it is possible that some rows had the statement executed on them successfully. It is also possible that statement was never executed against other rows. - Partitioned DML transactions may only contain the execution of a single DML statement via ExecuteSql or ExecuteStreamingSql. - If any error is encountered during the execution of the partitioned DML operation (for instance, a UNIQUE INDEX violation, division by zero, or a value that cannot be stored due to schema constraints), then the operation is stopped at that point and an error is returned. It is possible that at this point, some partitions have been committed (or even committed multiple times), and other partitions have not been run at all. Given the above, Partitioned DML is good fit for large, database-wide, operations that are idempotent, such as deleting old rows from a very large table.","ref":"GoogleApi.Spanner.V1.Model.TransactionOptions.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.TransactionOptions","doc":"*   `excludeTxnFromChangeStreams` (*type:* `boolean()`, *default:* `nil`) - When `exclude_txn_from_change_streams` is set to `true`: * Modifications from this transaction will not be recorded in change streams with DDL option `allow_txn_exclusion=true` that are tracking columns modified by these transactions. * Modifications from this transaction will be recorded in change streams with DDL option `allow_txn_exclusion=false or not set` that are tracking columns modified by these transactions. When `exclude_txn_from_change_streams` is set to `false` or not set, Modifications from this transaction will be recorded in all change streams that are tracking columns modified by these transactions. `exclude_txn_from_change_streams` may only be specified for read-write or partitioned-dml transactions, otherwise the API will return an `INVALID_ARGUMENT` error.\n*   `partitionedDml` (*type:* `GoogleApi.Spanner.V1.Model.PartitionedDml.t`, *default:* `nil`) - Partitioned DML transaction. Authorization to begin a Partitioned DML transaction requires `spanner.databases.beginPartitionedDmlTransaction` permission on the `session` resource.\n*   `readOnly` (*type:* `GoogleApi.Spanner.V1.Model.ReadOnly.t`, *default:* `nil`) - Transaction will not write. Authorization to begin a read-only transaction requires `spanner.databases.beginReadOnlyTransaction` permission on the `session` resource.\n*   `readWrite` (*type:* `GoogleApi.Spanner.V1.Model.ReadWrite.t`, *default:* `nil`) - Transaction may write. Authorization to begin a read-write transaction requires `spanner.databases.beginOrRollbackReadWriteTransaction` permission on the `session` resource.","ref":"GoogleApi.Spanner.V1.Model.TransactionOptions.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.TransactionOptions.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.TransactionOptions.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.TransactionOptions.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.TransactionOptions.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.TransactionSelector","doc":"This message is used to select the transaction in which a Read or ExecuteSql call runs. See TransactionOptions for more information about transactions.","ref":"GoogleApi.Spanner.V1.Model.TransactionSelector.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.TransactionSelector","doc":"*   `begin` (*type:* `GoogleApi.Spanner.V1.Model.TransactionOptions.t`, *default:* `nil`) - Begin a new transaction and execute this read or SQL query in it. The transaction ID of the new transaction is returned in ResultSetMetadata.transaction, which is a Transaction.\n*   `id` (*type:* `String.t`, *default:* `nil`) - Execute the read or SQL query in a previously-started transaction.\n*   `singleUse` (*type:* `GoogleApi.Spanner.V1.Model.TransactionOptions.t`, *default:* `nil`) - Execute the read or SQL query in a temporary transaction. This is the most efficient way to execute a transaction that consists of a single SQL query.","ref":"GoogleApi.Spanner.V1.Model.TransactionSelector.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.TransactionSelector.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.TransactionSelector.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.TransactionSelector.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.TransactionSelector.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Type","doc":"`Type` indicates the type of a Cloud Spanner value, as might be stored in a table cell or returned from an SQL query.","ref":"GoogleApi.Spanner.V1.Model.Type.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Type","doc":"*   `arrayElementType` (*type:* `GoogleApi.Spanner.V1.Model.Type.t`, *default:* `nil`) - If code == ARRAY, then `array_element_type` is the type of the array elements.\n*   `code` (*type:* `String.t`, *default:* `nil`) - Required. The TypeCode for this type.\n*   `protoTypeFqn` (*type:* `String.t`, *default:* `nil`) - If code == PROTO or code == ENUM, then `proto_type_fqn` is the fully qualified name of the proto type representing the proto/enum definition.\n*   `structType` (*type:* `GoogleApi.Spanner.V1.Model.StructType.t`, *default:* `nil`) - If code == STRUCT, then `struct_type` provides type information for the struct's fields.\n*   `typeAnnotation` (*type:* `String.t`, *default:* `nil`) - The TypeAnnotationCode that disambiguates SQL type that Spanner will use to represent values of this type during query processing. This is necessary for some type codes because a single TypeCode can be mapped to different SQL types depending on the SQL dialect. type_annotation typically is not needed to process the content of a value (it doesn't affect serialization) and clients can ignore it on the read path.","ref":"GoogleApi.Spanner.V1.Model.Type.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Type.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Type.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Type.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Type.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlMetadata","doc":"Metadata type for the operation returned by UpdateDatabaseDdl.","ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlMetadata","doc":"*   `actions` (*type:* `list(GoogleApi.Spanner.V1.Model.DdlStatementActionInfo.t)`, *default:* `nil`) - The brief action info for the DDL statements. `actions[i]` is the brief info for `statements[i]`.\n*   `commitTimestamps` (*type:* `list(DateTime.t)`, *default:* `nil`) - Reports the commit timestamps of all statements that have succeeded so far, where `commit_timestamps[i]` is the commit timestamp for the statement `statements[i]`.\n*   `database` (*type:* `String.t`, *default:* `nil`) - The database being modified.\n*   `progress` (*type:* `list(GoogleApi.Spanner.V1.Model.OperationProgress.t)`, *default:* `nil`) - The progress of the UpdateDatabaseDdl operations. All DDL statements will have continuously updating progress, and `progress[i]` is the operation progress for `statements[i]`. Also, `progress[i]` will have start time and end time populated with commit timestamp of operation, as well as a progress of 100% once the operation has completed.\n*   `statements` (*type:* `list(String.t)`, *default:* `nil`) - For an update this list contains all the statements. For an individual statement, this list contains only that statement.\n*   `throttled` (*type:* `boolean()`, *default:* `nil`) - Output only. When true, indicates that the operation is throttled e.g. due to resource constraints. When resources become available the operation will resume and this field will be false again.","ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlMetadata.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlRequest","doc":"Enqueues the given DDL statements to be applied, in order but not necessarily all at once, to the database schema at some point (or points) in the future. The server checks that the statements are executable (syntactically valid, name tables that exist, etc.) before enqueueing them, but they may still fail upon later execution (e.g., if a statement from another batch of statements is applied first and it conflicts in some way, or if there is some data-related problem like a `NULL` value in a column to which `NOT NULL` would be added). If a statement fails, all subsequent statements in the batch are automatically cancelled. Each batch of statements is assigned a name which can be used with the Operations API to monitor progress. See the operation_id field for more details.","ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlRequest","doc":"*   `operationId` (*type:* `String.t`, *default:* `nil`) - If empty, the new update request is assigned an automatically-generated operation ID. Otherwise, `operation_id` is used to construct the name of the resulting Operation. Specifying an explicit operation ID simplifies determining whether the statements were executed in the event that the UpdateDatabaseDdl call is replayed, or the return value is otherwise lost: the database and `operation_id` fields can be combined to form the name of the resulting longrunning.Operation: `/operations/`. `operation_id` should be unique within the database, and must be a valid identifier: `a-z*`. Note that automatically-generated operation IDs always begin with an underscore. If the named operation already exists, UpdateDatabaseDdl returns `ALREADY_EXISTS`.\n*   `protoDescriptors` (*type:* `String.t`, *default:* `nil`) - Optional. Proto descriptors used by CREATE/ALTER PROTO BUNDLE statements. Contains a protobuf-serialized [google.protobuf.FileDescriptorSet](https://github.com/protocolbuffers/protobuf/blob/main/src/google/protobuf/descriptor.proto). To generate it, [install](https://grpc.io/docs/protoc-installation/) and run `protoc` with --include_imports and --descriptor_set_out. For example, to generate for moon/shot/app.proto, run ``` $protoc --proto_path=/app_path --proto_path=/lib_path \\ --include_imports \\ --descriptor_set_out=descriptors.data \\ moon/shot/app.proto ``` For more details, see protobuffer [self description](https://developers.google.com/protocol-buffers/docs/techniques#self-description).\n*   `statements` (*type:* `list(String.t)`, *default:* `nil`) - Required. DDL statements to be applied to the database.","ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseDdlRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseMetadata","doc":"Metadata type for the operation returned by UpdateDatabase.","ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.UpdateDatabaseMetadata","doc":"*   `cancelTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which this operation was cancelled. If set, this operation is in the process of undoing itself (which is best-effort).\n*   `progress` (*type:* `GoogleApi.Spanner.V1.Model.OperationProgress.t`, *default:* `nil`) - The progress of the UpdateDatabase operation.\n*   `request` (*type:* `GoogleApi.Spanner.V1.Model.UpdateDatabaseRequest.t`, *default:* `nil`) - The request for UpdateDatabase.","ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseMetadata.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseRequest","doc":"The request for UpdateDatabase.","ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.UpdateDatabaseRequest","doc":"*   `database` (*type:* `GoogleApi.Spanner.V1.Model.Database.t`, *default:* `nil`) - Required. The database to update. The `name` field of the database is of the form `projects//instances//databases/`.\n*   `updateMask` (*type:* `String.t`, *default:* `nil`) - Required. The list of fields to update. Currently, only `enable_drop_protection` field can be updated.","ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.UpdateDatabaseRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.UpdateDatabaseRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceConfigMetadata","doc":"Metadata type for the operation returned by UpdateInstanceConfig.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceConfigMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.UpdateInstanceConfigMetadata","doc":"*   `cancelTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which this operation was cancelled.\n*   `instanceConfig` (*type:* `GoogleApi.Spanner.V1.Model.InstanceConfig.t`, *default:* `nil`) - The desired instance configuration after updating.\n*   `progress` (*type:* `GoogleApi.Spanner.V1.Model.InstanceOperationProgress.t`, *default:* `nil`) - The progress of the UpdateInstanceConfig operation.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceConfigMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceConfigMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceConfigMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceConfigMetadata.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceConfigMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceConfigRequest","doc":"The request for UpdateInstanceConfigRequest.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceConfigRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.UpdateInstanceConfigRequest","doc":"*   `instanceConfig` (*type:* `GoogleApi.Spanner.V1.Model.InstanceConfig.t`, *default:* `nil`) - Required. The user instance configuration to update, which must always include the instance configuration name. Otherwise, only fields mentioned in update_mask need be included. To prevent conflicts of concurrent updates, etag can be used.\n*   `updateMask` (*type:* `String.t`, *default:* `nil`) - Required. A mask specifying which fields in InstanceConfig should be updated. The field mask must always be specified; this prevents any future fields in InstanceConfig from being erased accidentally by clients that do not know about them. Only display_name and labels can be updated.\n*   `validateOnly` (*type:* `boolean()`, *default:* `nil`) - An option to validate, but not actually execute, a request, and provide the same response.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceConfigRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceConfigRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceConfigRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceConfigRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceConfigRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceMetadata","doc":"Metadata type for the operation returned by UpdateInstance.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.UpdateInstanceMetadata","doc":"*   `cancelTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which this operation was cancelled. If set, this operation is in the process of undoing itself (which is guaranteed to succeed) and cannot be cancelled again.\n*   `endTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which this operation failed or was completed successfully.\n*   `expectedFulfillmentPeriod` (*type:* `String.t`, *default:* `nil`) - The expected fulfillment period of this update operation.\n*   `instance` (*type:* `GoogleApi.Spanner.V1.Model.Instance.t`, *default:* `nil`) - The desired end state of the update.\n*   `startTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which UpdateInstance request was received.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceMetadata.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.UpdateInstancePartitionMetadata","doc":"Metadata type for the operation returned by UpdateInstancePartition.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstancePartitionMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.UpdateInstancePartitionMetadata","doc":"*   `cancelTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which this operation was cancelled. If set, this operation is in the process of undoing itself (which is guaranteed to succeed) and cannot be cancelled again.\n*   `endTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which this operation failed or was completed successfully.\n*   `instancePartition` (*type:* `GoogleApi.Spanner.V1.Model.InstancePartition.t`, *default:* `nil`) - The desired end state of the update.\n*   `startTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which UpdateInstancePartition request was received.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstancePartitionMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.UpdateInstancePartitionMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstancePartitionMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.UpdateInstancePartitionMetadata.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.UpdateInstancePartitionMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.UpdateInstancePartitionRequest","doc":"The request for UpdateInstancePartition.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstancePartitionRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.UpdateInstancePartitionRequest","doc":"*   `fieldMask` (*type:* `String.t`, *default:* `nil`) - Required. A mask specifying which fields in InstancePartition should be updated. The field mask must always be specified; this prevents any future fields in InstancePartition from being erased accidentally by clients that do not know about them.\n*   `instancePartition` (*type:* `GoogleApi.Spanner.V1.Model.InstancePartition.t`, *default:* `nil`) - Required. The instance partition to update, which must always include the instance partition name. Otherwise, only fields mentioned in field_mask need be included.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstancePartitionRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.UpdateInstancePartitionRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstancePartitionRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.UpdateInstancePartitionRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.UpdateInstancePartitionRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceRequest","doc":"The request for UpdateInstance.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.UpdateInstanceRequest","doc":"*   `fieldMask` (*type:* `String.t`, *default:* `nil`) - Required. A mask specifying which fields in Instance should be updated. The field mask must always be specified; this prevents any future fields in Instance from being erased accidentally by clients that do not know about them.\n*   `instance` (*type:* `GoogleApi.Spanner.V1.Model.Instance.t`, *default:* `nil`) - Required. The instance to update, which must always include the instance name. Otherwise, only fields mentioned in field_mask need be included.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.UpdateInstanceRequest.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.UpdateInstanceRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.VisualizationData","doc":"","ref":"GoogleApi.Spanner.V1.Model.VisualizationData.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.VisualizationData","doc":"*   `dataSourceEndToken` (*type:* `String.t`, *default:* `nil`) - The token signifying the end of a data_source.\n*   `dataSourceSeparatorToken` (*type:* `String.t`, *default:* `nil`) - The token delimiting a datasource name from the rest of a key in a data_source.\n*   `diagnosticMessages` (*type:* `list(GoogleApi.Spanner.V1.Model.DiagnosticMessage.t)`, *default:* `nil`) - The list of messages (info, alerts, ...)\n*   `endKeyStrings` (*type:* `list(String.t)`, *default:* `nil`) - We discretize the entire keyspace into buckets. Assuming each bucket has an inclusive keyrange and covers keys from k(i) ... k(n). In this case k(n) would be an end key for a given range. end_key_string is the collection of all such end keys\n*   `hasPii` (*type:* `boolean()`, *default:* `nil`) - Whether this scan contains PII.\n*   `indexedKeys` (*type:* `list(String.t)`, *default:* `nil`) - Keys of key ranges that contribute significantly to a given metric Can be thought of as heavy hitters.\n*   `keySeparator` (*type:* `String.t`, *default:* `nil`) - The token delimiting the key prefixes.\n*   `keyUnit` (*type:* `String.t`, *default:* `nil`) - The unit for the key: e.g. 'key' or 'chunk'.\n*   `metrics` (*type:* `list(GoogleApi.Spanner.V1.Model.Metric.t)`, *default:* `nil`) - The list of data objects for each metric.\n*   `prefixNodes` (*type:* `list(GoogleApi.Spanner.V1.Model.PrefixNode.t)`, *default:* `nil`) - The list of extracted key prefix nodes used in the key prefix hierarchy.","ref":"GoogleApi.Spanner.V1.Model.VisualizationData.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.VisualizationData.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.VisualizationData.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.VisualizationData.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.VisualizationData.html#t:t/0"},{"type":"module","title":"GoogleApi.Spanner.V1.Model.Write","doc":"Arguments to insert, update, insert_or_update, and replace operations.","ref":"GoogleApi.Spanner.V1.Model.Write.html"},{"type":"module","title":"Attributes - GoogleApi.Spanner.V1.Model.Write","doc":"*   `columns` (*type:* `list(String.t)`, *default:* `nil`) - The names of the columns in table to be written. The list of columns must contain enough columns to allow Cloud Spanner to derive values for all primary key columns in the row(s) to be modified.\n*   `table` (*type:* `String.t`, *default:* `nil`) - Required. The table whose rows will be written.\n*   `values` (*type:* `list(list(any()))`, *default:* `nil`) - The values to be written. `values` can contain more than one list of values. If it does, then multiple rows are written, one for each entry in `values`. Each list in `values` must have exactly as many entries as there are entries in columns above. Sending multiple lists is equivalent to sending multiple `Mutation`s, each containing one `values` entry and repeating table and columns. Individual values in each list are encoded as described here.","ref":"GoogleApi.Spanner.V1.Model.Write.html#module-attributes"},{"type":"function","title":"GoogleApi.Spanner.V1.Model.Write.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Spanner.V1.Model.Write.html#decode/2"},{"type":"type","title":"GoogleApi.Spanner.V1.Model.Write.t/0","doc":"","ref":"GoogleApi.Spanner.V1.Model.Write.html#t:t/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}